//
// HPB bot - botman's High Ping Bastard bot
//
// (http://planethalflife.com/botman/)
//
// bot_combat.cpp
//

#include "general_header.h"
 
#define NUM_TAGS 22

char *tag1[NUM_TAGS]={
"-=","-[","-]","-}","-{","<[","<]","[-","]-","{-","}-","[[","[","{","]","}","<",">","-","|","=","+"};
char *tag2[NUM_TAGS]={
"=-","]-","[-","{-","}-","]>","[>","-]","-[","-}","-{","]]","]","}","[","{",">","<","-","|","=","+"};

CChatClass *pChatClass = NULL;

int bot_chat_count;
int bot_taunt_count;
int bot_whine_count;

bot_chat_t bot_chat[MAX_BOT_CHAT];
bot_chat_t bot_taunt[MAX_BOT_CHAT];
bot_chat_t bot_whine[MAX_BOT_CHAT];

int recent_bot_chat[5];
int recent_bot_taunt[5];
int recent_bot_whine[5];

int player_count;
char player_names[32][33];  // 32 players max, 32 chars + null

extern int bot_chat_tag_percent;
extern int bot_chat_drop_percent;
extern int bot_chat_swap_percent;
extern int bot_chat_lower_percent;

#ifdef classstuff
void CBotManager::LoadChatTexts()
{
	FILE *bfp;
	char filename[256];
	char buffer[256];
	char *stat;
	int section = -1;
	int i, length;

	bot_chat_count = 0;
	bot_taunt_count = 0;
	bot_whine_count = 0;

	for (i=0; i < 5; i++)
	{
		recent_bot_chat[i] = -1;
		recent_bot_taunt[i] = -1;
		recent_bot_whine[i] = -1;
    }

	UTIL_BuildFileName(filename, "esf_bot_chat.txt", NULL);

	(*g_engfuncs.pfnServerPrint) ("Reading bot_chat file... ");

	bfp = fopen(filename, "r");

	if (bfp == NULL)
	{
		(*g_engfuncs.pfnServerPrint) ("file not found\n");
		return;
	}

	while (bfp != NULL)
	{
		stat = fgets(buffer, 80, bfp);

        if (stat == NULL)
		{
			fclose(bfp);
			bfp = NULL;
			continue;
		}

		buffer[80] = 0;  // truncate lines longer than 80 characters

		length = strlen(buffer);

		if (buffer[length-1] == '\n')
		{
			buffer[length-1] = 0;  // remove '\n'
			length--;
		}

		if (strcmp(buffer, "[bot_chat]") == 0)
		{
			section = 0;
			continue;
		}

		if (strcmp(buffer, "[bot_taunt]") == 0)
		{
			section = 1;
			continue;
		}

        if (strcmp(buffer, "[bot_whine]") == 0)
		{
			section = 2;
			continue;
		}

		if ((length > 0) && (section == 0) &&  // bot chat
			(bot_chat_count < MAX_BOT_CHAT))
		{
			if (buffer[0] == '!')
			{
				strcpy(bot_chat[bot_chat_count].text, &buffer[1]);
				bot_chat[bot_chat_count].can_modify = FALSE;
			}
			else
			{
				strcpy(bot_chat[bot_chat_count].text, buffer);
				bot_chat[bot_chat_count].can_modify = TRUE;
			}

			bot_chat_count++;
		}

        if ((length > 0) && (section == 1) &&  // bot taunt
			(bot_taunt_count < MAX_BOT_CHAT))
		{
			if (buffer[0] == '!')
			{
				strcpy(bot_taunt[bot_taunt_count].text, &buffer[1]);
				bot_taunt[bot_taunt_count].can_modify = FALSE;
			}
			else
			{
				strcpy(bot_taunt[bot_taunt_count].text, buffer);
				bot_taunt[bot_taunt_count].can_modify = TRUE;
			}

			bot_taunt_count++;
		}

        if ((length > 0) && (section == 2) &&  // bot whine
			(bot_whine_count < MAX_BOT_CHAT))
		{
			if (buffer[0] == '!')
			{
				strcpy(bot_whine[bot_whine_count].text, &buffer[1]);
				bot_whine[bot_whine_count].can_modify = FALSE;
			}
			else
			{
				strcpy(bot_whine[bot_whine_count].text, buffer);
				bot_whine[bot_whine_count].can_modify = TRUE;
			}

			bot_whine_count++;
		}
	}
    (*g_engfuncs.pfnServerPrint) ("done\n");
}
#endif

void LoadBotChat(void)
{
   FILE *bfp;
   char filename[256];
   char buffer[256];
   char *stat;
   int section = -1;
   int i, length;

   bot_chat_count = 0;
   bot_taunt_count = 0;
   bot_whine_count = 0;

   for (i=0; i < 5; i++)
   {
      recent_bot_chat[i] = -1;
      recent_bot_taunt[i] = -1;
      recent_bot_whine[i] = -1;
   }

   UTIL_BuildFileName(filename, "esf_bot_chat.txt", NULL);

   (*g_engfuncs.pfnServerPrint) ("Reading bot_chat file... ");

   bfp = fopen(filename, "r");

   if (bfp == NULL)
   {
	  (*g_engfuncs.pfnServerPrint) ("file not found\n");
	  return;
   }

   while (bfp != NULL)
   {
      stat = fgets(buffer, 80, bfp);

      if (stat == NULL)
      {
         fclose(bfp);
         bfp = NULL;
         continue;
      }

      buffer[80] = 0;  // truncate lines longer than 80 characters

      length = strlen(buffer);

      if (buffer[length-1] == '\n')
      {
         buffer[length-1] = 0;  // remove '\n'
         length--;
      }

      if (strcmp(buffer, "[bot_chat]") == 0)
      {
         section = 0;
         continue;
      }

      if (strcmp(buffer, "[bot_taunt]") == 0)
      {
         section = 1;
         continue;
      }

      if (strcmp(buffer, "[bot_whine]") == 0)
      {
         section = 2;
         continue;
      }

      if ((length > 0) && (section == 0) &&  // bot chat
          (bot_chat_count < MAX_BOT_CHAT))
      {
         if (buffer[0] == '!')
         {
            strcpy(bot_chat[bot_chat_count].text, &buffer[1]);
            bot_chat[bot_chat_count].can_modify = FALSE;
         }
         else
         {
            strcpy(bot_chat[bot_chat_count].text, buffer);
            bot_chat[bot_chat_count].can_modify = TRUE;
         }

         bot_chat_count++;
      }

      if ((length > 0) && (section == 1) &&  // bot taunt
          (bot_taunt_count < MAX_BOT_CHAT))
      {
         if (buffer[0] == '!')
         {
            strcpy(bot_taunt[bot_taunt_count].text, &buffer[1]);
            bot_taunt[bot_taunt_count].can_modify = FALSE;
         }
         else
         {
            strcpy(bot_taunt[bot_taunt_count].text, buffer);
            bot_taunt[bot_taunt_count].can_modify = TRUE;
         }

         bot_taunt_count++;
      }

      if ((length > 0) && (section == 2) &&  // bot whine
          (bot_whine_count < MAX_BOT_CHAT))
      {
         if (buffer[0] == '!')
         {
            strcpy(bot_whine[bot_whine_count].text, &buffer[1]);
            bot_whine[bot_whine_count].can_modify = FALSE;
         }
         else
         {
            strcpy(bot_whine[bot_whine_count].text, buffer);
            bot_whine[bot_whine_count].can_modify = TRUE;
         }

         bot_whine_count++;
      }
   }
   (*g_engfuncs.pfnServerPrint) ("done\n");
}


void BotTrimBlanks(char *in_string, char *out_string)
{
   int i, pos;
   char *dest;

   pos=0;
   while ((pos < 80) && (in_string[pos] == ' '))  // skip leading blanks
      pos++;

   dest=&out_string[0];

   while ((pos < 80) && (in_string[pos]))
   {
      *dest++ = in_string[pos];
      pos++;
   }
   *dest = 0;  // store the null

   i = strlen(out_string) - 1;
   while ((i > 0) && (out_string[i] == ' '))  // remove trailing blanks
   {
      out_string[i] = 0;
      i--;
   }
}


int BotChatTrimTag(char *original_name, char *out_name)
{
   int i;
   char *pos1, *pos2, *src, *dest;
   char in_name[80];
   int result = 0;

   strncpy(in_name, original_name, 31);
   in_name[32] = 0;

   for (i=0; i < NUM_TAGS; i++)
   {
      pos1=strstr(in_name, tag1[i]);
      if (pos1)
         pos2=strstr(pos1+strlen(tag1[i]), tag2[i]);
      else
         pos2 = NULL;

      if (pos1 && pos2 && pos1 < pos2)
      {
         src = pos2+strlen(tag2[i]);
         dest = pos1;
         while (*src)
            *dest++ = *src++;
         *dest = *src;  // copy the null;

         result = 1;
      }
   }

   strcpy(out_name, in_name);

   BotTrimBlanks(out_name, in_name);

   if (strlen(in_name) == 0)  // is name just a tag?
   {
      strncpy(in_name, original_name, 31);
      in_name[32] = 0;

      // strip just the tag part...
      for (i=0; i < NUM_TAGS; i++)
      {
         pos1=strstr(in_name, tag1[i]);
         if (pos1)
            pos2=strstr(pos1+strlen(tag1[i]), tag2[i]);
         else
            pos2 = NULL;

         if (pos1 && pos2 && pos1 < pos2)
         {
            src = pos1 + strlen(tag1[i]);
            dest = pos1;
            while (*src)
               *dest++ = *src++;
            *dest = *src;  // copy the null;

            src = pos2 - strlen(tag2[i]);
            *src = 0; // null out the rest of the string
         }
      }
   }

   BotTrimBlanks(in_name, out_name);

   out_name[31] = 0;

   return (result);
}


void BotDropCharacter(char *in_string, char *out_string)
{
   int len, pos;
   int count = 0;
   char *src, *dest;
   bool is_bad;

   strcpy(out_string, in_string);

   len = strlen(out_string);
   pos = RANDOM_LONG(1, len-1);  // don't drop position zero

   is_bad = !isalpha(out_string[pos]) || (out_string[pos-1] == '%');

   while ((is_bad) && (count < 20))
   {
      pos = RANDOM_LONG(1, len-1);
      is_bad = !isalpha(out_string[pos]) || (out_string[pos-1] == '%');
      count++;
   }

   if (count < 20)
   {
      src = &out_string[pos+1];
      dest = &out_string[pos];
      while (*src)
         *dest++ = *src++;
      *dest = *src;  // copy the null;
   }
}


void BotSwapCharacter(char *in_string, char *out_string)
{
   int len, pos;
   int count = 0;
   char temp;
   bool is_bad;

   strcpy(out_string, in_string);

   len = strlen(out_string);
   pos = RANDOM_LONG(1, len-2);  // don't swap position zero

   is_bad = !isalpha(out_string[pos]) || !isalpha(out_string[pos+1]) ||
            (out_string[pos-1] == '%');

   while ((is_bad) && (count < 20))
   {
      pos = RANDOM_LONG(1, len-2);
      is_bad = !isalpha(out_string[pos]) || !isalpha(out_string[pos+1]) ||
               (out_string[pos-1] == '%');
      count++;
   }

   if (count < 20)
   {
      temp = out_string[pos];
      out_string[pos] = out_string[pos+1];
      out_string[pos+1] = temp;
   }
}


void BotChatName(char *original_name, char *out_name)
{
   int pos;

   if (RANDOM_LONG(1, 100) <= bot_chat_tag_percent)
   {
      char temp_name[80];

      strncpy(temp_name, original_name, 31);
      temp_name[31] = 0;

      while (BotChatTrimTag(temp_name, out_name))
      {
         strcpy(temp_name, out_name);
      }
   }
   else
   {
      strncpy(out_name, original_name, 31);
      out_name[31] = 0;
   }

   if (RANDOM_LONG(1, 100) <= bot_chat_lower_percent)
   {
      pos=0;
      while ((pos < 80) && (out_name[pos]))
      {
         out_name[pos] = tolower(out_name[pos]);
         pos++;
      }
   }
}


void BotChatText(char *in_text, char *out_text)
{
   int pos;
   char temp_text[81];
   int count;

   strncpy(temp_text, in_text, 79);
   temp_text[80] = 0;

   if (RANDOM_LONG(1, 100) <= bot_chat_drop_percent)
   {
      count = RANDOM_LONG(1, 3);

      while (count)
      {
         BotDropCharacter(temp_text, out_text);
         strcpy(temp_text, out_text);
         count--;
      }
   }

   if (RANDOM_LONG(1, 100) <= bot_chat_swap_percent)
   {
      count = RANDOM_LONG(1, 2);

      while (count)
      {
         BotSwapCharacter(temp_text, out_text);
         strcpy(temp_text, out_text);
         count--;
      }
   }

   if (RANDOM_LONG(1, 100) <= bot_chat_lower_percent)
   {
      pos=0;
      while (temp_text[pos])
      {
         temp_text[pos] = tolower(temp_text[pos]);
         pos++;
      }
   }

   strcpy(out_text, temp_text);
}


void BotChatGetPlayers(void)
{
   int index;
   const char *pName;

   player_count = 0;

   for (index = 1; index <= gpGlobals->maxClients; index++)
   {
      edict_t *pPlayer = INDEXENT(index);

      // skip invalid players
      if ((pPlayer) && (!pPlayer->free))
      {
         if (pPlayer->v.netname)
         {
            pName = STRING(pPlayer->v.netname);

            if (*pName != 0)
            {
               strncpy(player_names[player_count], pName, 32);

               player_count++;
            }
         }
      }
   }
}


void BotChatFillInName(char *bot_say_msg, char *chat_text,
                       char *chat_name, const char *bot_name)
{
   int chat_index, say_index;
   char *name_pos, *rand_pos;
   char random_name[64];
   int index, name_offset = 0, rand_offset = 0;  //EEKHOORN GAVE THESE A VALUE
   bool is_bad;

   chat_index = 0;
   say_index = 0;
   bot_say_msg[0] = 0;

   name_pos = strstr(&chat_text[chat_index], "%n");
   rand_pos = strstr(&chat_text[chat_index], "%r");

   while ((name_pos != NULL) || (rand_pos != NULL))
   {
      if (name_pos != NULL)
         name_offset = name_pos - chat_text;
      if (rand_pos != NULL)
         rand_offset = rand_pos - chat_text;

      if ((rand_pos == NULL) ||
          ((name_offset < rand_offset) && (name_pos != NULL)))
      {
         while (&chat_text[chat_index] < name_pos)
            bot_say_msg[say_index++] = chat_text[chat_index++];

         bot_say_msg[say_index] = 0;  // add null terminator

         chat_index += 2;  // skip the "%n"

         strcat(bot_say_msg, chat_name);
         say_index += strlen(chat_name);

         bot_say_msg[say_index] = 0;
      }
      else  // use random player name...
      {
         int count = 0;

         BotChatGetPlayers();

         // pick a name at random from the list of players...

         index = RANDOM_LONG(0, player_count-1);

         is_bad = (strcmp(player_names[index], chat_name) == 0) ||
                  (strcmp(player_names[index], bot_name) == 0);

         while ((is_bad) && (count < 20))
         {
            index = RANDOM_LONG(0, player_count-1);

            is_bad = (strcmp(player_names[index], chat_name) == 0) ||
                     (strcmp(player_names[index], bot_name) == 0);

            count++;
         }

         BotChatName(player_names[index], random_name);

         while (&chat_text[chat_index] < rand_pos)
            bot_say_msg[say_index++] = chat_text[chat_index++];

         bot_say_msg[say_index] = 0;  // add null terminator

         chat_index += 2;  // skip the "%r"

         strcat(bot_say_msg, random_name);
         say_index += strlen(random_name);

         bot_say_msg[say_index] = 0;
      }

      name_pos = strstr(&chat_text[chat_index], "%n");
      rand_pos = strstr(&chat_text[chat_index], "%r");
   }

   // copy the rest of the chat_text into the bot_say_msg...

   while (chat_text[chat_index])
      bot_say_msg[say_index++] = chat_text[chat_index++];

   bot_say_msg[say_index] = 0;  // add null terminator
}


// ---------------------------------------------


// ===================================================
// Code of CChatClass::CChatSentence Start
// ===================================================

CChatClass::CChatSentence::CChatSentence(const char *szSentence, bool CM, byte UV, byte RCount,
										 byte TCount) : 
										 szText(new char[strlen(szSentence) + 1]), CanModify(CM),
										 UseValue(UV), RandomNameCount(RCount),
										 TargetNameCount(TCount)
{
	strcpy(szText, szSentence);
	szSenderName[0] = 0;
}

CChatClass::CChatSentence::~CChatSentence()
{
	if (szText)
	{
		delete[] szText;
		szText = NULL;
	}
}

// ===================================================
// Code of CChatClass::CChatSentence End
// ===================================================

// ===================================================
// Code of CChatClass::CChatNode Start
// ===================================================

CChatClass::CChatNode::CChatNode(const char *KW, EKeyType KT) : 
								pChatSentences(new TLinkedList<CChatSentence*>),
								szKeyStr(NULL), KeyType(KT), TotalValue(0),
								SentenceCount(0)
{
	if (KT == KEY_TYPE_KEYTOKEN)
	{
		szKeyStr = new char[2];
		szKeyStr[0] = KW[0];
		szKeyStr[1] = 0;
	}
	else
	{
		szKeyStr = new char[strlen(KW) + 1];
		strcpy(szKeyStr, KW);
	}
}

CChatClass::CChatNode::~CChatNode()
{
	if ((szKeyStr) && (*szKeyStr))
	{
		delete[] szKeyStr;
		szKeyStr = NULL;
	}

	if (pChatSentences)
	{
		while (pChatSentences->Empty() == false)
			delete pChatSentences->Pop();

		delete pChatSentences;
		pChatSentences = NULL;
	}
}

void CChatClass::CChatNode::AddSentence(const char *szSentence)
{
	short StartPos = 0;
	byte b;
	byte RCount = 0, TCount = 0;
	int UV = 50;
	bool CanModify = true;

	short StrLength = strlen(szSentence);

	while ((StartPos < StrLength) && (StartPos < MAX_CHAT_SENTENCE_LENGTH) && 
		   (szSentence[StartPos]))
	{
		if ((szSentence[StartPos] == ' ') || (szSentence[StartPos] == '\t'))
			StartPos++;
		else if (szSentence[StartPos] == '!')
		{
			CanModify = false;
			StartPos++;
		}
		else if (strnicmp(&szSentence[StartPos], "UV:", 3) == 0)
		{
			StartPos += 3; // Skip the 'UV:' part...

			// Get the Use Value...
			int pos = StartPos;

			while ((pos < StrLength) && (pos < MAX_CHAT_SENTENCE_LENGTH) && (szSentence[pos]) &&
				   ((szSentence[pos] == ' ') || (szSentence[pos] == '\t')))
				   pos++;
		
			if ((&szSentence[pos]) && (szSentence[pos]))
			{
				char szTemp[MAX_CHAT_SENTENCE_LENGTH] = "";
				strcpy(szTemp, szSentence);
				char *szUserVal = strtok(&szTemp[pos], " ");

				if ((szUserVal) && (*szUserVal))
				{
					UV = atoi(szUserVal);
					StartPos = pos + strlen(szUserVal) + 1;
				}
			}
		}
		else
		{
			break;
		}
	}
	
	StrLength = strlen(szSentence);
	for (b=0;b<(StrLength-1);b++)
	{
		if (szSentence[b] == '%')
		{
			if (szSentence[b + 1] == 'r')
				RCount++;
			else if (szSentence[b + 1] == 'n')
				TCount++;
		}
	}

	if (UV > 100)
		UV = 100;
	else if (UV < 0)
		UV = 0;

	pChatSentences->AddNode(new CChatSentence(&szSentence[StartPos], CanModify, UV, RCount,
											  TCount));
	SentenceCount++;
	TotalValue += UV;

/*
	if (CanModify == false)
		pChatSentences->AddNode(new CChatSentence(&szSentence[1], false, 50));
	else
		pChatSentences->AddNode(new CChatSentence(szSentence, true, 50));*/
}

int CChatClass::CChatNode::GetRegularVal()
{
	if (TotalValue && SentenceCount)
		return (TotalValue / SentenceCount);
	else
		return 0;
}

// ===================================================
// Code of CChatClass::CChatNode End
// ===================================================

// ===================================================
// Code of CChatClass Start
// ===================================================

CChatClass::CChatClass() : pWelcomeSentences(new CChatNode),
						   pNormalChatNodeList(new TLinkedList<CChatNode*>),
						   pTauntChatNodeList(new TLinkedList<CChatNode*>),
						   pWhineChatNodeList(new TLinkedList<CChatNode*>)
{
	memset(OldChatTexts, 0, sizeof(OldChatTexts));

	for (byte i=0;i<MAX_RECENT_USED_TEXTS;i++)
	{
		pRecentNormalChatTexts[i] = NULL;
		pRecentTauntChatTexts[i] = NULL;
		pRecentWhineChatTexts[i] = NULL;
	}
}

CChatClass::~CChatClass()
{
	if (pWelcomeSentences)
	{
		delete pWelcomeSentences;
		pWelcomeSentences = NULL;
	}

	if (pNormalChatNodeList)
	{
		while (pNormalChatNodeList->Empty() == false)
			delete pNormalChatNodeList->Pop();

		delete pNormalChatNodeList;
		pNormalChatNodeList = NULL;
	}

	if (pTauntChatNodeList)
	{
		while (pTauntChatNodeList->Empty() == false)
			delete pTauntChatNodeList->Pop();

		delete pTauntChatNodeList;
		pTauntChatNodeList = NULL;
	}

	if (pWhineChatNodeList)
	{
		while (pWhineChatNodeList->Empty() == false)
			delete pWhineChatNodeList->Pop();

		delete pWhineChatNodeList;
		pWhineChatNodeList = NULL;
	}
}

// debug function(s)
/*
void PrintChatSentenceNode(CChatClass::CChatSentence *pNode)
{
	clog << pNode->szText << "\n";
}

void PrintChatNode(CChatClass::CChatNode *pNode)
{
	clog << "\nKey word:\n";
	clog << pNode->szKeyWord << "\n";

	clog << "\nSentences:\n";
	pNode->pChatSentences->ForEach(PrintChatSentenceNode);
}
*/
void CChatClass::ReadChatFile()
{
	FILE *pChatFile;
	char FileName[256];
	char KeyWords[MAX_CHAT_KEYWORDS][64];
	char KeyTokens[MAX_CHAT_KEYTOKENS] = "";
	bool ActiveBlock = false;
	EChatCatagory Section = NONE_CHAT;
	EKeyType KeyType = KEY_TYPE_NONE;
	int i;

	byte WelcomeChatCount = 0, NormalChatCount = 0, WhineCount = 0, TauntCount = 0;

	for (i=0; i < 5; i++)
	{
		pRecentNormalChatTexts[i] = NULL;
		pRecentWhineChatTexts[i] = NULL;
		pRecentTauntChatTexts[i] = NULL;
    }

	// Reset all key words
	for (i=0; i < MAX_CHAT_KEYWORDS; i++)
	{
		KeyWords[i][0] = 0;
    }

	// Reset all key tokens
	for (i=0; i < MAX_CHAT_KEYTOKENS; i++)
	{
		KeyTokens[i] = 0;
	}

	UTIL_BuildFileName(FileName, "esf_bot_chat.txt", NULL);

	(*g_engfuncs.pfnServerPrint) ("Reading bot_chat file... ");

	pChatFile = fopen(FileName, "r");

	if (pChatFile == NULL)
	{
		(*g_engfuncs.pfnServerPrint) ("file not found\n");
		return;
	}

	int ch;
	char cmd_line[256];
	int cmd_index;
	static char server_cmd[256];
	char cmd[256], *arg1, *arg2, *arg3, *arg4, *arg5, *arg6;
	char szSentence[MAX_CHAT_SENTENCE_LENGTH] = "";

	while (pChatFile != NULL)
	{
		cmd_index = 0;
		cmd_line[cmd_index] = 0;

		ch = fgetc(pChatFile);

		// skip any leading blanks
		while ((ch == ' ') || (ch == '\t'))
			ch = fgetc(pChatFile);

		while ((ch != EOF) && (ch != '\r') && (ch != '\n'))
   		{
			if (ch == '\t')  // convert tabs to spaces
				ch = ' ';

			cmd_line[cmd_index] = ch;

			ch = fgetc(pChatFile);

			// skip multiple spaces in input file
			while ((cmd_line[cmd_index] == ' ') && (ch == ' '))
				ch = fgetc(pChatFile);

		    cmd_index++;
   		}

		if (ch == '\r')  // is it a carriage return?
		{
		      ch = fgetc(pChatFile);  // skip the linefeed
   		}

		// if reached end of file, then close it
		if (ch == EOF)
   		{
			fclose(pChatFile);
			pChatFile = NULL;
		}

		cmd_line[cmd_index] = 0;  // terminate the command line

		// copy the command line to a server command buffer...
		strcpy(server_cmd, cmd_line);
		strcat(server_cmd, "\n");
		strcpy(cmd, cmd_line);

		cmd_index = 0;
		arg1 = arg2 = arg3 = arg4 = arg5 = arg6 = NULL;

		arg1 = strtok(cmd_line, " ,");
		arg1 = strtok(NULL, " ,"); // Do this twice so we skip the command
		arg2 = strtok(NULL, " ,");
		arg3 = strtok(NULL, " ,");
		arg4 = strtok(NULL, " ,");
		arg5 = strtok(NULL, " ,");
		arg6 = strtok(NULL, " ,");
/*
		// skip to blank or end of string...
		while ((cmd_line[cmd_index] != ' ') && (cmd_line[cmd_index] != 0) && 
			   (cmd_line[cmd_index] != ','))
			   cmd_index++;

		if ((cmd_line[cmd_index] == ' ') || (cmd_line[cmd_index] == ','))
		{
			cmd_line[cmd_index++] = 0;
			arg1 = &cmd_line[cmd_index];

		    // skip to blank or end of string...
		    while ((cmd_line[cmd_index] != ' ') && (cmd_line[cmd_index] != 0) && 
				   (cmd_line[cmd_index] != ','))
				   cmd_index++;

		    if ((cmd_line[cmd_index] == ' ') || (cmd_line[cmd_index] == ','))
			{
				cmd_line[cmd_index++] = 0;
		        arg2 = &cmd_line[cmd_index];

		        // skip to blank or end of string...
		        while ((cmd_line[cmd_index] != ' ') && (cmd_line[cmd_index] != 0) && 
			           (cmd_line[cmd_index] != ','))
					   cmd_index++;

		        if ((cmd_line[cmd_index] == ' ') || (cmd_line[cmd_index] == ','))
		        {
					cmd_line[cmd_index++] = 0;
		            arg3 = &cmd_line[cmd_index];

            		// skip to blank or end of string...
		            while ((cmd_line[cmd_index] != ' ') && (cmd_line[cmd_index] != 0) && 
			               (cmd_line[cmd_index] != ','))
						   cmd_index++;

		            if ((cmd_line[cmd_index] == ' ') || (cmd_line[cmd_index] == ','))
            		{
						cmd_line[cmd_index++] = 0;
		                arg4 = &cmd_line[cmd_index];

				        // skip to blank or end of string...
						while ((cmd_line[cmd_index] != ' ') && (cmd_line[cmd_index] != 0) && 
							   (cmd_line[cmd_index] != ','))
							   cmd_index++;

						if ((cmd_line[cmd_index] == ' ') || (cmd_line[cmd_index] == ','))
						{
							cmd_line[cmd_index++] = 0;
							arg5 = &cmd_line[cmd_index];

            				// skip to blank or end of string...
							while ((cmd_line[cmd_index] != ' ') && (cmd_line[cmd_index] != 0) && 
								   (cmd_line[cmd_index] != ','))
								   cmd_index++;

							if ((cmd_line[cmd_index] == ' ') || (cmd_line[cmd_index] == ','))
							{
								cmd_line[cmd_index++] = 0;
								arg6 = &cmd_line[cmd_index];
							}
						}
            		}
				}
			}
		}
*/
		if ((cmd[0] == '#') || (cmd[0] == 0))
		    continue;  // skip if comment or blank line

        if (strcmp(cmd, "[bot_welcome]") == 0)
		{
			Section = WELCOME_CHAT;
			continue;
		}

		if (strcmp(cmd, "[bot_chat]") == 0)
		{
			Section = NORMAL_CHAT;
			continue;
		}

		if (strcmp(cmd, "[bot_taunt]") == 0)
		{
			Section = TAUNT_CHAT;
			continue;
		}

        if (strcmp(cmd, "[bot_whine]") == 0)
		{
			Section = WHINE_CHAT;
			continue;
		}

		// skip if no section found yet
		if (Section == NONE_CHAT)
		{
			continue;
		}

		if (cmd[0] == '{')
		{
			ActiveBlock = true;
			continue;
		}

		if (cmd[0] == '}')
		{
			ActiveBlock = false;
			continue;
		}

		if ((strnicmp(cmd, "keyword", 7) == 0) || (strnicmp(cmd, "keyword2", 8) == 0))
		{
			// Reset all key words
			for (i=0; i < MAX_CHAT_KEYWORDS; i++)
			{
				KeyWords[i][0] = 0;
			}

			if (strnicmp(cmd, "keyword2", 8) == 0)
				KeyType = KEY_TYPE_KEYWORD2;
			else
				KeyType = KEY_TYPE_KEYWORD;

			// Set new keyword(s)...

			if ((arg1) && (*arg1))
			{
				strncpy(KeyWords[0], arg1, 63);
				KeyWords[0][63] = 0;
			}

			if ((arg2) && (*arg2))
			{
				strncpy(KeyWords[1], arg2, 63);
				KeyWords[1][63] = 0;
			}

			if ((arg3) && (*arg3))
			{
				strncpy(KeyWords[2], arg3, 63);
				KeyWords[2][63] = 0;
			}

			if ((arg4) && (*arg4))
			{
				strncpy(KeyWords[3], arg4, 63);
				KeyWords[3][63] = 0;
			}

			if ((arg5) && (*arg5))
			{
				strncpy(KeyWords[4], arg5, 63);
				KeyWords[4][63] = 0;
			}

			if ((arg6) && (*arg6))
			{
				strncpy(KeyWords[5], arg6, 63);
				KeyWords[5][63] = 0;
			}

			continue;
		}

		if (strnicmp(cmd, "keytoken", 8) == 0)
		{
			// Reset all key tokens
			for (i=0; i < MAX_CHAT_KEYTOKENS; i++)
			{
				KeyTokens[i] = 0;
			}

			KeyType = KEY_TYPE_KEYTOKEN;

			// Set new keytoken(s)...

			if ((arg1) && (*arg1))
			{
				KeyTokens[0] = arg1[0];
			}

			if ((arg2) && (*arg2))
			{
				KeyTokens[1] = arg2[0];
			}

			if ((arg3) && (*arg3))
			{
				KeyTokens[2] = arg3[0];
			}

			if ((arg4) && (*arg4))
			{
				KeyTokens[3] = arg4[0];
			}

			if ((arg5) && (*arg5))
			{
				KeyTokens[4] = arg5[0];
			}

			if ((arg6) && (*arg6))
			{
				KeyTokens[5] = arg6[0];
			}

			continue;
		}

		// Skip if outside brackets
		if (!ActiveBlock)// && (KeyType != KEY_TYPE_NONE) && (KeyType != KEY_TYPE_KEYWORD))
			continue;

		// If we get here we lickely need to add a new chat sentence...
		// So just in case the sentence is longer then MAX_CHAT_SENTENCE_LENGTH
		// we only take the first MAX_CHAT_SENTENCE_LENGTH chars...
		strncpy(szSentence, cmd, MAX_CHAT_SENTENCE_LENGTH - 1);
		szSentence[MAX_CHAT_SENTENCE_LENGTH - 1] = 0;

		int StrLength = strlen(szSentence);

		// If last char is a '\n'; remove it.
		if (szSentence[StrLength - 1] == '\n')
			szSentence[StrLength - 1] = 0;

		// If not in a keyword block and not in a keytoken block...
		if (KeyType == KEY_TYPE_NONE)
			KeyType = KEY_TYPE_KEYWORD;

		if ((Section == WELCOME_CHAT) && (WelcomeChatCount < MAX_BOT_CHAT))
		{
			AddWelcomeSentence(szSentence);
			WelcomeChatCount++;
		}
		else if ((Section == NORMAL_CHAT) && (NormalChatCount < MAX_BOT_CHAT))
		{
			if ((KeyType == KEY_TYPE_KEYWORD) || (KeyType == KEY_TYPE_KEYWORD2))
			{
				// No key word(s) specified?
				if (KeyWords[0][0] == 0)
					strcpy(KeyWords[0], "All");

				AddNormalChatSentence(szSentence, KeyWords[0], KeyType);

				for (i=1;i<MAX_CHAT_KEYWORDS;i++)
				{
					if (KeyWords[i][0] != 0)
						AddNormalChatSentence(szSentence, KeyWords[i], KeyType);
				}
			}
			else
			{
				// No key token(s) specified?
				if (KeyTokens[0] == 0)
					KeyTokens[0] = ' '; // Make it a space

				AddNormalChatSentence(szSentence, &KeyTokens[0], KeyType);

				for (i=1;i<MAX_CHAT_KEYWORDS;i++)
				{
					if (KeyTokens[i] != 0)
						AddNormalChatSentence(szSentence, &KeyTokens[i], KeyType);
				}
			}

			NormalChatCount++;
		}
        else if ((Section == TAUNT_CHAT) && (TauntCount < MAX_BOT_CHAT))
		{
			// No key word(s) specified?
			if (KeyWords[0][0] == 0)
				strcpy(KeyWords[0], "All");

			// .. For now DON'T use keywords for taunt sentences...
			AddTauntChatSentence(szSentence, "All", KeyType);

/*
			AddTauntChatSentence(szSentence, KeyWords[0], CanModify);

			for (i=1;i<MAX_CHAT_KEYWORDS;i++)
			{
				if (KeyWords[i][0] != 0)
					AddTauntChatSentence(szSentence, KeyWords[i], CanModify);
			}
*/
			TauntCount++;
		}
        else if ((Section == WHINE_CHAT) && (WhineCount < MAX_BOT_CHAT))
		{
			// No key word(s) specified?
			if (KeyWords[0][0] == 0)
				strcpy(KeyWords[0], "All");

			// .. For now DON'T use keywords for whine sentences...
			AddWhineChatSentence(szSentence, "All", KeyType);

//			AddWhineChatSentence(szSentence, KeyWords[0], CanModify);

/*
			for (i=1;i<MAX_CHAT_KEYWORDS;i++)
			{
				if (KeyWords[i][0] != 0)
					AddWhineChatSentence(szSentence, KeyWords[i], CanModify);
			}
*/
			WhineCount++;
		}
	}
    (*g_engfuncs.pfnServerPrint) ("done\n");

/*
	clog << "\nNormal Chat node list:\n\n";
	pNormalChatNodeList->ForEach(PrintChatNode);
	clog << "\nTaunt Chat node list:\n\n";
	pTauntChatNodeList->ForEach(PrintChatNode);
	clog << "\nWhine Chat node list:\n\n";
	pWhineChatNodeList->ForEach(PrintChatNode);
*/
}

void CChatClass::AddNormalChatSentence(const char *Sentence, const char *KeyWord, EKeyType KT)
{
	CChatNode *pChatNode;

	if (KT == KEY_TYPE_KEYTOKEN)
		pChatNode = pNormalChatNodeList->FindIf(this, &CChatClass::KeyTokenIsInNodeList,
											    KeyWord[0]);
	else
		pChatNode = pNormalChatNodeList->FindIf(this, &CChatClass::KeyWordIsInNodeList,
											    KeyWord);

	if (!pChatNode)
	{
		pChatNode = new CChatNode(KeyWord, KT);
		pChatNode->AddSentence(Sentence);
		pNormalChatNodeList->AddNode(pChatNode);
	}
	else
		pChatNode->AddSentence(Sentence);
}

void CChatClass::AddTauntChatSentence(const char *Sentence, const char *KeyWord, EKeyType KT)
{
	CChatNode *pChatNode = pTauntChatNodeList->FindIf(this, &CChatClass::KeyWordIsInNodeList,
													  KeyWord);

	if (!pChatNode)
	{
		pChatNode = new CChatNode(KeyWord, KT);
		pChatNode->AddSentence(Sentence);
		pTauntChatNodeList->AddNode(pChatNode);
	}
	else
		pChatNode->AddSentence(Sentence);
}

void CChatClass::AddWhineChatSentence(const char *Sentence, const char *KeyWord, EKeyType KT)
{
	CChatNode *pChatNode = pWhineChatNodeList->FindIf(this, &CChatClass::KeyWordIsInNodeList,
													  KeyWord);

	if (!pChatNode)
	{
		pChatNode = new CChatNode(KeyWord, KT);
		pChatNode->AddSentence(Sentence);
		pWhineChatNodeList->AddNode(pChatNode);
	}
	else
		pChatNode->AddSentence(Sentence);
}

bool CChatClass::CreateResponseList(SOldChatText *pOldChatText,
									TMultiChoice<CChatSentence*> *pSentenceList)
{
	char TempSentence[MAX_CHAT_SENTENCE_LENGTH] = "";
	char *TempKeyWord = NULL;
	CChatNode *pChatNode = NULL;
	bool MadeResponse = false;

	strcpy(TempSentence, pOldChatText->szText);

	TempKeyWord = strtok(TempSentence, " ,.;:[](){}-=+*-/\\<>?!@#$%%^&\n\r\t");
	pChatNode = pNormalChatNodeList->FindIf(this, &CChatClass::KeyWordIsInNodeList,
										    (const char*)(TempKeyWord));

	// Examine all words in the sentence to find a keyword....
	while (TempKeyWord)
	{
		// Is this word known as a key word?
		if (pChatNode)
		{
			if (!MadeResponse)
				MadeResponse = true;

			pChatNode->pChatSentences->ForEach(this, &CChatClass::MakeSentenceChoiceList2,
											   pSentenceList, pRecentNormalChatTexts,
											   (const char*)(pOldChatText->szSenderName));
		}

		TempKeyWord = strtok(NULL, " ,.;:[](){}-=+*-/\\<>?!@#$%%^&\n\r\t");

		pChatNode = pNormalChatNodeList->FindIf(this, &CChatClass::KeyWordIsInNodeList,
											    (const char*)(TempKeyWord));
	}

	strcpy(TempSentence, pOldChatText->szText);
	TempKeyWord = strtok(TempSentence, " \n\r\t");
	pChatNode = pNormalChatNodeList->FindIf(this, &CChatClass::KeyWordIsInNodeList,
										    (const char*)(TempKeyWord));

	// Examine all words in the sentence to find a keyword(without token filtering)....
	while (TempKeyWord)
	{
		//clog << "Searching KW: " << TempKeyWord << "\n";

		// Is this word known as a key word?
		if (pChatNode)
		{
			if (!MadeResponse)
				MadeResponse = true;

			pChatNode->pChatSentences->ForEach(this, &CChatClass::MakeSentenceChoiceList2,
											   pSentenceList, pRecentNormalChatTexts,
											   (const char*)(pOldChatText->szSenderName));
		}

		TempKeyWord = strtok(NULL, " \n\r\t");

		pChatNode = pNormalChatNodeList->FindIf(this, &CChatClass::KeyWordIsInNodeList,
											    (const char*)(TempKeyWord));
	}

	short Index = 0;
	short SentenceLength = strlen(pOldChatText->szText);

	// Examine all tokens...
	while ((Index < SentenceLength) && (pOldChatText->szText[Index]))
	{
		pChatNode = pNormalChatNodeList->FindIf(this, &CChatClass::KeyTokenIsInNodeList,
											    pOldChatText->szText[Index]);

		if (pChatNode)
		{
			if (!MadeResponse)
				MadeResponse = true;

			pChatNode->pChatSentences->ForEach(this, &CChatClass::MakeSentenceChoiceList2,
											   pSentenceList, pRecentNormalChatTexts,
											   (const char*)(pOldChatText->szSenderName));
		}

		Index++;
	}

	return MadeResponse;
}

void CChatClass::LetBotSayAWelcomeSentence(bot_t *pBot)
{
	// Pick a random sentence

	TMultiChoice<CChatSentence*> *pSentenceChoiceList = new TMultiChoice<CChatSentence*>;
	pWelcomeSentences->pChatSentences->ForEach(this, &CChatClass::MakeSentenceChoiceList3,
									   pSentenceChoiceList);

	CChatSentence *pSentence = NULL;
	pSentenceChoiceList->GetSelection(pSentence);
	delete pSentenceChoiceList;
	if (pSentence)
	{
		pBot->b_bot_say = true;
		pBot->f_bot_say = gpGlobals->time + 5.0 + RANDOM_FLOAT(0.0, 5.0);
			
		char PlayerName[33] = "";
		strcpy(PlayerName, STRING(pBot->pEdict->v.netname)); // make a 'dummy' name

		char ChatText[256] = "";

		if (pSentence->CanModify)
			MakeChatSentence(&BotPersonalities[pBot->Personality],
							 pSentence->szText, ChatText);
		else
			strcpy(ChatText, pSentence->szText);

		FillInNames(pBot, ChatText, pBot->bot_say_msg, PlayerName, STRING(pBot->pEdict->v.netname));
	}
}

void CChatClass::LetBotCheckForReply(bot_t *pBot)
{
	TMultiChoice<CChatSentence*> SentenceChoiceList[MAX_OLD_TEXTS_SAVED];
	TMultiChoice<TMultiChoice<CChatSentence*>*> *pReplySentencesChoices = new TMultiChoice<TMultiChoice<CChatSentence*>*>;
	CChatSentence *pSentence = NULL;
	char BotName[33] = "";

	strcpy(BotName, STRING(pBot->pEdict->v.netname));

	// Look if the bot can reply to a sentence...

	// Are there are any msg's at all and if so aren't they to old?
	if ((OldChatTexts[0].szText) && (*OldChatTexts[0].szText) &&
		(OldChatTexts[0].flCreateTime > (gpGlobals->time - 5.0f)))
	{
		byte Counter;
		short s;
		edict_t *pPlayer;
		char szPlayerName[33];

		for (Counter=0;Counter<MAX_OLD_TEXTS_SAVED;Counter++)
		{
			if ((OldChatTexts[Counter].szText) && (*OldChatTexts[Counter].szText) &&
				(OldChatTexts[Counter].flCreateTime > (gpGlobals->time - 5.0f)) &&
				(OldChatTexts[Counter].szSenderName) && 
				(*OldChatTexts[Counter].szSenderName) &&
				(strcmp(BotName, OldChatTexts[Counter].szSenderName) != 0))
			{
				byte UV = 50 - (10 * Counter);

				// Check if there are player names in the sentence...
				for (s=1;s<=gpGlobals->maxClients;s++)
				{
					pPlayer = INDEXENT(s);
					if (UTIL_IsValidPlayer(pPlayer, false, false) == false)
						continue;

					strcpy(szPlayerName, STRING(pPlayer->v.netname));

					if (strstr(OldChatTexts[Counter].szText, szPlayerName))
						UV *= 0.1;
					else if (strstr(OldChatTexts[Counter].szText, BotName))
						UV *= 1.25;
				}

				if(CreateResponseList(&OldChatTexts[Counter], &SentenceChoiceList[Counter]))
					pReplySentencesChoices->Insert(&SentenceChoiceList[Counter], UV);
			}
		}
	}

	TMultiChoice<CChatSentence*> *pSentenceChoiceList = NULL;
	pReplySentencesChoices->GetSelection(pSentenceChoiceList);
	delete pReplySentencesChoices;

	pSentence = NULL;

	if (pSentenceChoiceList)
	{
		pSentenceChoiceList->GetSelection(pSentence);
	}

	if (pSentence)
	{
		StoreRecentUsedSentence(pRecentNormalChatTexts, pSentence);
		pBot->b_bot_say = true;
		pBot->f_bot_say = gpGlobals->time + RANDOM_FLOAT(1.0, 2.5);
		pBot->f_bot_chat_time += RANDOM_FLOAT(10.0f, 20.0f);
			
		char PlayerName[33] = "";
		if (pSentence->szSenderName[0])
			strcpy(PlayerName, pSentence->szSenderName);
		else 
			strcpy(PlayerName, STRING(pBot->pEdict->v.netname)); // make a 'dummy' name

		char ChatText[256] = "";

		if (pSentence->CanModify)
			MakeChatSentence(&BotPersonalities[pBot->Personality],
							 pSentence->szText, ChatText);
		else
			strcpy(ChatText, pSentence->szText);

		FillInNames(pBot, ChatText, pBot->bot_say_msg, PlayerName, BotName);
	}
}

void CChatClass::LetBotSaySomething(bot_t *pBot)
{
	TMultiChoice<CChatSentence*> *pSentenceChoiceList = new TMultiChoice<CChatSentence*>;
	CChatSentence *pSentence = NULL;
	char BotName[33] = "";

	strcpy(BotName, STRING(pBot->pEdict->v.netname));

	// Pick a random sentence
	CChatNode *pChatNode = pNormalChatNodeList->FindIf(this, &CChatClass::KeyWordIsInNodeList, 
													   (const char*)("All"));
	if (pChatNode)
	{
		pChatNode->pChatSentences->ForEach(this, &CChatClass::MakeSentenceChoiceList,
										   pSentenceChoiceList, pRecentNormalChatTexts);
	}

	pSentenceChoiceList->GetSelection(pSentence);
	delete pSentenceChoiceList;

	if (pSentence)
	{
		StoreRecentUsedSentence(pRecentNormalChatTexts, pSentence);
		pBot->b_bot_say = true;
		pBot->f_bot_say = gpGlobals->time + 5.0 + RANDOM_FLOAT(0.0, 5.0);
			
		char PlayerName[33] = "";
		if (pSentence->szSenderName[0])
			strcpy(PlayerName, pSentence->szSenderName);
		else 
			strcpy(PlayerName, STRING(pBot->pEdict->v.netname)); // make a 'dummy' name

		char ChatText[256] = "";

		if (pSentence->CanModify)
			MakeChatSentence(&BotPersonalities[pBot->Personality],
							 pSentence->szText, ChatText);
		else
			strcpy(ChatText, pSentence->szText);

		FillInNames(pBot, ChatText, pBot->bot_say_msg, PlayerName, BotName);
	}
}

void CChatClass::LetBotTaunt(bot_t *pBot, edict_t *pVictim)
{
	// Pick a random sentence
	CChatNode *pChatNode = pTauntChatNodeList->FindIf(this, &CChatClass::KeyWordIsInNodeList, 
											          (const char*)("All"));
	if (pChatNode)
	{
		TMultiChoice<CChatSentence*> *pSentenceChoiceList = new TMultiChoice<CChatSentence*>;
		pChatNode->pChatSentences->ForEach(this, &CChatClass::MakeSentenceChoiceList,
										   pSentenceChoiceList, pRecentTauntChatTexts);

		CChatSentence *pSentence = NULL;
		pSentenceChoiceList->GetSelection(pSentence);
		delete pSentenceChoiceList;
		if (pSentence)
		{
			StoreRecentUsedSentence(pRecentTauntChatTexts, pSentence);
			pBot->b_bot_say = true;
			pBot->f_bot_say = gpGlobals->time + 5.0 + RANDOM_FLOAT(0.0, 5.0);
				
			const char *BotName = STRING(pBot->pEdict->v.netname);
			char ChatText[256] = "";
			char VictimName[33] = "";

			HumanizeName(&BotPersonalities[pBot->Personality], STRING(pVictim->v.netname),
						 VictimName);

			if (pSentence->CanModify)
				MakeChatSentence(&BotPersonalities[pBot->Personality],
								 pSentence->szText, ChatText);
			else
				strcpy(ChatText, pSentence->szText);

			FillInNames(pBot, ChatText, pBot->bot_say_msg, VictimName, BotName);
		}
	}
}

void CChatClass::LetBotWhine(bot_t *pBot, edict_t *pKiller)
{
	// Pick a random sentence
	CChatNode *pChatNode = pWhineChatNodeList->FindIf(this, &CChatClass::KeyWordIsInNodeList, 
											          (const char*)("All"));
	if (pChatNode)
	{
		TMultiChoice<CChatSentence*> *pSentenceChoiceList = new TMultiChoice<CChatSentence*>;
		pChatNode->pChatSentences->ForEach(this, &CChatClass::MakeSentenceChoiceList,
										   pSentenceChoiceList, pRecentWhineChatTexts);

		CChatSentence *pSentence = NULL;
		pSentenceChoiceList->GetSelection(pSentence);
		delete pSentenceChoiceList;
		if (pSentence)
		{
			StoreRecentUsedSentence(pRecentWhineChatTexts, pSentence);
			pBot->b_bot_say = true;
			pBot->f_bot_say = gpGlobals->time + 5.0 + RANDOM_FLOAT(0.0, 5.0);
				
			const char *BotName = STRING(pBot->pEdict->v.netname);
			char ChatText[256] = "";
			char KillerName[33] = "";

			HumanizeName(&BotPersonalities[pBot->Personality], STRING(pKiller->v.netname),
						 KillerName);

			if (pSentence->CanModify)
				MakeChatSentence(&BotPersonalities[pBot->Personality],
								 pSentence->szText, ChatText);
			else
				strcpy(ChatText, pSentence->szText);

			FillInNames(pBot, ChatText, pBot->bot_say_msg, KillerName, BotName);
		}
	}
}

void CChatClass::MakeChatSentence(BotPersonality_t *pPerso, 
								  const char *szSentence, char *szOutput)
{
	int pos;
    char temp_text[81];
    int count;

    strncpy(temp_text, szSentence, 79);
    temp_text[80] = 0;

    if (RANDOM_LONG(1, 100) <= pPerso->chat_drop_percent)
    {
		count = RANDOM_LONG(1, 3);

        while (count)
		{
			DropChars(temp_text, szOutput);
			strcpy(temp_text, szOutput);
			count--;
		}
    }

    if (RANDOM_LONG(1, 100) <= pPerso->chat_swap_percent)
    {
		count = RANDOM_LONG(1, 2);

		while (count)
		{
			SwapChars(temp_text, szOutput);
			strcpy(temp_text, szOutput);
			count--;
		}
    }

    if (RANDOM_LONG(1, 100) <= pPerso->chat_lower_percent)
    {
		pos = 0;
		while (temp_text[pos])
		{
			temp_text[pos] = tolower(temp_text[pos]);
			pos++;
		}
    }

    strcpy(szOutput, temp_text);
}

void CChatClass::FillInNames(bot_t *pBot, const char *szSentence, char *szOutput,
							 const char *PlayerName, const char *BotName)
{
	int chat_index, say_index;
    char *name_pos, *rand_pos;
    char random_name[64];
    int index, name_offset = 0, rand_offset = 0;  //EEKHOORN GAVE THESE A VALUE
    bool is_bad;
	char PlayerNames[32][33];
	edict_t *pPlayer;

    chat_index = 0;
    say_index = 0;
    szOutput[0] = 0;

    name_pos = strstr(&szSentence[chat_index], "%n");
    rand_pos = strstr(&szSentence[chat_index], "%r");

    while ((name_pos != NULL) || (rand_pos != NULL))
    {
		if (name_pos != NULL)
			name_offset = name_pos - szSentence;
		if (rand_pos != NULL)
			rand_offset = rand_pos - szSentence;

		if ((rand_pos == NULL) ||
			((name_offset < rand_offset) && (name_pos != NULL)))
		{
			while (&szSentence[chat_index] < name_pos)
				szOutput[say_index++] = szSentence[chat_index++];

			szOutput[say_index] = 0;  // add null terminator

			chat_index += 2;  // skip the "%n"

			strcat(szOutput, PlayerName);
			say_index += strlen(PlayerName);

			szOutput[say_index] = 0;
		}
		else  // use random player name...
		{
			int count;
			int PlayerCount = 0;

			for (count = 1;count <= gpGlobals->maxClients;count++)
			{
				pPlayer = INDEXENT(count);

				if (pPlayer == pBot->pEdict)
					continue;

				if (pBot->MadePlayerList)
				{
					if (!(pBot->PlayersChecked & (1<<(count-1))))
						continue;
				}
				else if (UTIL_IsValidPlayer(pPlayer, false, false) == false)
					continue;

				strcpy(PlayerNames[PlayerCount], STRING(pPlayer->v.netname));
				PlayerCount++;
			}

			if (PlayerCount < 2)
				return; // Looks stupid if bot is talking to himself :)

			// pick a name at random from the list of players...

			index = RANDOM_LONG(0, PlayerCount-1);

			is_bad = (strcmp(PlayerNames[index], PlayerName) == 0) ||
				     (strcmp(PlayerNames[index], BotName) == 0);

			count = 0;
			while ((is_bad) && (count < 20))
			{
				index = RANDOM_LONG(0, player_count-1);

				is_bad = (strcmp(PlayerNames[index], PlayerName) == 0) ||
					     (strcmp(PlayerNames[index], BotName) == 0);

				count++;
			}

			HumanizeName(&BotPersonalities[pBot->Personality], PlayerNames[index], random_name);

			while (&szSentence[chat_index] < rand_pos)
				szOutput[say_index++] = szSentence[chat_index++];

			szOutput[say_index] = 0;  // add null terminator

			chat_index += 2;  // skip the "%r"

			strcat(szOutput, random_name);
			say_index += strlen(random_name);

			szOutput[say_index] = 0;
		}

		name_pos = strstr(&szSentence[chat_index], "%n");
		rand_pos = strstr(&szSentence[chat_index], "%r");
    }

    while (szSentence[chat_index])
		szOutput[say_index++] = szSentence[chat_index++];

    szOutput[say_index] = 0;  // add null terminator
}

void CChatClass::HumanizeName(BotPersonality_t *pPerso, const char *szName, char *szOutput)
{
	int pos;

    if (RANDOM_LONG(1, 100) <= pPerso->chat_tag_percent)
    {
		char temp_name[80];

		strncpy(temp_name, szName, 31);
		temp_name[31] = 0;

		while (CutTags(temp_name, szOutput))
		{
			strcpy(temp_name, szOutput);
		}
    }
    else
    {
		strncpy(szOutput, szName, 31);
		szOutput[31] = 0;
    }

    if (RANDOM_LONG(1, 100) <= pPerso->chat_lower_percent)
    {
		pos = 0;
		while ((pos < 80) && (szOutput[pos]))
		{
			szOutput[pos] = tolower(szOutput[pos]);
			pos++;
		}
    }
}

int CChatClass::CutTags(const char *szName, char *szOutput)
{
	int i;
    char *pos1, *pos2, *src, *dest;
    char in_name[80];
    int result = 0;

    strncpy(in_name, szName, 31);
    in_name[32] = 0;

    for (i=0; i < NUM_TAGS; i++)
    {
		pos1=strstr(in_name, tag1[i]);
		if (pos1)
			pos2 = strstr(pos1+strlen(tag1[i]), tag2[i]);
		else
			pos2 = NULL;

		if (pos1 && pos2 && pos1 < pos2)
		{
			src = pos2+strlen(tag2[i]);
			dest = pos1;
			while (*src)
				*dest++ = *src++;
			*dest = *src;  // copy the null;

			result = 1;
		}
    }

    strcpy(szOutput, in_name);

    CutSpaces(szOutput, in_name);

    if (strlen(in_name) == 0)  // is name just a tag?
    {
		strncpy(in_name, szName, 31);
		in_name[32] = 0;

		// strip just the tag part...
		for (i=0; i < NUM_TAGS; i++)
		{
			pos1=strstr(in_name, tag1[i]);
			if (pos1)
				pos2 = strstr(pos1+strlen(tag1[i]), tag2[i]);
			else
				pos2 = NULL;

			if (pos1 && pos2 && pos1 < pos2)
			{
				src = pos1 + strlen(tag1[i]);
				dest = pos1;
				while (*src)
					*dest++ = *src++;
				*dest = *src;  // copy the null;

				src = pos2 - strlen(tag2[i]);
				*src = 0; // null out the rest of the string
			}
		}
	}

    CutSpaces(in_name, szOutput);

    szOutput[31] = 0;

    return (result);
}

void CChatClass::SwapChars(const char *szSentence, char *szOutput)
{
	int len, pos;
    int count = 0;
    char temp;
    bool is_bad;

    strcpy(szOutput, szSentence);

    len = strlen(szOutput);
    pos = RANDOM_LONG(1, len-2);  // don't swap position zero

    is_bad = !isalpha(szOutput[pos]) || !isalpha(szOutput[pos+1]) || 
		     (szOutput[pos-1] == '%');

    while ((is_bad) && (count < 20))
    {
		pos = RANDOM_LONG(1, len-2);
		is_bad = !isalpha(szOutput[pos]) || !isalpha(szOutput[pos+1]) ||
			     (szOutput[pos-1] == '%');
        count++;
    }

    if (count < 20)
    {
		temp = szOutput[pos];
		szOutput[pos] = szOutput[pos+1];
		szOutput[pos+1] = temp;
    }
}

void CChatClass::DropChars(const char *szSentence, char *szOutput)
{
	int len, pos;
    int count = 0;
    char *src, *dest;
    bool is_bad;

    strcpy(szOutput, szSentence);

    len = strlen(szOutput);
    pos = RANDOM_LONG(1, len-1);  // don't drop position zero

    is_bad = !isalpha(szOutput[pos]) || (szOutput[pos-1] == '%');

    while ((is_bad) && (count < 20))
    {
		pos = RANDOM_LONG(1, len-1);
		is_bad = !isalpha(szOutput[pos]) || (szOutput[pos-1] == '%');
		count++;
    }

    if (count < 20)
    {
		src = &szOutput[pos+1];
		dest = &szOutput[pos];
		while (*src)
			*dest++ = *src++;
		*dest = *src;  // copy the null;
    }
}

void CChatClass::CutSpaces(const char *szInput, char *szOutput)
{
	int i, Pos;
    char *szDest;

    Pos = 0;
    while ((Pos < 80) && (szInput[Pos] == ' '))  // skip leading blanks
		Pos++;

    szDest = &szOutput[0];

    while ((Pos < 80) && (szInput[Pos]))
    {
		*szDest++ = szInput[Pos];
		Pos++;
    }
    *szDest = 0;  // store the null

    i = strlen(szOutput) - 1;
    while ((i > 0) && (szOutput[i] == ' '))  // remove trailing blanks
    {
		szOutput[i] = 0;
		i--;
    }
}

void CChatClass::GetChatTextFromTextMsg(const char *szMsgText, char *szOutput)
{
	if ((!szMsgText) || (!*szMsgText))
	{
		strcpy(szOutput, "");
		return;
	}

	if (szMsgText[0] == 2) // Does the message start with nr 2, if so its a chat msg
	{
		unsigned int pos = 0;
		char szSentence[256] = "";
		strcpy(szSentence, &szMsgText[1]); // Copy the text without nr 2...

		// Search the first ':'
		while((pos < strlen(szSentence)) && (szSentence[pos]) && (szSentence[pos] != ':'))
			pos++;

		// Copy the text without ':' and the following space
		strcpy(szOutput, &szSentence[pos + 2]);
	}
	else
		strcpy(szOutput, "");
}

void CChatClass::GetSenderNameFromTextMsg(const char *szMsgText, char *szOutput)
{
	if ((!szMsgText) || (!*szMsgText))
	{
		strcpy(szOutput, "");
		return;
	}

	if (szMsgText[0] == 2) // Does the message start with nr 2, if so its a chat msg
	{
		int pos = 0;
		char szName[256] = "";
		strcpy(szName, &szMsgText[1]); // Copy the text without nr 2...

		// Search the first ':'
		int StrLength = strlen(szName);
		while((pos < StrLength) && (szName[pos]) && (szName[pos] != ':') && (pos < 32))
			pos++;

		// Copy the text without ':' and the following space
		strncpy(szOutput, szName, pos);
		szOutput[pos] = 0;
	}
	else
		strcpy(szOutput, "");
}

void CChatClass::StoreTextMsg(const char *szMsgText)
{
	char szSentence[256] = "";
	char szSenderName[33] = "";

	GetChatTextFromTextMsg(szMsgText, szSentence);
	GetSenderNameFromTextMsg(szMsgText, szSenderName);

	if ((szSentence) && (*szSentence) && (szSenderName) && (*szSenderName))
	{
		if (FStrEq(szSentence, OldChatTexts[0].szText))
			return; // Don't store if already exist

		for (short j=(MAX_OLD_TEXTS_SAVED-1);j>0;j--)
			OldChatTexts[j] = OldChatTexts[j-1];

		OldChatTexts[0].flCreateTime = gpGlobals->time;
		strcpy(OldChatTexts[0].szText, szSentence);
		strcpy(OldChatTexts[0].szSenderName, szSenderName);
	}
}

void CChatClass::StoreRecentUsedSentence(CChatSentence *VarToStore[], CChatSentence *pSentence)
{
	for (byte i = (MAX_RECENT_USED_TEXTS - 1);i>0;i--)
		VarToStore[i] = VarToStore[i-1];

	VarToStore[0] = pSentence;
}

// List operation function(s)

bool CChatClass::KeyWordIsInNodeList(CChatNode *pNode, const char *KeyWord)
{
	if (pNode->KeyType == KEY_TYPE_KEYTOKEN)
		return false;

	if ((KeyWord) && (*KeyWord))
		return (stricmp(KeyWord, pNode->szKeyStr) == 0);
	else
		return false;
}

bool CChatClass::KeyTokenIsInNodeList(CChatNode *pNode, char KeyToken)
{
	if (pNode->KeyType != KEY_TYPE_KEYTOKEN)
		return false;

	return (KeyToken == pNode->szKeyStr[0]);
}

void CChatClass::MakeSentenceChoiceList(CChatSentence *pChatSentence,
										TMultiChoice<CChatSentence*> *pList,
										CChatSentence *OldSentences[])
{
	if (pChatSentence->RandomNameCount > (NumPlayers - 1))
		return;

	if (pChatSentence->TargetNameCount > NumPlayers)
		return;

	byte UseValue = pChatSentence->UseValue;

	for (byte i=0;i<MAX_RECENT_USED_TEXTS;i++)
	{
		// Is this sentence recently used?
		if (pChatSentence == OldSentences[i])
		{
			// For about 80% skip the message
			if (RANDOM_LONG(1, 100) <= 80)
				return;
			else // else just lower the use value
				UseValue *= 0.25;
		}
	}

	pList->Insert(pChatSentence, pChatSentence->UseValue);
	//clog << "Inserting " << pChatSentence->szText << "...\n";
//	lcout << "Inserting " << pChatSentence->szText << "...\n";
}

void CChatClass::MakeSentenceChoiceList2(CChatSentence *pChatSentence,
										 TMultiChoice<CChatSentence*> *pList,
										 CChatSentence *OldSentences[], const char *szSenderName)
{
	if (pChatSentence->RandomNameCount > (NumPlayers - 1))
		return;

	if (pChatSentence->TargetNameCount > NumPlayers)
		return;

	byte UseValue = pChatSentence->UseValue;

	for (byte i=0;i<MAX_RECENT_USED_TEXTS;i++)
	{
		// Is this sentence recently used?
		if (pChatSentence == OldSentences[i])
		{
			// For about 80% skip the message
			if (RANDOM_LONG(1, 100) <= 80)
				return;
			else // else just lower the use value
				UseValue *= 0.25;
		}
	}

	pChatSentence->szSenderName[0] = 0;
	strcpy(pChatSentence->szSenderName, szSenderName);
	pList->Insert(pChatSentence, pChatSentence->UseValue);
	//clog << "Inserting " << pChatSentence->szText << "...\n";
//	lcout << "Inserting " << pChatSentence->szText << "...\n";
}

void CChatClass::MakeSentenceChoiceList3(CChatSentence *pChatSentence,
										 TMultiChoice<CChatSentence*> *pList)
{
	if (pChatSentence->RandomNameCount > (NumPlayers - 1))
		return;

	if (pChatSentence->TargetNameCount > NumPlayers)
		return;

	pList->Insert(pChatSentence, pChatSentence->UseValue);
}

// Debug function(s)

void CChatClass::LogPrevMessages()
{
	for (int i=0;i<MAX_OLD_TEXTS_SAVED;i++)
	{
		clog << "Prev msg nr " << i << " msg: " << OldChatTexts[i].szText << "\n";
		clog << "Sender: " << OldChatTexts[i].szSenderName << " SendTime: " << OldChatTexts[i].flCreateTime << "\n";
	}
}

void CChatClass::LogChatLists()
{
	clog << "Logging welcome sentences...\n\n";
	pWelcomeSentences->pChatSentences->ForEach(this, &CChatClass::LogChatSentences);
	clog << "\nEnd node\n";
	clog << "Logging normal chat list...\n\n";
	pNormalChatNodeList->ForEach(this, &CChatClass::LogChatNode);
	clog << "\n\nTaunt Chat node list:\n\n";
	pTauntChatNodeList->ForEach(this, &CChatClass::LogChatNode);
	clog << "\n\nWhine Chat node list:\n\n";
	pWhineChatNodeList->ForEach(this, &CChatClass::LogChatNode);
}

void CChatClass::LogChatNode(CChatNode *pNode)
{
	if (pNode->KeyType == KEY_TYPE_KEYWORD)
		clog << "Node using keyword: " << pNode->szKeyStr << "\n";
	else if (pNode->KeyType == KEY_TYPE_KEYWORD2)
		clog << "Node using keyword2: " << pNode->szKeyStr << "\n";
	else
		clog << "Node using key token: " << pNode->szKeyStr[0] << "\n";

	clog << "Sentences of this node: \n\n";
	pNode->pChatSentences->ForEach(this, &CChatClass::LogChatSentences);
	clog << "\nEnd node\n";
}

void CChatClass::LogChatSentences(CChatSentence *pSentence)
{
	clog << "Sentence: " << pSentence->szText << " CanModify: " << pSentence->CanModify << 
		    " UV: " << pSentence->UseValue << "\n";
}

// ===================================================
// Code of CChatClass End
// ===================================================
