#include "general_header.h"

void ChangeMeleePercent(short NewPercent);
void ChangeTeleportPercent(short NewPercent);
void ChangeSwoopPercent(short NewPercent);
void ChangeFlyPercent(short NewPercent);
void ChangeChatPercent(short NewPercent);
void ChangeTauntPercent(short NewPercent);
void ChangeWhinePercent(short NewPercent);
void ChangeChatTagPercent(short NewPercent);
void ChangeChatDropPercent(short NewPercent);
void ChangeChatSwapPercent(short NewPercent);
void ChangeChatLowerPercent(short NewPercent);
void ChangeSBotLaserPercent(short NewPercent);

extern edict_t *listenserver_edict;
extern float bot_check_time;
extern bot_t bots[32];
extern float num_bots_check;
extern bool fill_half;
extern bool fill_server;
extern int fill_count;
extern int fill_team;
extern BotPersonality_t BotPersonalities[9];
extern int default_bot_skill;
extern bool IsPlayingMessage;

extern bool follow_mode;
extern bool should_bot_chat;
extern bool b_observer_mode;
extern bool b_botdontshoot;
extern bool BotDontSearchEnemy;
extern bool BotShouldMove;
extern bool BotDoCombos;
extern bool BotsUseDiscs;
extern bool BotsAreIdle;

extern bool DrawTraceLines;
extern bool BalanceTeams;

int NMenu::gmsgShowMenu = 0;
void (*NMenu::pCurrentMenuFunction)(void) = NULL;
short NMenu::CurrentMenuChoice;
short NMenu::SBotType = 0;
short NMenu::BotTeam = 0;
short NMenu::BotSkill = 0;
char *NMenu::CurrentMenuText;
int NMenu::CurrentKeySlots;

const char *NMenu::MainMenuText =
{"ESF-Bot Menu\n\n"
 "1: Add Random Bot\n"
 "2: Add Custom Bot\n"   
 "3: Super Bot Menu\n"
 "4: Fill Server\n" 
 "5: Advanced Options\n"
 "6: Chat Settings\n"
 "7: Kick Last Bot\n"
 "8: Kick Bots\n"
 "9: Debug Options\n\n"
 "0: Exit"
};

const char *NMenu::CustomBotSkillMenuText =
{"Add Custom Bot - Select a Skill\n\n"
 "1: Best\n"
 "2: Good\n"
 "3: Medium\n"
 "4: Weak\n"
 "5: Bad\n"
 "6: Default\n"
 "7: Random\n\n"
 "0: Exit"
};

const char *NMenu::CustomBotTeamMenuText =
{"Add Custom Bot - Select a Team\n\n"
 "1: Team Good\n"
 "2: Team Evil\n"
 "3: Random Team\n\n"
 "0: Exit"
};

const char *NMenu::CustomBotClassMenuText =
{"Add Custom Bot - Select a Class\n\n"
 "1: Buu\n"
 "2: Goku\n"
 "3: Gohan\n"
 "4: Krillin\n"
 "5: Frieza\n"
 "6: Piccolo\n"
 "7: Trunks\n"
 "8: Vegeta\n"
 "9: Cell\n\n"
 "0: Exit"
};

const char *NMenu::SuperBotMenuText =
{"Super Bot Menu\n\n"
 "1: Add a Super Bot\n"
 "2: Add a Mega Bot\n"
 "3: Add a Ultimate Bot\n"
 "4: Add Random Super Bot Type\n"
 "5: Change Super Bot Laser Percent\n\n"
 "0: Exit"
};

const char *NMenu::FillServerMenuText =
{"Fill Server Menu\n\n"
 "1: Fill Server\n"
 "2: Fill Half Team Good\n"
 "3: Fill Half Team Evil\n"
 "4: Fill Team Good\n"
 "5: Fill Team Evil\n\n"
 "0. Exit"
};

const char *NMenu::AdvancedMenuText =
{"Advanced Settings\n\n"
 "1: Set Bot Skill\n"
 "2: Percent settings\n"
 "3: Follow Mode\n"
 "4: Bot team balancing\n"
 "5: Bots use discs\n"
 "6: Restore bot personalities\n"
 "7: Set Bot Aggression Level\n\n"
 "0: Exit"
};

const char *NMenu::ChatMenuText =
{"Bot Chat Menu\n\n"
 "1: Chat On/Off\n"
 "2: Set Chat Percent\n"
 "3: Set Whine Percent\n"
 "4: Set Taunt Percent\n"
 "5: Set Swap Percent\n"
 "6: Set Lower Percent\n"
 "7: Set Drop Percent\n"
 "8: Set Tag Percent\n\n"
 "0: Exit"
};

const char *NMenu::KickMenuText =
{"Kick Bots Menu\n\n"
 "1: Kick All Bots\n"
 "2: Kick Good Team Bots\n"
 "3: Kick Evil Team Bots\n\n"
 "0: Exit"
};

const char *NMenu::DebugMenuText =
{"Debug Menu\n\n"
 "1: Bots Don't Shoot\n"
 "2: Bots Don't Search enemy's\n"
 "3: Bots Ignore Human Players\n"
 "4: Bots Move\n"
 "5: Draw Trace Lines\n\n"
 "0: Exit"
};


const char *NMenu::AIPercentMenuText =
{"Percent settings\n\n"
 "1: Set Melee Percent\n"
 "2: Set Teleport Percent\n"
 "3: Set fly percent\n"
 "4: Set swoop percent\n\n"
 "0: Exit"
};

const char *NMenu::PercentMenuText =
{"Select Percent\n\n"
 "1: 100%\n"
 "2: 80% - 99%\n"
 "3: 60%-80%\n"
 "4: 40%-60%\n"
 "5: 20%-40%\n"
 "6: 1%-20%\n"
 "7: 0%\n"
 "8: Random\n\n"
 "0. exit"
};

const char *NMenu::OnOffMenuText =
{"Enable Or Disable ?\n\n"
 "1: Enable\n"
 "2: Disable\n\n"
 "0: Exit"
};

const char *NMenu::BotSkillMenuText =
{"Select Skill\n\n"
 "1: Best\n"
 "2: Good\n"
 "3: Medium\n"
 "4: Weak\n"
 "5: Bad\n"
 "6: Default\n\n"
 "0: Exit"
};

const char *NMenu::AutoClientMenuText =
{"Auto pilot menu\n\n"
 "1: Enable\n"
 "2: Disable\n"
 "3: Lock Camara\n\n"
 "0: Exit"
};

const char *NMenu::AggressionLevelMenuText =
{"Set Bot Aggression Level\n\n"
 "1: Defensive\n"
 "2: Normal\n"
 "3: Aggressive\n\n"
 "0: Exit"
};

const char *NMenu::FollowEnabledMessage = "Follow mode enabled";
const char *NMenu::FollowDisabledMessage = "Follow mode disabled";
const char *NMenu::ChatEnabledMessage = "Bots will chat";
const char *NMenu::ChatDisabledMessage = "Bots won't chat";
const char *NMenu::BotDontShootEnabledMessage = "Bots won't attack";
const char *NMenu::BotDontShootDisabledMessage = "Bots will attack";
const char *NMenu::BotDontSearchEnemiesEnabledMessage = "Bots won't search for enemies";
const char *NMenu::BotDontSearchEnemiesDisabledMessage = "Bots will search enemies";
const char *NMenu::ObserverEnabledMessage = "Bots ignore real players";
const char *NMenu::ObserverDisabledMessage = "Bots won't ignore real players";
const char *NMenu::BotsMoveEnabledMessage = "Bots will move";
const char *NMenu::BotsMoveDisabledMessage = "Bots won't move";
const char *NMenu::DrawTraceLinesEnabledMessage = "Beams will be drawed on tracelines";
const char *NMenu::DrawTraceLinesDisabledMessage = "Beams won't be drawed on tracelines";
const char *NMenu::DiscUsageEnabledMessage = "Bots will use discs";
const char *NMenu::DiscUsageDisabledMessage = "Bots won't use discs";
const char *NMenu::BotBalanceTeamsEnabledMessage = "Bots will balance teams";
const char *NMenu::BotBalanceTeamsDisabledMessage = "Bots won't balance teams";

const int NMenu::MainMenuKeys = 0x3FF;
const int NMenu::CustomBotSkillMenuKeys	= 0x27F;
const int NMenu::CustomBotTeamMenuKeys	= 0x207;
const int NMenu::CustomBotClassMenuKeys	= 0x3FF;
const int NMenu::SuperBotMenuKeys = 0x21F;
const int NMenu::FillServerMenuKeys = 0x21F;
const int NMenu::AdvancedMenuKeys = 0x27F;
const int NMenu::ChatMenuKeys = 0x2FF;
const int NMenu::KickMenuKeys = 0x207;
const int NMenu::DebugMenuKeys = 0x21F;
const int NMenu::PercentMenuKeys = 0x2FF;
const int NMenu::AIPercentMenuKeys	= 0x2FF;
const int NMenu::OnOffMenuKeys = 0x203;
const int NMenu::BotSkillMenuKeys = 0x23F;
const int NMenu::AutoClientMenuKeys = 0x207;
const int NMenu::AggressionLevelMenuKeys = 0x207;

// To make things easier :)
using namespace NMenu;

// This MUST be in the same order as EMenuType !!
NMenu::MenuInfo NMenu::MenuInfos[] =
{
	{MainMenuKeys, MainMenuText, &MainMenu},

	{CustomBotSkillMenuKeys, CustomBotSkillMenuText, &CustomBotSkillMenu},
	{CustomBotTeamMenuKeys, CustomBotTeamMenuText, &CustomBotTeamMenu},
	{CustomBotClassMenuKeys, CustomBotClassMenuText, &CustomBotClassMenu},

	{SuperBotMenuKeys, SuperBotMenuText, &SuperBotMenu},
	{FillServerMenuKeys, FillServerMenuText, &FillServerMenu},
	{AdvancedMenuKeys, AdvancedMenuText, &AdvancedMenu},
	{ChatMenuKeys, ChatMenuText, &ChatMenu},
	{KickMenuKeys, KickMenuText, &KickMenu},
	{DebugMenuKeys, DebugMenuText, &DebugMenu},

	{AIPercentMenuKeys, AIPercentMenuText, &AIPercentMenu},
	{PercentMenuKeys, PercentMenuText, &MeleePercentMenu},
	{PercentMenuKeys, PercentMenuText, &TeleportPercentMenu},
	{PercentMenuKeys, PercentMenuText, &SwoopPercentMenu},
	{PercentMenuKeys, PercentMenuText, &FlyPercentMenu},
	{PercentMenuKeys, PercentMenuText, &ChatPercentMenu},
	{PercentMenuKeys, PercentMenuText, &WhinePercentMenu},
	{PercentMenuKeys, PercentMenuText, &TauntPercentMenu},
	{PercentMenuKeys, PercentMenuText, &SwapPercentMenu},
	{PercentMenuKeys, PercentMenuText, &DropPercentMenu},
	{PercentMenuKeys, PercentMenuText, &TagPercentMenu},
	{PercentMenuKeys, PercentMenuText, &LowerPercentMenu},
	{PercentMenuKeys, PercentMenuText, &SBotLaserPercentMenu},

	{BotSkillMenuKeys, BotSkillMenuText, &BotSkillMenu},
	{AggressionLevelMenuKeys, AggressionLevelMenuText, &AggressionLevelMenu},
	{OnOffMenuKeys, OnOffMenuText, &FollowToggleMenu},
	{OnOffMenuKeys, OnOffMenuText, &ChatToggleMenu},
	{OnOffMenuKeys, OnOffMenuText, &BotDontShootToggleMenu},
	{OnOffMenuKeys, OnOffMenuText, &BotDontSearchEnemiesToggleMenu},
	{OnOffMenuKeys, OnOffMenuText, &ObserverToggleMenu},
	{OnOffMenuKeys, OnOffMenuText, &BotsMoveToggleMenu},
	{OnOffMenuKeys, OnOffMenuText, &DrawTraceLinesToggleMenu},
	{OnOffMenuKeys, OnOffMenuText, &DiscUsageToggleMenu},
	{OnOffMenuKeys, OnOffMenuText, &BalanceTeamsToggleMenu}
};

void NMenu::ExecuteMenuCommand(int MenuChoice)
{
	if ((!pCurrentMenuFunction) || (!CurrentMenuText) || (MenuChoice == -1))
	{
		SetNewMenu(MainMenuType);
	}
	else
	{
		CurrentMenuChoice = MenuChoice;
		pCurrentMenuFunction();
	}

	if (CurrentMenuText)
		ShowMenu();
}

void NMenu::ShowMenu()
{
    if (IS_DEDICATED_SERVER() == false)
    {
		if (gmsgShowMenu == 0)
			gmsgShowMenu = REG_USER_MSG( "ShowMenu", -1 );

		if (IsPlayingMessage)
		{
			clog << "Tried to display menu-text when there is already a message active\n";
			return;
		}

		pfnMessageBegin(MSG_ONE, gmsgShowMenu, NULL, listenserver_edict);
			pfnWriteShort(CurrentKeySlots); // used key slots
		    pfnWriteChar(-1); // lifetime(forever)
	        pfnWriteByte(false); // needmore ?
	        pfnWriteString(CurrentMenuText); // Menu text to display
	    pfnMessageEnd();
    }
    else
    {
		// Split the menu text in 2 parts when the text length > 128
	    if (strlen(CurrentMenuText) > 128)
		{
		    char MenuText1[130] = "";
		    char MenuText2[130] = "";
		   
		    strncpy(MenuText1,CurrentMenuText,128);
		    strncpy(MenuText2,&CurrentMenuText[129],strlen(CurrentMenuText)-128);
			MenuText1[128] = 0;
			MenuText2[128] = 0;
		    UTIL_Printf(MenuText1);
		    UTIL_Printf(MenuText2);
		}
	    else
		    UTIL_Printf(CurrentMenuText);

	   UTIL_Printf("\n\nTo make a choice type esf_bot4 menuselect X where X stands for the choice number\n");
   }
}

void NMenu::ResetMenu()
{
	pCurrentMenuFunction = NULL;
	CurrentMenuChoice = 0;
	CurrentMenuText = NULL;
	CurrentKeySlots = 0;
	SBotType = 0;
	BotTeam = 0;
}

void NMenu::SetNewMenu(EMenuType MenuType)
{
	int Index = static_cast<int>(MenuType);

	pCurrentMenuFunction = MenuInfos[Index].pMenuFunction;
	CurrentMenuText = const_cast<char*>(MenuInfos[Index].MenuText);
	CurrentKeySlots = MenuInfos[Index].MenuKeySlots;
}

void NMenu::MainMenu()
{
	switch(CurrentMenuChoice)
	{
	case 1: // Add a random bot
		BotCreate(listenserver_edict, NULL, NULL, NULL, NULL, NULL );
        bot_check_time = gpGlobals->time + 5.0;
		ResetMenu();
		break;
	case 2:
		SetNewMenu(CustomBotSkillMenuType);

		break;
	case 3:
#ifndef SBotFights
		if (IsTeamPlay())
#endif
			SetNewMenu(SuperBotMenuType);
#ifndef SBotFights
		else
		{
			cout << "This option is NOT available in free fight\n";
			ResetMenu();
		}
#endif
		break;
	case 4:
		SetNewMenu(FillServerMenuType);
		break;
	case 5:
		SetNewMenu(AdvancedMenuType);
		break;
	case 6:
		SetNewMenu(ChatMenuType);
		break;
	case 7: // Kick the last created bot
		int index;
         
		for (index = 31; index >= 0; index--)
		{
			// is this slot used?
			if ((bots[index].is_used) && (bots[index].pEdict != listenserver_edict) &&
				(!IsNull(bots[index].pEdict)))
			{
				char cmd[40];
		
				sprintf(cmd, "kick \"%s\"\n", STRING(bots[index].pEdict->v.netname));
				SERVER_COMMAND(cmd);  // kick the bot using (kick "name")
				bots[index].is_used = false;

				num_bots_check = -2;

				if (fill_server) // stop filling the server(guess the user want to abort it)
				{
					fill_team = 0;
					fill_half = fill_server = false;
				}

				break;
			}

			ResetMenu();
		}
		break;
	case 8:
		SetNewMenu(KickBotsMenuType);
		break;
	case 9:
		SetNewMenu(DebugMenuType);
		break;
	default:
		ResetMenu();
	}
}

void NMenu::CustomBotSkillMenu()
{
	if ((CurrentMenuChoice >= 1) && (CurrentMenuChoice <= 5))
		BotSkill = CurrentMenuChoice;
	else if (CurrentMenuChoice == 6)
		BotSkill = 2;
	else if (CurrentMenuChoice == 7)
		BotSkill = RANDOM_LONG(1, 5);
	else
	{
		ResetMenu();
		return;
	}

	if (IsTeamPlay())
	{
		SetNewMenu(CustomBotTeamMenuType);
	}
	else
	{
		SetNewMenu(CustomBotClassMenuType);
	}
}

void NMenu::CustomBotTeamMenu()
{
	if ((CurrentMenuChoice == 1) || (CurrentMenuChoice == 2))
		BotTeam = CurrentMenuChoice;
	else if (CurrentMenuChoice == 3)
		BotTeam = RANDOM_LONG(1, 2);
	else
	{
		ResetMenu();
		return;
	}
	SetNewMenu(CustomBotClassMenuType);
}

void NMenu::CustomBotClassMenu()
{
	char temp_skill[2] = "";
	char temp_team[2] = "";
	char temp_class[2] = "";
	
	if ((BotSkill >= 1) && (BotSkill <= 5))
		sprintf(temp_skill, "%i", BotSkill);

	if ((BotTeam >= 1) && (BotTeam <= 2))
		sprintf(temp_team, "%i", BotTeam);

	if ((CurrentMenuChoice >= 1) && (CurrentMenuChoice <= 9))
		sprintf(temp_class, "%i", CurrentMenuChoice);
	else
	{
		ResetMenu();
		return;
	}

	if (SBotType > 0)
	{
		SBotCreate(listenserver_edict, temp_class, SBotType, NULL);
		SBotType = 0;
	}
	else
	{
		BotCreate(listenserver_edict, temp_team, temp_class, NULL, temp_skill, NULL);
		BotSkill = BotTeam = 0;
	}
 
    bot_check_time = gpGlobals->time + 5.0;
	ResetMenu();
}

void NMenu::SuperBotMenu()
{
	switch(CurrentMenuChoice)
	{
	case 1:
	case 2:
	case 3:
	case 4:
		if (CurrentMenuChoice == 4)
			SBotType = RANDOM_LONG(1, 3);
		else
			SBotType = CurrentMenuChoice;

		SetNewMenu(CustomBotClassMenuType);
		break;
	case 5:
		SetNewMenu(SBotLaserPercentMenuType);
		break;
	default:
		ResetMenu();
		return;
	}
}

void NMenu::FillServerMenu()
{
	switch (CurrentMenuChoice)
	{
	case 1: // Fill whole server
		fill_half = false;
		fill_server = true;
		fill_count = 0;
		fill_team = 0;
		break;
	case 2:
		fill_server = true;
        fill_half = true;
		fill_count = 0;
		fill_team = 1;
		break;
	case 3:
		fill_server = true;
        fill_half = true;
		fill_count = 0;
		fill_team = 2;
		return;
	case 4:
		fill_server = true;
        fill_half = false;
		fill_count = 0;
		fill_team = 1;
		break;
	case 5:
		fill_server = true;
        fill_half = false;
		fill_count = 0;
		fill_team = 2;
		break;
	default:
		fill_half = false;
		fill_server = false;
		fill_count = 0;
		fill_team = 0;	
	}

	if ((fill_server) && (fill_team != 0) && (!IsTeamPlay()))
		fill_team = 0;

	ResetMenu();
}

void NMenu::AdvancedMenu()
{
	switch(CurrentMenuChoice)
	{
	case 1:
		SetNewMenu(BotSkillSelectMenuType);
		break;
	case 2:
		SetNewMenu(AIPercentMenuType);
		break;
	case 3:
		SetNewMenu(FollowToggleMenuType);
		break;
	case 4:
		SetNewMenu(BalanceTeamsToggleMenuType);
		break;
	case 5:
		SetNewMenu(DiscUsageToggleMenuType);
		break;
	case 6: // Restore all bot personalities
		MakePersonalities();

		int i;
		for(i=0;i<32;i++)
		{
			if (bots[i].is_used == false)
				continue;

			if (bots[i].pEdict != listenserver_edict) // Skip autopilots(since they can't melee)
				bots[i].MeleePercent = BotPersonalities[bots[i].Personality].melee_percent;

			bots[i].TeleportPercent = BotPersonalities[bots[i].Personality].teleport_percent;
			bots[i].SwoopPercent = BotPersonalities[bots[i].Personality].swoop_percent;
			bots[i].FlyPercent = BotPersonalities[bots[i].Personality].fly_percent;
			bots[i].AggressionLevel = BotPersonalities[bots[i].Personality].aggression_level;
			bots[i].chat_percent = BotPersonalities[bots[i].Personality].chat_percent;
			bots[i].taunt_percent = BotPersonalities[bots[i].Personality].taunt_percent;
			bots[i].whine_percent = BotPersonalities[bots[i].Personality].whine_percent;
			bots[i].chat_tag_percent = BotPersonalities[bots[i].Personality].chat_tag_percent;
			bots[i].chat_drop_percent = BotPersonalities[bots[i].Personality].chat_drop_percent;
			bots[i].chat_swap_percent = BotPersonalities[bots[i].Personality].chat_swap_percent;
			bots[i].chat_lower_percent = BotPersonalities[bots[i].Personality].chat_lower_percent;
		}

		ResetMenu();
		break;
	case 7:
		SetNewMenu(AggressionLevelMenuType);
		break;
	default:
		ResetMenu();
		break;
	}
}

void NMenu::ChatMenu()
{
	switch(CurrentMenuChoice)
	{
	case 1:
		SetNewMenu(ChatToggleMenuType);
		break;
	case 2:
		SetNewMenu(ChatToggleMenuType);
		break;
	case 3:
		SetNewMenu(ChatPercentMenuType);
		break;
	case 4:
		SetNewMenu(WhinePercentMenuType);
		break;
	case 5:
		SetNewMenu(TauntPercentMenuType);
		break;
	case 6:
		SetNewMenu(SwapPercentMenuType);
		break;
	case 7:
		SetNewMenu(LowerPercentMenuType);
		break;
	case 8:
		SetNewMenu(DropPercentMenuType);
		break;
	default:
		ResetMenu();
		break;
	}
}

void NMenu::KickMenu()
{
	switch(CurrentMenuChoice)
	{
	case 1:
		UTIL_KickBots(-1);
		UTIL_Printf("All Bots removed!\n");
		break;
	case 2:
		UTIL_KickBots(1);
		UTIL_Printf("All Bots removed in team good!\n");
		break;
	case 3:
		UTIL_KickBots(2);
		UTIL_Printf("All Bots removed in team evil!\n");
		break;
	}

	ResetMenu();
}

void NMenu::DebugMenu()
{
	switch(CurrentMenuChoice)
	{
	case 1:
		SetNewMenu(BotDontShootToggleMenuType);
		break;
	case 2:
		SetNewMenu(BotDontSearchEnemiesToggleMenuType);
		break;
	case 3:
		SetNewMenu(ObserverToggleMenuType);
		break;
	case 4:
		SetNewMenu(BotsMoveToggleMenuType);
		break;
	case 5:
		if (IS_DEDICATED_SERVER() == false)
			SetNewMenu(DrawTraceLinesToggleMenuType);
		else
		{
			ResetMenu();
			UTIL_Printf("This option is not available for a dedicated server.\n");
		}
		break;
	default:
		ResetMenu();
		break;
	}
}

void NMenu::AIPercentMenu()
{
	switch(CurrentMenuChoice)
	{
	case 1:
		SetNewMenu(MeleePercentMenuType);
		break;
	case 2:
		SetNewMenu(TeleportPercentMenuType);
		break;
	case 3:
		SetNewMenu(FlyPercentMenuType);
		break;
	case 4:
		SetNewMenu(SwoopPercentMenuType);
		break;
	default:
		ResetMenu();
		break;
	}
}

void NMenu::MeleePercentMenu()
{
	if (CurrentMenuChoice <= 8)
		ChangeMeleePercent(GetPercentFromMenu());

	ResetMenu();
}

void NMenu::TeleportPercentMenu()
{
	if (CurrentMenuChoice <= 8)
		ChangeTeleportPercent(GetPercentFromMenu());

	ResetMenu();
}

void NMenu::SwoopPercentMenu()
{
	if (CurrentMenuChoice <= 8)
		ChangeSwoopPercent(GetPercentFromMenu());

	ResetMenu();
}

void NMenu::FlyPercentMenu()
{
	if (CurrentMenuChoice <= 8)
		ChangeFlyPercent(GetPercentFromMenu());

	ResetMenu();
}

void NMenu::ChatPercentMenu()
{
	if (CurrentMenuChoice <= 8)
		ChangeChatPercent(GetPercentFromMenu());

	ResetMenu();
}

void NMenu::TauntPercentMenu()
{
	if (CurrentMenuChoice <= 8)
		ChangeTauntPercent(GetPercentFromMenu());

	ResetMenu();
}

void NMenu::WhinePercentMenu()
{
	if (CurrentMenuChoice <= 8)
		ChangeWhinePercent(GetPercentFromMenu());

	ResetMenu();
}

void NMenu::TagPercentMenu()
{
	if (CurrentMenuChoice <= 8)
		ChangeChatTagPercent(GetPercentFromMenu());

	ResetMenu();
}

void NMenu::DropPercentMenu()
{
	if (CurrentMenuChoice <= 8)
		ChangeChatDropPercent(GetPercentFromMenu());

	ResetMenu();
}

void NMenu::SwapPercentMenu()
{
	if (CurrentMenuChoice <= 8)
		ChangeChatSwapPercent(GetPercentFromMenu());

	ResetMenu();
}

void NMenu::LowerPercentMenu()
{
	if (CurrentMenuChoice <= 8)
		ChangeChatLowerPercent(GetPercentFromMenu());

	ResetMenu();
}

void NMenu::SBotLaserPercentMenu()
{
	if (CurrentMenuChoice <= 8)
		ChangeSBotLaserPercent(GetPercentFromMenu());

	ResetMenu();
}

void NMenu::BotSkillMenu()
{
	char *SkillMsg[5] =
	{
		"Best",
		"Good",
		"Medium",
		"Weak",
		"Bad"
	};

	char Msg[50] = "";

	int NewSkill;
    int i;

	if ((CurrentMenuChoice >= 1) && (CurrentMenuChoice <= 5))
		NewSkill = CurrentMenuChoice;
	else if (CurrentMenuChoice == 6)
		NewSkill = 2;
	else
	{
		ResetMenu();
		return;
	}

	default_bot_skill = NewSkill;

    for (i = 0;i<=31;i++)  
	{
		if (bots[i].SBotType < 1)
			bots[i].bot_skill = NewSkill-1;
	}

	CVAR_SET_FLOAT("bot_skill", NewSkill-1);
    
	sprintf(Msg, "Skill for every bot is now: %s\n", SkillMsg[NewSkill - 1]);
	UTIL_Printf(Msg);

	ResetMenu();
}

void NMenu::AggressionLevelMenu()
{
	AggressionLevel_e ALevel;
	char msg[25] = "";
	char AggrLev[15] = "";
	int i;

	switch(CurrentMenuChoice)
	{
	case 1:
		ALevel = Defensive;
		strcpy(AggrLev, "Defensive");
		break;
	case 2:
		ALevel = Normal;
		strcpy(AggrLev, "Normal");
		break;
	case 3:
		ALevel = Aggressive;
		strcpy(AggrLev, "Aggressive");
		break;
	default:
		ResetMenu();
		return;
	}

	for (i=0;i<32;i++)
	{
		bots[i].AggressionLevel = ALevel;
	}
			  
	for (i=0;i<9;i++)
		BotPersonalities[i].aggression_level = ALevel;

	sprintf(msg, "Aggression level of every bot is now %s\n", AggrLev);
	UTIL_Printf(msg);

	ResetMenu();
}

void NMenu::FollowToggleMenu()
{
	if ((CurrentMenuChoice == 1) || (CurrentMenuChoice == 2))
		follow_mode = ToggleAVar(FollowEnabledMessage, FollowDisabledMessage);

	ResetMenu();
}

void NMenu::ChatToggleMenu()
{
	if ((CurrentMenuChoice == 1) || (CurrentMenuChoice == 2))
		should_bot_chat = ToggleAVar(ChatEnabledMessage, ChatDisabledMessage);

	ResetMenu();
}

void NMenu::BotDontShootToggleMenu()
{
	if ((CurrentMenuChoice == 1) || (CurrentMenuChoice == 2))
		b_botdontshoot = ToggleAVar(BotDontShootEnabledMessage, BotDontShootDisabledMessage);

	ResetMenu();
}

void NMenu::BotDontSearchEnemiesToggleMenu()
{
	if ((CurrentMenuChoice == 1) || (CurrentMenuChoice == 2))
		BotDontSearchEnemy = ToggleAVar(BotDontSearchEnemiesEnabledMessage,
							  BotDontSearchEnemiesDisabledMessage);

	ResetMenu();
}

void NMenu::ObserverToggleMenu()
{
	if ((CurrentMenuChoice == 1) || (CurrentMenuChoice == 2))
		b_observer_mode = ToggleAVar(ObserverEnabledMessage, ObserverDisabledMessage);

	ResetMenu();
}

void NMenu::BotsMoveToggleMenu()
{
	if ((CurrentMenuChoice == 1) || (CurrentMenuChoice == 2))
		BotShouldMove = ToggleAVar(BotsMoveEnabledMessage, BotsMoveDisabledMessage);

	ResetMenu();
}

void NMenu::DrawTraceLinesToggleMenu()
{
	if ((CurrentMenuChoice == 1) || (CurrentMenuChoice == 2))
		DrawTraceLines = ToggleAVar(DrawTraceLinesEnabledMessage, DrawTraceLinesDisabledMessage);

	ResetMenu();
}

void NMenu::DiscUsageToggleMenu()
{
	if ((CurrentMenuChoice == 1) || (CurrentMenuChoice == 2))
		BotsUseDiscs = ToggleAVar(DiscUsageEnabledMessage, DiscUsageDisabledMessage);

	ResetMenu();
}

void NMenu::BalanceTeamsToggleMenu()
{
	if ((CurrentMenuChoice == 1) || (CurrentMenuChoice == 2))
		BalanceTeams = ToggleAVar(BotBalanceTeamsEnabledMessage, BotBalanceTeamsDisabledMessage);

	ResetMenu();
}

bool NMenu::ToggleAVar(const char *szEnableText, const char *szDisableText)
{
	if (CurrentMenuChoice == 1)
	{
		cout << szEnableText;
		return true;
	}
	else
	{
		cout << szDisableText;
		return false;
	}
}

short NMenu::GetPercentFromMenu()
{
	switch (CurrentMenuChoice)
	{
	case 1:
		return 100;
	case 2:
		return RANDOM_LONG(80, 99);
	case 3:
		return RANDOM_LONG(60, 80);
	case 4:
		return RANDOM_LONG(40, 60);
	case 5:
		return RANDOM_LONG(20, 40);
	case 6:
		return RANDOM_LONG(1, 20);
	case 7:
		return 0;
	case 8:
		return RANDOM_LONG(0, 100);
	}
	return 0;
}
