//
// HPB bot - botman's High Ping Bastard bot
//
// (http://planethalflife.com/botman/)
//
// bot_start.cpp
//

#include "extdll.h"
#include "util.h"
#include "cbase.h"

#include "bot.h"
#include "bot_func.h"
#include "bot_weapons.h"

extern edict_t *pent_info_ctfdetect;

extern int max_team_players[4];
extern int team_class_limits[4];

extern bool isesfteamplay;

void BotStartGame( bot_t *pBot )
{
   char c_team[32];
   char c_class[32];

   int index, retry_count;

   edict_t *pPlayer;
   int team;
   static FILE *fp;

   edict_t *pEdict = pBot->pEdict;


   if (pBot->start_action == MSG_MOTD)
   {
	   pBot->pEdict->v.button = IN_ATTACK;
	   return;
   }
  
   if ((pBot->start_action == MSG_IDLE) &&
       (pBot->create_time + 3.0 <= gpGlobals->time))
   {
	   pBot->start_action = MSG_TEAM_SELECT;  // force team selection
   }

   if (pBot->start_action == MSG_TEAM_SELECT)
   {
	     isesfteamplay = TRUE;
         pBot->start_action = MSG_IDLE;  // switch back to idle
         pBot->create_time = gpGlobals->time;  // reset

         if ((pBot->bot_team != 1) && (pBot->bot_team != 2)) 
            pBot->bot_team = -1;

         if (pBot->bot_team == -1)
         {
			 int CountGood, CountEvil;
			 CountGood = CountEvil = 0;

			 for(index=1;index<=gpGlobals->maxClients;index++)
			 {
				pPlayer = INDEXENT(index);
				if (UTIL_IsValidPlayer(pPlayer), false)
				{
					if (UTIL_GetTeam(pPlayer) == 0)
						CountGood++;
					else
						CountEvil++;
				}
			 }

			 if (CountGood > CountEvil)
				pBot->bot_team = 2;
			 else if (CountGood < CountEvil)
				pBot->bot_team = 1;
			 else
				pBot->bot_team = RANDOM_LONG(1, 2);
		 }

         retry_count = 0;

         // select the team the bot wishes to join...
         if (pBot->bot_team == 1)
            strcpy(c_team, "1");
         else if (pBot->bot_team == 2)
            strcpy(c_team, "2");
         else 
            strcpy(c_team, "5");

         FakeClientCommand(pEdict, "jointeam", c_team, NULL);
         pBot->start_action = MSG_CLASS_SELECT;
         return;
      }

      if (pBot->start_action == MSG_CLASS_SELECT)
      {
         char *cvar_realteams = (char *)CVAR_GET_STRING("mp_realteams");
		 pBot->start_action = MSG_IDLE;  // switch back to idle
         pBot->create_time = gpGlobals->time;  // reset

         if ((pBot->bot_class < 1) || (pBot->bot_class > 9))
            pBot->bot_class = -1;

         if (pBot->bot_class == -1)
            pBot->bot_class = RANDOM_LONG(1, 9);

         team = UTIL_GetTeam(pEdict);

         if ((cvar_realteams && cvar_realteams[0]) && (strncmp(cvar_realteams, "1", 1) == 0) && (isesfteamplay))
         {
			 if (pBot->bot_team == 1)
			 {
				 if ((pBot->bot_class != 2) && (pBot->bot_class != 3) && (pBot->bot_class != 4) &&
					 (pBot->bot_class != 6) && (pBot->bot_class != 7))
				 {
					 if (RANDOM_LONG(1, 2) < 2)
						 pBot->bot_class = RANDOM_LONG(2, 4);
					 else
						 pBot->bot_class = RANDOM_LONG(6, 7);
				 }
			 }
			 else
			 {
				 if ((pBot->bot_class != 1) && (pBot->bot_class != 5) && (pBot->bot_class != 8) &&
					 (pBot->bot_class != 9))
				 {
					 int i = RANDOM_LONG(1, 3);

                     switch (i)
					 {
					 case 1:
     					 pBot->bot_class = 1;
						 break;
					 case 2:
						 pBot->bot_class = 5;
						 break;
					 case 3:
						 pBot->bot_class = RANDOM_LONG(8, 9);
						 break;
					 default:
						 break;
					 }
				 }
			 }
		 }

         // select the class the bot wishes to use...
         if (pBot->bot_class == 1)
            strcpy(c_class, "buu");
         else if (pBot->bot_class == 2)
            strcpy(c_class, "goku");
         else if (pBot->bot_class == 3)
            strcpy(c_class, "gohan");
         else if (pBot->bot_class == 4)
            strcpy(c_class, "krillin");
         else if (pBot->bot_class == 5)
            strcpy(c_class, "frieza");
         else if (pBot->bot_class == 6)
            strcpy(c_class, "piccolo");
         else if (pBot->bot_class == 7)
            strcpy(c_class, "trunks");
         else if (pBot->bot_class == 8)
            strcpy(c_class, "vegeta");
         else if (pBot->bot_class == 9)
            strcpy(c_class, "cell");
	     else 
	        strcpy(c_class, "randompc");

         FakeClientCommand(pEdict, c_class, NULL, NULL);

         // bot has now joined the game (doesn't need to be started)
         pBot->not_started = 0;

         return;
      }
}

