/////////////////////////////////////////////////////////
//			Combo.cpp for simple bot tricks
//			Current code-style SUXX
/////////////////////////////////////////////////////////

#include "general_header.h"

extern edict_t *listenserver_edict;
extern bool debug_mode;
extern int bot_teleport_percent;

BotCombo::~BotCombo()
{
	Delete_Combos(ComboList);
}

void BotCombo::Delete_Combos(ComboList_t *CL)
{
	if (debug_mode)
		ClientPrint(listenserver_edict,HUD_PRINTNOTIFY,"DelCombo\n");

	if (CL != NULL)
	{
		Delete_Combos(CL->next);
		delete CL;
		CL = NULL;
	}
}//kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib 

// __sbh_alloc_block    ;   _heap_alloc    ;   _nh_malloc
// __sbh_free_block		;	free

void BotCombo::AddCombo(ComboList_t *CL)
{
	if (!ComboList)
	{
		ComboList = new ComboList_t;
		ComboList->ComboAction = CL->ComboAction;
		ComboList->TeleDir = CL->TeleDir;
		ComboList->delay = CL->delay;
		ComboList->TeleDelay = CL->TeleDelay + ComboList->delay;
		ComboList->LifeTime = CL->LifeTime + ComboList->delay;
		ComboList->poweruptime = CL->poweruptime + ComboList->delay;
		ComboList->next = NULL;

		CurrentCombo = ComboList;
		LastCombo = ComboList;

		/*char bleh[400] = "";
		sprintf(bleh, "ComboList: \n\n"
				"combo delay: %f\n"
				"TeleDelay: % f\n"
				"LifeTime: %f\n"
				"poweruptime: %f\n"
				"gpGlobals->time: %f",
				CurrentCombo->delay,CurrentCombo->TeleDelay,CurrentCombo->LifeTime,
				CurrentCombo->poweruptime,gpGlobals->time);

		ClientPrint(listenserver_edict,HUD_PRINTNOTIFY,bleh);

		fp = fopen("bot.txt","a");
		fprintf(fp, "\nAddCombo\n");
		fprintf(fp, bleh);
		fclose(fp);*/

		return;
	}

	if (debug_mode)
		ClientPrint(listenserver_edict,HUD_PRINTNOTIFY,"AddCombo\n");

    if(LastCombo!=NULL)
	{
		while(LastCombo->next!=NULL)
		{
			LastCombo=LastCombo->next;   
		}

		LastCombo->next = new ComboList_t;
		LastCombo=LastCombo->next; //Points to that node
	//	LastCombo = CL;
		LastCombo->next=NULL; //Prevents it from going any further
		LastCombo->ComboAction = CL->ComboAction;
		LastCombo->TeleDir = CL->TeleDir;
		LastCombo->TeleDelay = CL->TeleDelay;
		LastCombo->delay = CL->delay;
		LastCombo->LifeTime = CL->LifeTime;
		LastCombo->poweruptime = CL->poweruptime;
	}
}

bool BotCombo::PushCombo()
{
	if (debug_mode)
		ClientPrint(listenserver_edict,HUD_PRINTNOTIFY,"PushCombo\n");

	if (CurrentCombo->next)
	{
		CurrentCombo = CurrentCombo->next;
		CurrentCombo->delay = CurrentCombo->delay + gpGlobals->time;
		CurrentCombo->TeleDelay = CurrentCombo->TeleDelay + CurrentCombo->delay;
		CurrentCombo->LifeTime = CurrentCombo->LifeTime + CurrentCombo->delay;
		CurrentCombo->poweruptime = CurrentCombo->poweruptime + CurrentCombo->delay;
		CurrentCombo->StartTime = CurrentCombo->delay;

/*		char bleh[400] = "";
		sprintf(bleh, "PushCombo\n\n"
				"combo delay: %f\n"
				"TeleDelay: % f\n"
				"LifeTime: %f\n"
				"poweruptime: %f\n"
				"gpGlobals->time: %f",
				CurrentCombo->delay,CurrentCombo->TeleDelay,CurrentCombo->LifeTime,
				CurrentCombo->poweruptime,gpGlobals->time);

		ClientPrint(listenserver_edict,HUD_PRINTNOTIFY,bleh);

		fp = fopen("bot.txt","a");
		fprintf(fp, "\nPushCombo\n");
		fprintf(fp, bleh);
		fclose(fp);*/

		return true;
	}

	return false;
}

void BotCombo::DoCombo()
{
	float dist = 0.0;

	if (state==done)
		return;

	if (!ComboList)
	{
		state=done;
		return;
	}

	if ((CurrentCombo->delay > gpGlobals->time) && (!pBot->pBotClient->Swoops))
	{
		pBot->f_move_speed = 0.0;
		pBot->f_strafe_speed = 0.0;
		pBot->f_updown_speed = 0.0;

		return;
	}

	if (debug_mode)
		ClientPrint(listenserver_edict,HUD_PRINTNOTIFY,"DoCombo\n");

	edict_t *pEdict = pBot->pEdict;

	int TeleDir = CurrentCombo->TeleDir;
	short MinKiLevel;

	switch(CurrentCombo->ComboAction)
	{
	case teleport1:
		if (pBot->pBotEnemy)
			pBot->AimVec = WrapAngles(UTIL_VecToAngles(BotBodyTarget(pBot->pBotEnemy,pBot) - 
									  pEdict->v.origin));

		ResetMoveSpeed(pBot);
		SetMoveDir(pBot, TeleDir);

		if ((CurrentCombo->TeleDelay < gpGlobals->time) ||
			(pBot->DangerLevel >= DANGER_HEAVY_MIN_VAL))
		{
			FakeClientCommand(pEdict,"teleport",NULL,NULL);
			if (!PushCombo())
				state = done;
		}

		break;
	case teleport2:
		if (debug_mode)
		{	char s[100] = "";
			sprintf(s,"teledelay: %f\n",(CurrentCombo->TeleDelay-gpGlobals->time));
			ClientPrint(listenserver_edict,HUD_PRINTNOTIFY,s);
		}

		pBot->f_move_speed = 0.0;
		pBot->f_strafe_speed = 0.0;
		pBot->f_updown_speed = 0.0;

		if (TeleDir & dir_forward)
			pBot->f_move_speed = pBot->f_max_speed;
		if (TeleDir & dir_back)
			pBot->f_move_speed = -pBot->f_max_speed;
		if (TeleDir & dir_left)
			pBot->f_strafe_speed = -pBot->f_max_speed/2;
		if (TeleDir & dir_right)
			pBot->f_strafe_speed = pBot->f_max_speed/2;
		if (TeleDir & dir_up)
			pBot->f_updown_speed = pBot->f_max_speed/2;
		if (TeleDir & dir_down)
			pBot->f_updown_speed = -pBot->f_max_speed/2;

	//	pBot->f_move_speed = -pBot->f_max_speed;

//		if ((CurrentCombo->TeleDelay - gpGlobals->time) > 1.0)
//			CurrentCombo->TeleDelay = gpGlobals->time + 1.0;

		if ((CurrentCombo->TeleDelay < gpGlobals->time) ||
			(pBot->DangerLevel >= DANGER_HEAVY_MIN_VAL))
		{
			FakeClientCommand(pEdict,"teleport",NULL,NULL);
			if (!PushCombo())
				state = done;
		}

		break;
	case teleport3:

		pBot->f_move_speed = 0.0;
		pBot->f_strafe_speed = 0.0;
		pBot->f_updown_speed = 0.0;

		if (!pBot->pBotEnemy)
		{
			state = done;
			return;
		}

		if (PlayerSwoops(pBot->pBotEnemy))
		{
			if (!PushCombo())
				state = done;
			return;
		}

		pBot->AimVec = WrapAngles(UTIL_VecToAngles(BotBodyTarget(pBot->pBotEnemy,pBot) - 
								  pEdict->v.origin));

		if (TeleDir & dir_forward)
			pBot->f_move_speed = pBot->f_max_speed;
		if (TeleDir & dir_back)
			pBot->f_move_speed = -pBot->f_max_speed;
		if (TeleDir & dir_left)
			pBot->f_strafe_speed = -pBot->f_max_speed/2;
		if (TeleDir & dir_right)
			pBot->f_strafe_speed = pBot->f_max_speed/2;
		if (TeleDir & dir_up)
			pBot->f_updown_speed = pBot->f_max_speed/2;
		if (TeleDir & dir_down)
			pBot->f_updown_speed = -pBot->f_max_speed/2;

	//	pBot->f_move_speed = -pBot->f_max_speed;

//		if ((CurrentCombo->TeleDelay - gpGlobals->time) > 1.0)
//			CurrentCombo->TeleDelay = gpGlobals->time + 1.0;

		if ((CurrentCombo->TeleDelay < gpGlobals->time) ||
			(pBot->DangerLevel >= DANGER_HEAVY_MIN_VAL))
		{
			FakeClientCommand(pEdict,"teleport",NULL,NULL);
			if (!PushCombo())
				state = done;
		}

		break;
	case EscapeTeleport:
		ResetMoveSpeed(pBot);

		if (pBot->pBotEnemy)
			pBot->AimVec = WrapAngles(UTIL_VecToAngles(BotBodyTarget(pBot->pBotEnemy,pBot) - 
									  pEdict->v.origin));

		// Didn't checked for a teledir?
		if (TeleDir == 0)
		{
			TMultiChoice<int> TeleDirChoices;

			// Less chance for left & right since this doesn't confuse the enemy very much
			if (CheckForCollide(pEdict, dir_left, 350.0f) == false)
				TeleDirChoices.Insert(dir_left, 30);

			if (CheckForCollide(pEdict, dir_right, 350.0f) == false)
				TeleDirChoices.Insert(dir_right, 30);

			// More chance for up & down teleport because it confuses the enemy more :)
			if (CheckForCollide(pEdict, dir_up, 650.0f) == false)
				TeleDirChoices.Insert(dir_up, 75);
	
			if (CheckForCollide(pEdict, dir_down, 650.0f) == false)
				TeleDirChoices.Insert(dir_down, 75);

			if (CheckForCollide(pEdict, dir_left_back, 650.0f) == false)
				TeleDirChoices.Insert((dir_back | dir_left), 40);

			if (CheckForCollide(pEdict, dir_right_back, 650.0f) == false)
				TeleDirChoices.Insert((dir_back | dir_right), 40);

			if (CheckForCollide(pEdict, dir_back, 650.0f) == false)
				TeleDirChoices.Insert(dir_back, 40);
 
			if (TeleDirChoices.GetSelection(CurrentCombo->TeleDir) == false) // No valid choice?
				CurrentCombo->TeleDir = dir_back; // Just go back...
		}

		SetMoveDir(pBot, CurrentCombo->TeleDir);

		if ((CurrentCombo->TeleDelay <= gpGlobals->time) ||
			(pBot->DangerLevel >= DANGER_HEAVY_MIN_VAL))
		{
			FakeClientCommand(pEdict,"teleport",NULL,NULL);
			if (!PushCombo())
				state = done;
		}

		break;
	case startswoop:
		  if (debug_mode)
			  ClientPrint(listenserver_edict,HUD_PRINTNOTIFY,"startswoop\n");

          if (pBot->pBotClient->Swoops)
	      {
		      if (!PushCombo())
			     state = done;
	      }
	      else if (CurrentCombo->LifeTime < gpGlobals->time)
	      {
		       state = done;
	      }
		  else if ((pBot->bot_ki < 300) && (pBot->SBotType < 1))
		  {
			  state = done;
		  }
          else if (pBot->pBotEnemy)
		  {
			  pBot->AimVec = WrapAngles(UTIL_VecToAngles(BotBodyTarget(pBot->pBotEnemy,pBot) - 
										pEdict->v.origin));

	          pEdict->v.idealpitch = UTIL_WrapAngle(pBot->AimVec.x);
	          pEdict->v.ideal_yaw = UTIL_WrapAngle(pBot->AimVec.y);
   
		      float distance = UTIL_Distance(pEdict->v.origin, pBot->pBotEnemy->v.origin);

              if (RANDOM_LONG(0, 100) < 30)
				  pEdict->v.button = IN_ATTACK;

		      if (distance < RANDOM_LONG(2200, 2420))
			      pBot->f_move_speed = -pBot->f_max_speed;
		      else
		 	      pBot->f_move_speed = pBot->f_max_speed;

		    if (pBot->DangerLevel == danger_heavy)
		    {
		 	   state = done;
			   return;
		    }
		  }
		  else
		  {
			  state = done;
		  }
	     
		  break;

	case stopfly:
		if (debug_mode)
			ClientPrint(listenserver_edict,HUD_PRINTNOTIFY,"stopfly\n");

		if ((pEdict->v.gravity > 0.1) || (CurrentCombo->LifeTime < gpGlobals->time))
		{
		    if (!PushCombo())
			 state = done;
			return;
	    }
		else
			FakeClientCommand(pEdict,"togglefly",NULL,NULL);
		break;
	
	case teleswoop1:
		if (debug_mode)
			ClientPrint(listenserver_edict,HUD_PRINTCENTER,"teleswoop1\n");

		ResetMoveSpeed(pBot);
		SetMoveDir(pBot, dir_forward);

		if ((pBot->pBotEnemy == NULL) || (pBot->pBotClient->Swoops == false))
		{
			state = done;
			FinishingTask = TaskNone;
		}
		else
		{
			float MinDist = (PlayerSwoops(pBot->pBotEnemy)) ? 600.0f : 450.0f;
			if (UTIL_Distance(pEdict->v.origin, pBot->pBotEnemy->v.origin) < MinDist)
	      	{
				if (!PushCombo())
					state = done;
				FakeClientCommand(pEdict, "togglefly", NULL, NULL);
	      	}
			else
			{
	 		    pBot->AimVec = WrapAngles(UTIL_VecToAngles(BotBodyTarget(pBot->pBotEnemy,pBot) - 
										  pEdict->v.origin));

				if (PlayerSwoops(pBot->pBotEnemy))
				{
					if (pBot->wander_dir == WANDER_LEFT)
						pBot->AimVec.y = UTIL_WrapAngle(pBot->AimVec.y + 30.0f);
					else
						pBot->AimVec.y = UTIL_WrapAngle(pBot->AimVec.y - 30.0f);
				}

				if (pBot->bot_skill == 0)
					AvoidAttackWhenSwoop(pBot);
			}
		}
		break;

	case kickenemy:
		if (!pBot->pBotEnemy)
		{
			state = done;
			FinishingTask = TaskNone;
			return;
		}
		dist = UTIL_Distance(pEdict->v.origin,pBot->pBotEnemy->v.origin);

		if (dist > 300)
		{
			state = done;
			FinishingTask = TaskNone;
			return;
		}

		if (CurrentCombo->LifeTime < gpGlobals->time)
      	{
	    	if (!PushCombo())
		  	   state = done;
			return;
      	}
		else
		{
			if (pEdict->v.playerclass == 7)
			{
         		if (pBot->current_weapon.iId != ESF_WEAPON_SWORD)
		           	UTIL_SelectItem(pEdict, "weapon_sword");
			}
			else
			{
         		if (pBot->current_weapon.iId != ESF_WEAPON_MELEE)
		           	UTIL_SelectItem(pEdict, "weapon_melee");
			}

			pEdict->v.button |= IN_ATTACK2;

			pBot->AimVec = WrapAngles(UTIL_VecToAngles(BotBodyTarget(pBot->pBotEnemy,pBot) - 
									  pEdict->v.origin));

			if (pBot->bot_skill < 2)
				ToggleTurbo(pEdict, true);
/*
			if (dist < 30)
				pBot->f_move_speed = -pBot->f_max_speed;
			else if (dist > 100)
				pBot->f_move_speed = pBot->f_max_speed;
			else
			{
				if (RANDOM_LONG(0,1))
					pBot->f_move_speed = pBot->f_max_speed;
				else
					pBot->f_move_speed = -pBot->f_max_speed;
			}

			if (RANDOM_LONG(1, 100) < 20)
			{
				if (RANDOM_LONG(1, 5) < 2)
				{
					if (RANDOM_LONG(0, 1))
						pBot->f_strafe_speed = pBot->f_max_speed/2.0;
					else
						pBot->f_strafe_speed = -pBot->f_max_speed/2.0;
				}
				if (RANDOM_LONG(1, 5) < 2)
				{
					if (RANDOM_LONG(0, 1))
						pBot->f_updown_speed = pBot->f_max_speed/2.0;
					else
						pBot->f_updown_speed = -pBot->f_max_speed/2.0;
				}
			}*/
		}
		break;
						
	case powerup:
		if ((!pBot->BotPowerUps) && (RANDOM_LONG(1,100) < 50))
			FakeClientCommand(pEdict,"+powerup",NULL,NULL);

		MinKiLevel = 990;

		if (UTIL_IsValidEnemy(pBot, pBot->pBotEnemy))
		{
			float flDist = UTIL_Distance(pEdict->v.origin, pBot->pBotEnemy->v.origin);
			if (flDist < 1250.0f)
			{
				switch (pBot->AggressionLevel)
				{
				case Aggressive:
					MinKiLevel = 700;
					break;
				case Normal:
					MinKiLevel = 750;
					break;
				case Defensive:
					MinKiLevel = 800;
					break;
				}
			}

			pBot->AimVec = WrapAngles(UTIL_VecToAngles(pBot->pBotEnemy->v.origin - pEdict->v.origin));
		}

#ifdef USE_NEW_BOT_SENSE
		if (pBot->DangerLevel >= DANGER_MEDIUM_MIN_VAL)
#else
		if (pBot->DangerLevel >= danger_medium)
#endif
		{
#ifdef USE_NEW_BOT_SENSE
			if (pBot->DangerLevel <= DANGER_MEDIUM_MAX_VAL)
				MinKiLevel = 100; // hurry up
			else
				MinKiLevel = 20;

#else			
			switch (pBot->DangerLevel)
			{
			case danger_light:
				MinKiLevel = 900;
				break;
			case danger_medium:
				MinKiLevel = 100; // hurry up
				break;
			case danger_hard:
			case danger_heavy:
				MinKiLevel = 20;
				break;
			}
#endif
		}

		pBot->f_move_speed = 0.0;

		if (pBot->bot_ki > MinKiLevel)
		{
			FakeClientCommand(pEdict, "-powerup", NULL, NULL);
	    	if (!PushCombo())
				state = done;
			return;
		}
		
		break;

	case pressforward:
		pEdict->v.button = IN_FORWARD;
		pBot->f_move_speed = pBot->f_max_speed;
		pBot->f_strafe_speed = 0.0;
		pBot->f_updown_speed = 0.0;

		if (pBot->pBotClient->Swoops)
		{
			pBot->TaskAfterTask = TaskSwoop;
			state = done;
			return;
		}

		if (pBot->pBotEnemy)
		{
			pBot->AimVec = WrapAngles(UTIL_VecToAngles(BotBodyTarget(pBot->pBotEnemy,pBot) - 
													   pEdict->v.origin));
			
			// Check if the bot isn't facing the enemy and the enemy isn't facing the bot
			if ((pBot->prev_speed == 0.0f) &&
				(EntIsInFieldOfView(pEdict, pBot->pBotEnemy) == false) &&
				(EntIsInFieldOfView(pBot->pBotEnemy, pEdict) == false))
				ResetMoveSpeed(pBot); // Give the bot some time to aim at his enemy.
		}

		if ((CurrentCombo->LifeTime < gpGlobals->time) ||
			(pBot->DangerLevel >= DANGER_HEAVY_MIN_VAL))
		{
			if (!PushCombo())
				state = done;
		}
		break;
	case pressforward2:
		if (pBot->pBotEnemy)
			pBot->AimVec = WrapAngles(UTIL_VecToAngles(BotBodyTarget(pBot->pBotEnemy,pBot) - 
													   pEdict->v.origin));

		pEdict->v.button = IN_FORWARD;
		pBot->f_move_speed = pBot->f_max_speed;
		pBot->f_strafe_speed = 0.0;
		pBot->f_updown_speed = 0.0;

		if (pBot->pBotClient->Swoops)
		{
			if (!PushCombo())
				state = done;	
			return;
		}

		if (CurrentCombo->LifeTime < gpGlobals->time)
		{
			if (!PushCombo())
				state = done;
		}
		break;
	case pressback:
		if (pBot->pBotEnemy)
			pBot->AimVec = WrapAngles(UTIL_VecToAngles(BotBodyTarget(pBot->pBotEnemy,pBot) - 
													   pEdict->v.origin));

		pEdict->v.button = IN_BACK;
		pBot->f_move_speed = -pBot->f_max_speed;
		pBot->f_strafe_speed = 0.0;
		pBot->f_updown_speed = 0.0;

		if (CurrentCombo->LifeTime < gpGlobals->time)
		{
			if (!PushCombo())
				state = done;
		}

		// Does the bot after 0.2 secs still not swoop?
		if ((pBot->pBotClient->Swoops == false) && 
			((gpGlobals->time - CurrentCombo->StartTime) > 0.2))
		{
			state = done;
		}

		break;
	case pressleft:
		if (pBot->pBotEnemy)
			pBot->AimVec = WrapAngles(UTIL_VecToAngles(BotBodyTarget(pBot->pBotEnemy,pBot) - 
													   pEdict->v.origin));

		pEdict->v.button = IN_MOVELEFT;
		pBot->f_move_speed = 0.0;
		pBot->f_strafe_speed = -pBot->f_max_speed;
		pBot->f_updown_speed = 0.0;

		if (CurrentCombo->LifeTime < gpGlobals->time)
		{
			if (!PushCombo())
				state = done;
		}

		// Does the bot after 0.2 secs still not swoop?
		if ((pBot->pBotClient->Swoops == false) && 
			((gpGlobals->time - CurrentCombo->StartTime) > 0.2))
		{
			state = done;
		}
		
		break;
	case pressright:
		if (pBot->pBotEnemy)
			pBot->AimVec = WrapAngles(UTIL_VecToAngles(BotBodyTarget(pBot->pBotEnemy,pBot) - 
													   pEdict->v.origin));

		pEdict->v.button = IN_MOVERIGHT;
		pBot->f_move_speed = 0.0;
		pBot->f_strafe_speed = pBot->f_max_speed;
		pBot->f_updown_speed = 0.0;

		if (CurrentCombo->LifeTime < gpGlobals->time)
		{
			if (!PushCombo())
				state = done;
		}

		// Does the bot after 0.2 secs still not swoop?
		if ((pBot->pBotClient->Swoops == false) && 
			((gpGlobals->time - CurrentCombo->StartTime) > 0.2))
		{
			state = done;
		}
		
		break;
	case pressjump:
		if (pBot->pBotEnemy)
			pBot->AimVec = WrapAngles(UTIL_VecToAngles(BotBodyTarget(pBot->pBotEnemy,pBot) - 
													   pEdict->v.origin));

		pEdict->v.button = IN_JUMP;
		pBot->f_move_speed = 0.0;
		pBot->f_strafe_speed = 0.0;
		pBot->f_updown_speed = pBot->f_max_speed;

		if (CurrentCombo->LifeTime < gpGlobals->time)
		{
			if (!PushCombo())
				state = done;
		}

		// Does the bot after 0.2 secs still not swoop?
		if ((pBot->pBotClient->Swoops == false) && 
			((gpGlobals->time - CurrentCombo->StartTime) > 0.2))
		{
			state = done;
		}
		
		break;
	case pressduck:
		if (pBot->pBotEnemy)
			pBot->AimVec = WrapAngles(UTIL_VecToAngles(BotBodyTarget(pBot->pBotEnemy,pBot) - 
													   pEdict->v.origin));

		pEdict->v.button = IN_DUCK;
		pBot->f_move_speed = 0.0;
		pBot->f_strafe_speed = 0.0;
		pBot->f_updown_speed = -pBot->f_max_speed;

		if (CurrentCombo->LifeTime < gpGlobals->time)
		{
			if (!PushCombo())
				state = done;
		}

		// Does the bot after 0.2 secs still not swoop?
		if ((pBot->pBotClient->Swoops == false) && 
			((gpGlobals->time - CurrentCombo->StartTime) > 0.2))
		{
			state = done;
		}
		
		break;
	case falldown:
		if ((CurrentCombo->LifeTime < gpGlobals->time) || (pEdict->v.flags & FL_ONGROUND))
		{
			if (!PushCombo())
				state = done;
		}

		if (pEdict->v.gravity < 0.1)
			FakeClientCommand(pEdict, "togglefly", NULL, NULL);

		pBot->ShouldFly = false;
		pBot->CheckFlyDelay = gpGlobals->time + 1.2;
		break;
	case ascend:
		FakeClientCommand(pEdict, "ascend", NULL, NULL);

		if (!PushCombo())
			state = done;

		break;
	case CheckFOVForAim:
		if (!pBot->pBotEnemy)
		{
			if (!PushCombo())
				state = done;
		}
		else if (pBot->DangerLevel >= DANGER_HARD_MIN_VAL)
		{
			if (!PushCombo())
				state = done;
		}
		else if ((EntIsInFieldOfView(pEdict, pBot->pBotEnemy)) ||
			     (EntIsInFieldOfView(pBot->pBotEnemy, pEdict)))
		{
			if (!PushCombo())
				state = done;
		}
		else if (CurrentCombo->LifeTime < gpGlobals->time)
		{
			if (!PushCombo())
				state = done;
		}
		else
		{
#ifdef _DEBUG
			lcout << "Stop moving for aim\n";
#endif
			ResetMoveSpeed(pBot);
			pBot->AimVec = WrapAngles(UTIL_VecToAngles(BotBodyTarget(pBot->pBotEnemy,pBot) - 
													   pEdict->v.origin));
		}
		break;

	case ChargeGenBall:
		if (!pBot->pBotEnemy)
		{
			if (!PushCombo())
				state = done;
		}
		else if (pBot->DangerLevel >= DANGER_HARD_MIN_VAL)
		{
			if (!PushCombo())
				state = done;
		}
		else if (pBot->ChargeBeamVal >= 60)
		{
			if (!PushCombo())
				state = done;
		}
		else
		{
#ifdef _DEBUG
			lcout << "Charging gen ball\n";
#endif
			pBot->AimVec = WrapAngles(UTIL_VecToAngles(BotBodyTarget(pBot->pBotEnemy,pBot) - 
													   pEdict->v.origin));

			if (pBot->current_weapon.iId != ESF_WEAPON_GENERIC_BEAM)
				UTIL_SelectItem(pEdict, "weapon_genericbeam");

			pEdict->v.button |= IN_ATTACK2;
			SetMoveDir(pBot, dir_back);
		}
		break;
	}
}

void BotCombo::MakeComboList(ComboTypes CT)
{
	if (debug_mode)
		ClientPrint(listenserver_edict,HUD_PRINTNOTIFY,"makelist\n");

	int prev=-1, RandNr, i;
	int TeleTimes=0;
	int TeleDir = 0;

	bool not_done = true;

	ComboList_t *CL = NULL;
	switch (CT)
	{
	case TeleLeftBackMelee:
	case TeleRightBackMelee:
	case TeleBackMelee:
	case TeleLeftMelee:
	case TeleRightMelee:
	case TeleUpMelee:
	case TeleDownMelee:
	case TeleForwardLeftMelee:
	case TeleForwardRightMelee:
		if (!pBot->pBotEnemy)
			return;

		CL = new ComboList_t;

		if (CT == TeleLeftBackMelee)
			TeleDir = (dir_left | dir_back);
		else if (CT == TeleRightBackMelee)
			TeleDir = (dir_right | dir_back);
		else if (CT == TeleBackMelee)
			TeleDir = dir_back;
		else if (CT == TeleLeftMelee)
			TeleDir = dir_left;
		else if (CT == TeleRightMelee)
			TeleDir = dir_right;
		else if (CT == TeleUpMelee)
			TeleDir = dir_up;
		else if (CT == TeleDownMelee)
			TeleDir = dir_down;
		else if (CT == TeleForwardLeftMelee)
			TeleDir = (dir_forward | dir_left);
		else if (CT == TeleForwardRightMelee)
			TeleDir = (dir_forward | dir_right);

		CL->ComboAction = teleport1;
		CL->delay = 0.0;
		CL->TeleDelay = 0.35f;
		CL->poweruptime = 0.0;
		CL->TeleDir = TeleDir;
		CL->next = NULL; 
		AddCombo(CL);

		if (UTIL_Distance(pBot->pEdict->v.origin, pBot->pBotEnemy->v.origin) < 350.0f)
		{
			CL->ComboAction = teleport1;
			CL->delay = 0.0;
			CL->TeleDelay = 0.2f;
			CL->poweruptime = 0.0;
			CL->TeleDir = TeleDir;
			CL->next = NULL; 
			AddCombo(CL);
		}

		CL->ComboAction = CheckFOVForAim;
		CL->delay = 0.0f;
		CL->LifeTime = 0.25f;
		CL->next = NULL;
		AddCombo(CL);

		CL->ComboAction = pressforward;
		CL->delay = swoop_begin_delay;
		CL->LifeTime = tap_lifetime;
		CL->next = NULL;
		AddCombo(CL);

		CL->ComboAction = pressforward;
		CL->delay = tap_delay;
		CL->LifeTime = 0.6;
		CL->next = NULL;
		AddCombo(CL);

		delete CL;

		break;

	case MultipleTeleport:
		if ((pBot->DangerLevel == 0) || (pBot->TeleportPercent == 0))
			return;

		TeleTimes = (pBot->DangerLevel / 150) * (pBot->TeleportPercent / 100);
		while ((TeleTimes > 0) && ((TeleTimes*150) > pBot->bot_ki))
			TeleTimes--;

		if (TeleTimes < 1)
			return;
		else if (TeleTimes > 4)
			TeleTimes = 4;

		CL = new ComboList_t;
			
		for (i=0;i<TeleTimes;i++)
		{
			CL->ComboAction = EscapeTeleport;
			CL->delay = 0.0;
			CL->TeleDelay = 0.2f;
			CL->TeleDir = 0;
			CL->next = NULL;
			AddCombo(CL);
		}
		delete CL;
		break;

	case telemelee1:
		if (!pBot->pBotEnemy)
			return;

		TeleTimes = RANDOM_LONG(3, 4);
		while ((TeleTimes) && ((TeleTimes * 165) > pBot->bot_ki))
			TeleTimes--; // Not enough ki

		CL = new ComboList_t;

		if (pBot->wander_dir == WANDER_LEFT)
			TeleDir = dir_left;
		else
			TeleDir = dir_right;

		TeleDir |= dir_forward;

		for (i=0;i<TeleTimes;i++)
		{
			CL->ComboAction = teleport1;
			CL->delay = 0.0;

			if (i == 0)
				CL->TeleDelay = 0.35f;
			else
				CL->TeleDelay = 0.2f;

			CL->poweruptime = 0.0;
			CL->TeleDir = TeleDir;
			CL->next = NULL; 
			AddCombo(CL);
		}

		CL->ComboAction = CheckFOVForAim;
		CL->delay = 0.0f;
		CL->LifeTime = 0.25f;
		CL->next = NULL;
		AddCombo(CL);

		CL->ComboAction = pressforward;
		CL->delay = swoop_begin_delay;
		CL->LifeTime = tap_lifetime;
		CL->next = NULL;
		AddCombo(CL);
		
		CL->ComboAction = pressforward;
		CL->delay = tap_delay;
		CL->LifeTime = 0.6;
		CL->next = NULL;
		AddCombo(CL);

		delete CL;

		break;

	case telemelee2:
		if (!pBot->pBotEnemy)
			return;

		MakePowerup();

		CL = new ComboList_t;

		CL->ComboAction = pressforward2;
		CL->delay = swoop_begin_delay;
		CL->LifeTime = tap_lifetime;
		CL->next = NULL;
		AddCombo(CL);
		
		CL->ComboAction = pressforward2;
		CL->delay = tap_delay;
		CL->LifeTime = 0.6;
		CL->next = NULL;
		AddCombo(CL);
		
		CL->ComboAction = teleswoop1;
		CL->delay = 0.0;
		CL->next = NULL;
		AddCombo(CL);

		CL->ComboAction = teleport1;
		CL->delay = 0.0;
		CL->TeleDelay = 0.25f;
		CL->TeleDir = 0;
		CL->next = NULL; 
		AddCombo(CL);
/*
		if (RANDOM_LONG(1, 100) <= pBot->TeleportPercent)
		{
			CL->ComboAction = teleport2;
			CL->TeleDelay = 0.15;
			CL->TeleDir = dir_forward;
			CL->next = NULL;
			AddCombo(CL);
		}
*/

		CL->ComboAction = CheckFOVForAim;
		CL->delay = 0.0f;
		CL->LifeTime = 0.25f;
		CL->next = NULL;
		AddCombo(CL);

		CL->ComboAction = pressforward;
		CL->delay = swoop_begin_delay;
		CL->LifeTime = tap_lifetime;
		CL->next = NULL;
		AddCombo(CL);
		
		CL->ComboAction = pressforward;
		CL->delay = tap_delay;
		CL->LifeTime = 0.6;
		CL->next = NULL;
		AddCombo(CL);

		delete CL;

		FinishingTask = TaskNone;

		break;

	case telemelee3:
		if (!pBot->pBotEnemy)
			return;

		MakePowerup();

		CL = new ComboList_t;

		TeleTimes = int(UTIL_Distance(pBot->pEdict->v.origin,pBot->pBotEnemy->v.origin))/400;

		if (((int(UTIL_Distance(pBot->pEdict->v.origin,pBot->pBotEnemy->v.origin)) % 400)) > 100)
			TeleTimes += 1;

		RandNr = RANDOM_LONG(0,3);

		if (RandNr == 0)
			TeleDir = dir_left;
		else if (RandNr == 1)
			TeleDir = dir_right;

		if (RandNr <= 1)
			TeleTimes += RANDOM_LONG(1, 2);

		TeleDir |= dir_forward;

		for (i=0;i<TeleTimes;i++)
		{
			CL->ComboAction = teleport3;
			CL->delay = 0.0;
			CL->poweruptime = 0.0;

			if (i == 0)
				CL->TeleDelay = 0.4;
			else
				CL->TeleDelay = 0.25;

			CL->TeleDir = TeleDir;
			CL->next = NULL; 
			AddCombo(CL);
		}

/*		//worked better with esf 1.1 :|
		CL->ComboAction = kickenemy;
		CL->delay = 0.0;
		CL->LifeTime = 1.2;
		CL->next = NULL;
		AddCombo(CL);
*/

		CL->ComboAction = CheckFOVForAim;
		CL->delay = 0.0f;
		CL->LifeTime = 0.25f;
		CL->next = NULL;
		AddCombo(CL);

		CL->ComboAction = pressforward;
		CL->delay = swoop_begin_delay;
		CL->LifeTime = tap_lifetime;
		CL->next = NULL;
		AddCombo(CL);
		
		CL->ComboAction = pressforward;
		CL->delay = tap_delay;
		CL->LifeTime = 0.6;
		CL->next = NULL;
		AddCombo(CL);

		delete CL;

		FinishingTask = TaskNone;

		break;
	case telemelee4:
		if ((!pBot->pBotEnemy) || (!pBot->bot_ki))
			return;

		TeleTimes = GetTeleCountForTeleMelee4(pBot);
		if (TeleTimes > ((pBot->bot_ki / 200)-1))
			return; // Not enough ki for this combo

		CL = new ComboList_t;

		TeleDir = dir_forward;

		if (RANDOM_LONG(0, 1))
			TeleDir |= dir_left;
		else
			TeleDir |= dir_right;

		for (i=0;i<TeleTimes;i++)
		{
			CL->ComboAction = teleport2;
			CL->delay = 0.0;
			CL->poweruptime = 0.0;

			if (i == 0)
				CL->TeleDelay = 0.4;
			else
				CL->TeleDelay = 0.25;

			CL->TeleDir = TeleDir;
			CL->next = NULL; 
			AddCombo(CL);
		}

		CL->ComboAction = CheckFOVForAim;
		CL->delay = 0.0f;
		CL->LifeTime = 0.25f;
		CL->next = NULL;
		AddCombo(CL);

		CL->ComboAction = pressforward;
		CL->delay = swoop_begin_delay;
		CL->LifeTime = tap_lifetime;
		CL->next = NULL;
		AddCombo(CL);
		
		CL->ComboAction = pressforward;
		CL->delay = tap_delay;
		CL->LifeTime = 0.6;
		CL->next = NULL;
		AddCombo(CL);

		delete CL;
		FinishingTask = TaskNone;
		break;

	case telemelee5:
		if (!pBot->pBotEnemy)
			return;

		CL = new ComboList_t;

		TeleDir = dir_back;

		if (RANDOM_LONG(0, 1))
		{
			if (pBot->wander_dir == WANDER_LEFT)
				TeleDir |= dir_left;
			else
				TeleDir |= dir_right;
		}

		CL->ComboAction = teleport2;
		CL->delay = 0.0;
		CL->TeleDelay = 0.2f;
		CL->poweruptime = 0.0;
		CL->TeleDir = TeleDir;
		CL->next = NULL; 
		AddCombo(CL);

		CL->ComboAction = teleport2;
		CL->delay = 0.0;
		CL->TeleDelay = 0.2f;
		CL->poweruptime = 0.0;
		CL->TeleDir = TeleDir;
		CL->next = NULL; 
		AddCombo(CL);

		CL->ComboAction = CheckFOVForAim;
		CL->delay = 0.0f;
		CL->LifeTime = 0.25f;
		CL->next = NULL;
		AddCombo(CL);

		CL->ComboAction = pressforward;
		CL->delay = swoop_begin_delay;
		CL->LifeTime = tap_lifetime;
		CL->next = NULL;
		AddCombo(CL);
		
		CL->ComboAction = pressforward;
		CL->delay = tap_delay;
		CL->LifeTime = 0.6;
		CL->next = NULL;
		AddCombo(CL);

		delete CL;
		pBot->AimVec = pBot->pEdict->v.v_angle;

		break;

	case teletwice:
		CL = new ComboList_t;

		for (i=0;i<2;i++)
		{
			CL->ComboAction = teleport1;
			CL->delay = 0.0;
			CL->TeleDelay = 0.0;
			CL->TeleDir = GetRandomTeleDir(pBot);
			CL->next = NULL;
			AddCombo(CL);
		}
		delete CL;
		break;
	case teleattack:
		if (!pBot->pBotEnemy)
			return;

		not_done = true;
		prev = -1;

		MakeTeleports(go_random,go_back,go_random);

		MakePowerup();

		FinishingTask = TaskChargeAttack;
		break;
	case teleattack2:
		if (!pBot->pBotEnemy)
			return;

		MakeTeleports(go_random,go_back,go_random);
		MakePowerup();

		FinishingTask = TaskShootNonChargeble;
		break;
	case teleback:
		MakeTeleports(go_random,go_back,go_random);
		break;
	case teleforward:
		MakeTeleports(go_random,go_forward,go_random);
		break;
	case powerupmelee:
		MakePowerup();

		CL = new ComboList_t;

		CL->ComboAction = CheckFOVForAim;
		CL->delay = 0.0f;
		CL->LifeTime = 0.25f;
		CL->next = NULL;
		AddCombo(CL);

		CL->ComboAction = pressforward;
		CL->delay = swoop_begin_delay;
		CL->LifeTime = tap_lifetime;
		CL->next = NULL;
		AddCombo(CL);
		
		CL->ComboAction = pressforward;
		CL->delay = tap_delay;
		CL->LifeTime = 0.6;
		CL->next = NULL;
		AddCombo(CL);

		delete CL;

		FinishingTask = TaskNone;

		pBot->SwoopButton = IN_FORWARD;

		break;
	case powerupattack:
		MakePowerup();
		FinishingTask = TaskChargeAttack;
		break;
	case powerupattack2:
		MakePowerup();
		FinishingTask = TaskShootNonChargeble;
		break;
	case startforwardswoop:
		CL = new ComboList_t;

		CL->ComboAction = CheckFOVForAim;
		CL->delay = 0.0f;
		CL->LifeTime = 0.25f;
		CL->next = NULL;
		AddCombo(CL);

		CL->ComboAction = pressforward;
		CL->delay = swoop_begin_delay;
		CL->LifeTime = tap_lifetime;
		CL->next = NULL;
		AddCombo(CL);
		
		CL->ComboAction = pressforward;
		CL->delay = tap_delay;
		CL->LifeTime = 0.6;
		CL->next = NULL;
		AddCombo(CL);

		delete CL;

		FinishingTask = TaskNone;

		pBot->SwoopButton = IN_FORWARD;

		break;

	case startbackwardswoop:
		CL = new ComboList_t;

		CL->ComboAction = pressback;
		CL->delay = swoop_begin_delay;
		CL->LifeTime = tap_lifetime;
		CL->next = NULL;
		AddCombo(CL);
		
		CL->ComboAction = pressback;
		CL->delay = tap_delay;
		CL->LifeTime = GetSwoopLifeTime(dir_back);
		CL->next = NULL;
		AddCombo(CL);

		delete CL;

		FinishingTask = TaskNone;

		pBot->SwoopButton = IN_BACK;

		break;

	case startleftswoop:
		CL = new ComboList_t;

		CL->ComboAction = pressleft;
		CL->delay = swoop_begin_delay;
		CL->LifeTime = tap_lifetime;
		CL->next = NULL;
		AddCombo(CL);
		
		CL->ComboAction = pressleft;
		CL->delay = tap_delay;
		CL->LifeTime = GetSwoopLifeTime(dir_left);
		CL->next = NULL;
		AddCombo(CL);

		delete CL;

		FinishingTask = TaskNone;

		pBot->SwoopButton = IN_MOVELEFT;

		break;

	case startrightswoop:
		CL = new ComboList_t;

		CL->ComboAction = pressright;
		CL->delay = swoop_begin_delay;
		CL->LifeTime = tap_lifetime;
		CL->next = NULL;
		AddCombo(CL);
		
		CL->ComboAction = pressright;
		CL->delay = tap_delay;
		CL->LifeTime = GetSwoopLifeTime(dir_right);
		CL->next = NULL;
		AddCombo(CL);

		delete CL;

		FinishingTask = TaskNone;

		pBot->SwoopButton = IN_MOVERIGHT;
		break;

	case startupswoop:
		CL = new ComboList_t;

		CL->ComboAction = pressjump;
		CL->delay = swoop_begin_delay;
		CL->LifeTime = tap_lifetime;
		CL->next = NULL;
		AddCombo(CL);
		
		CL->ComboAction = pressjump;
		CL->delay = tap_delay;
		CL->LifeTime = GetSwoopLifeTime(dir_up);
		CL->next = NULL;
		AddCombo(CL);

		delete CL;

		FinishingTask = TaskNone;

		pBot->SwoopButton = IN_JUMP;

		break;

	case startdownswoop:
		CL = new ComboList_t;

		CL->ComboAction = pressduck;
		CL->delay = swoop_begin_delay;
		CL->LifeTime = tap_lifetime;
		CL->next = NULL;
		AddCombo(CL);
		
		CL->ComboAction = pressduck;
		CL->delay = tap_delay;
		CL->LifeTime = GetSwoopLifeTime(dir_down);
		CL->next = NULL;
		AddCombo(CL);

		delete CL;

		FinishingTask = TaskNone;

		pBot->SwoopButton = IN_DUCK;
		break;

	case fallpowerup:
		CL = new ComboList_t;

		CL->ComboAction = falldown;
		CL->LifeTime = RANDOM_FLOAT(0.8, 1.2);
		CL->delay = 0.0;
		CL->next = NULL;
		AddCombo(CL);

		delete CL;
		FinishingTask = TaskPowerup;
		break;
	case fallascend:
		CL = new ComboList_t;

		CL->ComboAction = falldown;
		CL->LifeTime = RANDOM_FLOAT(0.8, 1.2);
		CL->delay = 0.0;
		CL->next = NULL;
		AddCombo(CL);

		CL->ComboAction = ascend;
		CL->delay = 0.0;
		CL->next = NULL;
		AddCombo(CL);

		delete CL;
		FinishingTask = TaskNone;
		break;
	case telekick:
		if (!pBot->pBotEnemy)
			return;

		CL = new ComboList_t;

		TeleTimes = (UTIL_Distance(pBot->pEdict->v.origin, pBot->pBotEnemy->v.origin) / 400);

		for (i=0;i<TeleTimes;i++)
		{
			CL->ComboAction = teleport1;
			CL->delay = 0.0;
			CL->poweruptime = 0.0;

			if (i == 0)
				CL->TeleDelay = 0.4;
			else
				CL->TeleDelay = 0.25;

			CL->TeleDir = dir_forward;
			CL->next = NULL; 
			AddCombo(CL);
		}
/*
		CL->ComboAction = kickenemy;
		CL->delay = 0.0;
		CL->LifeTime = 1.2;
		CL->next = NULL;
		AddCombo(CL);
*/
		delete CL;
		FinishingTask = TaskKickEnemy;
		break;
	case swoopforward:
		CL = new ComboList_t;

		CL->ComboAction = pressforward2;
		CL->delay = swoop_begin_delay;
		CL->LifeTime = tap_lifetime;
		CL->next = NULL;
		AddCombo(CL);
		
		CL->ComboAction = pressforward2;
		CL->delay = tap_delay;
		CL->LifeTime = 0.6;
		CL->next = NULL;
		AddCombo(CL);

		delete CL;

		FinishingTask = TaskNone;

		pBot->SwoopButton = IN_FORWARD;

		break;
	case ChargeGBallSwoop:
		CL = new ComboList_t;

		CL->ComboAction = CheckFOVForAim;
		CL->delay = 0.0f;
		CL->LifeTime = 0.25f;
		CL->next = NULL;
		AddCombo(CL);

		CL->ComboAction = ChargeGenBall;
		CL->next = NULL;
		AddCombo(CL);

		CL->ComboAction = pressforward;
		CL->delay = swoop_begin_delay;
		CL->LifeTime = tap_lifetime;
		CL->next = NULL;
		AddCombo(CL);
		
		CL->ComboAction = pressforward;
		CL->delay = tap_delay;
		CL->LifeTime = 0.6;
		CL->next = NULL;
		AddCombo(CL);

		delete CL;

		FinishingTask = TaskNone;

		pBot->SwoopButton = IN_FORWARD;

		break;

	default:
		state = done;
		break;
	}
}

float BotCombo::GetSwoopLifeTime(short SDir)
{
	edict_t *pEdict = pBot->pEdict;

#ifdef USE_NEW_BOT_SENSE
	float TraceDist = static_cast<float>(pBot->DangerLevel) * SWOOP_TRACE_DIST_FACTOR;
	if (TraceDist > MAX_SWOOP_TRACE_DIST)
		TraceDist = MAX_SWOOP_TRACE_DIST;
#else
	float TraceDist = 1550.0f;
#endif

	Vector v_src = pEdict->v.origin;
	Vector v_end;

	TraceResult tr;

	UTIL_MakeVectors(pEdict->v.v_angle);

	switch(SDir)
	{
	case dir_back:
		v_end = v_src - gpGlobals->v_forward * TraceDist;
		break;
	case dir_left:
		v_end = v_src - gpGlobals->v_right * TraceDist;
		break;
	case dir_right:
		v_end = v_src + gpGlobals->v_right * TraceDist;
		break;
	case dir_up:
		v_end = v_src + gpGlobals->v_up * TraceDist;
		break;
	case dir_down:
		v_end = v_src - gpGlobals->v_up * TraceDist;
		break;
	}

	UTIL_TraceHull(v_src,v_end,dont_ignore_monsters,human_hull,pEdict->v.pContainingEntity,&tr);

#ifdef USE_NEW_BOT_SENSE
	if (tr.flFraction <= 0.0f)
		return 0.1f; // Just return something otherwise we get a zero devide

	return (((tr.flFraction * TraceDist) / MAX_SWOOP_TRACE_DIST ) * 2.0f);
#else
	return (1.5 * tr.flFraction);
#endif
}

void BotCombo::SetSwoopDir(short SDir)
{
	SwoopDir = SDir;
}

bool BotCombo::MakeTeleports(TeleDir TeleDirLR, TeleDir TeleDirBF, TeleDir TeleDirUD)
{
	edict_t *pEdict = pBot->pEdict;
	float dist = UTIL_Distance(pEdict->v.origin,pBot->pBotEnemy->v.origin);
	int RandNr;

	ComboList_t *CL;
	
	int TeleCount;

	if (TeleDirBF == go_forward)
		TeleCount = int(dist / RANDOM_FLOAT(300.0,500.0));
	else
		TeleCount = RANDOM_LONG(3, 5);

	while ((TeleCount*150) > pBot->bot_ki)
		TeleCount--;

	if (TeleCount == 0)
		return false;

/*
	char s[25] = "";
	sprintf(s, "TeleCount: %d", TeleCount);
	UTIL_Printf(s, HUD_PRINTTALK);
*/
	CL = new ComboList_t;

	Vector PosToTrace = pEdict->v.origin;
	Vector v_end, v_aim;

	short TelCount = 0;
	for (int i=0;i<TeleCount;i++)
	{
		bool CheckedLeftForwardUp = false, CheckedRightForwardUp = false;
		bool CheckedLeftBackwardUp = false, CheckedRightBackwardUp = false;
		bool CheckedLeftForwardDown = false, CheckedRightForwardDown = false;
		bool CheckedLeftBackwardDown = false, CheckedRightBackwardDown = false;

		while ((CheckedLeftForwardUp == false) && (CheckedRightForwardUp == false) &&
			   (CheckedLeftBackwardUp == false) && (CheckedRightBackwardUp == false) &&
			   (CheckedLeftForwardDown == false) && (CheckedRightForwardDown == false) &&
			   (CheckedLeftBackwardDown == false) && (CheckedRightBackwardDown == false))
		{
			int IdealDir = 0;
			TraceResult tr;

			RandNr = 0;

			if (TeleDirLR == go_random)
				RandNr = RANDOM_LONG(0, 1);

			if ((TeleDirLR == go_left) || (RandNr))
				IdealDir |= dir_left;
			else
				IdealDir |= dir_right;

			RandNr = 0;

			if (TeleDirBF == go_random)
				RandNr = RANDOM_LONG(0, 1);

			if ((TeleDirBF == go_back) || (RandNr))
				IdealDir |= dir_back;
			else
				IdealDir |= dir_forward;

			RandNr = 0;

			if (TeleDirUD == go_random)
				RandNr = RANDOM_LONG(0, 1);

			if ((TeleDirUD == go_down) || (RandNr))
				IdealDir |= dir_down;
			else
				IdealDir |= dir_up;

			if ((IdealDir & dir_left) && (IdealDir & dir_forward) && (IdealDir & dir_up))
			{
				if (CheckedLeftForwardUp)
					continue;

				v_aim = pEdict->v.v_angle;
				v_aim.x = -45.0;
				v_aim.y = UTIL_WrapAngle(v_aim.y + 45.0);
				UTIL_MakeVectors(v_aim);

				v_end = PosToTrace + gpGlobals->v_forward * 400.0;

				CheckedLeftForwardUp = true;
			}
			else if ((IdealDir & dir_right) && (IdealDir & dir_forward) && (IdealDir & dir_up))
			{
				if (CheckedRightForwardUp)
					continue;

				CheckedRightForwardUp = true;

				v_aim = pEdict->v.v_angle;
				v_aim.x = -45.0;
				v_aim.y = UTIL_WrapAngle(v_aim.y + -45.0);
				UTIL_MakeVectors(v_aim);

				v_end = PosToTrace + gpGlobals->v_forward * 400.0;
			}
			else if ((IdealDir & dir_left) && (IdealDir & dir_back) && (IdealDir & dir_up))
			{
				if (CheckedLeftBackwardUp)
					continue;

				CheckedLeftBackwardUp = true;
				v_aim = pEdict->v.v_angle;
				v_aim.x = 45.0;
				v_aim.y = UTIL_WrapAngle(v_aim.y + -45.0);
				UTIL_MakeVectors(v_aim);

				v_end = PosToTrace - gpGlobals->v_forward * 400.0;
			}
			else if ((IdealDir & dir_right) && (IdealDir & dir_back) && (IdealDir & dir_up))
			{
				if (CheckedRightBackwardUp)
					continue;

				CheckedLeftForwardUp = true;
				v_aim = pEdict->v.v_angle;
				v_aim.x = 45.0;
				v_aim.y = UTIL_WrapAngle(v_aim.y + 45.0);
				UTIL_MakeVectors(v_aim);

				v_end = PosToTrace - gpGlobals->v_forward * 400.0;
			}
			else if ((IdealDir & dir_left) && (IdealDir & dir_forward) && (IdealDir & dir_down))
			{
				if (CheckedLeftForwardDown)
					continue;

				CheckedLeftForwardDown = true;
				v_aim = pEdict->v.v_angle;
				v_aim.x = 45.0;
				v_aim.y = UTIL_WrapAngle(v_aim.y + 45.0);
				UTIL_MakeVectors(v_aim);

				v_end = PosToTrace + gpGlobals->v_forward * 400.0;
			}
			else if ((IdealDir & dir_right) && (IdealDir & dir_forward) && (IdealDir & dir_down))
			{
				if (CheckedRightForwardDown)
					continue;

				CheckedRightForwardDown = true;
				v_aim = pEdict->v.v_angle;
				v_aim.x = 45.0;
				v_aim.y = UTIL_WrapAngle(v_aim.y + -45.0);
				UTIL_MakeVectors(v_aim);

				v_end = PosToTrace + gpGlobals->v_forward * 400.0;
			}
			else if ((IdealDir & dir_left) && (IdealDir & dir_back) && (IdealDir & dir_down))
			{
				if (CheckedLeftBackwardDown)
					continue;

				CheckedLeftBackwardDown = true;
				v_aim = pEdict->v.v_angle;
				v_aim.x = -45.0;
				v_aim.y = UTIL_WrapAngle(v_aim.y + -45.0);
				UTIL_MakeVectors(v_aim);

				v_end = PosToTrace - gpGlobals->v_forward * 400.0;
			}
			else if ((IdealDir & dir_right) && (IdealDir & dir_back) && (IdealDir & dir_down))
			{
				if (CheckedRightBackwardDown)
					continue;

				CheckedRightBackwardDown = true;
				v_aim = pEdict->v.v_angle;
				v_aim.x = -45.0;
				v_aim.y = UTIL_WrapAngle(v_aim.y + 45.0);
				UTIL_MakeVectors(v_aim);

				v_end = PosToTrace - gpGlobals->v_forward * 400.0;
			}
			else
				continue; // Shouldn't happen

			UTIL_TraceHull(PosToTrace, v_end, dont_ignore_monsters, human_hull, pEdict, &tr);

			// check if the trace didn't hit something...
			if (tr.flFraction >= 1.0)
			{
				CL->ComboAction = teleport1;
				CL->TeleDir = IdealDir;
				CL->TeleDelay = 0.4;
				CL->next = NULL;
				AddCombo(CL);
				PosToTrace = tr.vecEndPos;
				TelCount++;
				break;
			}
		}
	}
	delete CL;

	return (TeleCount >= 1);
}

void BotCombo::MakePowerup()
{
	ComboList_t *CL;

	CL = new ComboList_t;
	CL->ComboAction = powerup;
	CL->delay = 0.0;
	CL->LifeTime = 0.0;
	CL->next = NULL;
//	CL->poweruptime = ((1000-pBot->bot_ki)/150);

	AddCombo(CL);

	delete CL;

	//FakeClientCommand(pBot->pEdict,"+powerup",NULL,NULL);
}

void BotCombo::Activate()
{
	if (ComboList)
	{
		ComboList->delay += gpGlobals->time;
		ComboList->TeleDelay += gpGlobals->time;
		ComboList->LifeTime += gpGlobals->time;
		ComboList->poweruptime += gpGlobals->time;
		ComboList->StartTime += gpGlobals->time;
	}
	Activated = true;
}


void MakeCombo(bot_t *pBot, ComboTypes CT)
{
	if (pBot->pBotCombo)
		delete pBot->pBotCombo;

	MakeTask(pBot, TaskCombo);
	pBot->pBotCombo = new BotCombo(pBot,CT);
	return;
}

void DeleteCombos(bot_t *pBot)
{
	if (pBot->pBotCombo)
	{
		delete pBot->pBotCombo;
		pBot->pBotCombo = NULL;
	}
}

bool MakeTeleMelee(bot_t *pBot, float flEnemyDist)
{
	edict_t *pEdict = pBot->pEdict;
	TMultiChoice<ComboTypes> TeleMeleeChoices;

	// Only check for this if enemy isn't very close
	if (flEnemyDist > 450.0f)
	{
		if (CheckForCollide(pEdict, dir_left, 650.0f) == false)
			TeleMeleeChoices.Insert(TeleLeftMelee, 40);
		if (CheckForCollide(pEdict, dir_right, 650.0f) == false)
			TeleMeleeChoices.Insert(TeleRightMelee, 40);
		if (CheckForCollide(pEdict, dir_back, 650.0f) == false)
			TeleMeleeChoices.Insert(TeleBackMelee, 40);
	}

	// More chance for up & down teleport because it confuses the enemy more :)
	if (CheckForCollide(pEdict, dir_up, 650.0f) == false)
		TeleMeleeChoices.Insert(TeleUpMelee, 75);
	
	if (CheckForCollide(pEdict, dir_down, 650.0f) == false)
		TeleMeleeChoices.Insert(TeleDownMelee, 75);

	if (CheckForCollide(pEdict, dir_left_back, 650.0f) == false)
		TeleMeleeChoices.Insert(TeleLeftBackMelee, 40);

	if (CheckForCollide(pEdict, dir_right_back, 650.0f) == false)
		TeleMeleeChoices.Insert(TeleRightBackMelee, 40);

	// Only add these combos on large distances
	// (otherwise the bot probably won't surprise his enemy at all...)
	if (flEnemyDist < 600.0f)
	{
		if (CheckForCollide(pEdict, dir_left_forward, 650.0f) == false)
			TeleMeleeChoices.Insert(TeleForwardLeftMelee, 45);

		if (CheckForCollide(pEdict, dir_right_forward, 650.0f) == false)
			TeleMeleeChoices.Insert(TeleForwardRightMelee, 45);
	}

	ComboTypes ComboChoice;
	if (TeleMeleeChoices.GetSelection(ComboChoice))
	{
		MakeCombo(pBot, ComboChoice);
		return true;
	}

	return false;
}

void DebugComboTeleDirs(int IdealDir)
{
	edict_t *pEdict =listenserver_edict;
	Vector v_aim, v_end;
	Vector PosToTrace = pEdict->v.origin;
	TraceResult tr;

			if ((IdealDir & dir_left) && (IdealDir & dir_forward) && (IdealDir & dir_up))
			{
				v_aim = pEdict->v.v_angle;
				v_aim.x = -45.0;
				v_aim.y = UTIL_WrapAngle(v_aim.y + 45.0);
				UTIL_MakeVectors(v_aim);

				v_end = PosToTrace + gpGlobals->v_forward * 400.0;
			}
			else if ((IdealDir & dir_right) && (IdealDir & dir_forward) && (IdealDir & dir_up))
			{
				v_aim = pEdict->v.v_angle;
				v_aim.x = -45.0;
				v_aim.y = UTIL_WrapAngle(v_aim.y + -45.0);
				UTIL_MakeVectors(v_aim);

				v_end = PosToTrace + gpGlobals->v_forward * 400.0;
			}
			else if ((IdealDir & dir_left) && (IdealDir & dir_back) && (IdealDir & dir_up))
			{
				v_aim = pEdict->v.v_angle;
				v_aim.x = 45.0;
				v_aim.y = UTIL_WrapAngle(v_aim.y + -45.0);
				UTIL_MakeVectors(v_aim);

				v_end = PosToTrace - gpGlobals->v_forward * 400.0;
			}
			else if ((IdealDir & dir_right) && (IdealDir & dir_back) && (IdealDir & dir_up))
			{
				v_aim = pEdict->v.v_angle;
				v_aim.x = 45.0;
				v_aim.y = UTIL_WrapAngle(v_aim.y + 45.0);
				UTIL_MakeVectors(v_aim);

				v_end = PosToTrace - gpGlobals->v_forward * 400.0;
			}
			else if ((IdealDir & dir_left) && (IdealDir & dir_forward) && (IdealDir & dir_down))
			{
				v_aim = pEdict->v.v_angle;
				v_aim.x = 45.0;
				v_aim.y = UTIL_WrapAngle(v_aim.y + 45.0);
				UTIL_MakeVectors(v_aim);

				v_end = PosToTrace + gpGlobals->v_forward * 400.0;
			}
			else if ((IdealDir & dir_right) && (IdealDir & dir_forward) && (IdealDir & dir_down))
			{
				v_aim = pEdict->v.v_angle;
				v_aim.x = 45.0;
				v_aim.y = UTIL_WrapAngle(v_aim.y + -45.0);
				UTIL_MakeVectors(v_aim);

				v_end = PosToTrace + gpGlobals->v_forward * 400.0;
			}
			else if ((IdealDir & dir_left) && (IdealDir & dir_back) && (IdealDir & dir_down))
			{
				v_aim = pEdict->v.v_angle;
				v_aim.x = -45.0;
				v_aim.y = UTIL_WrapAngle(v_aim.y + -45.0);
				UTIL_MakeVectors(v_aim);

				v_end = PosToTrace - gpGlobals->v_forward * 400.0;
			}
			else if ((IdealDir & dir_right) && (IdealDir & dir_back) && (IdealDir & dir_down))
			{
				v_aim = pEdict->v.v_angle;
				v_aim.x = -45.0;
				v_aim.y = UTIL_WrapAngle(v_aim.y + 45.0);
				UTIL_MakeVectors(v_aim);

				v_end = PosToTrace - gpGlobals->v_forward * 400.0;
			}

			UTIL_TraceHull(PosToTrace, v_end, dont_ignore_monsters, human_hull, pEdict, &tr);

			UTIL_DrawBeam(listenserver_edict, PosToTrace, tr.vecEndPos, 12, 5, 0, 0, 255, 250, 
						  5, 150);


}

short GetTeleCountForTeleMelee4(bot_t *pBot)
{
	Vector v_predict = PredictEntityPos(pBot->pBotEnemy, 1.0f);
	float EnemyDist = UTIL_Distance(pBot->pEdict->v.origin, v_predict);

	return (EnemyDist / 400.0f) + 1;
}

#ifdef classstuff

void CBot::MakeCombo(ComboTypes CT)
{
	/* UNDONE
	if (m_pBotCombo)
		delete m_pBotCombo;

	MakeTask(TaskCombo);
	m_pBotCombo = new BotCombo(CT);
	*/
	return;
}

void CBot::DeleteCombos()
{
	if (m_pBotCombo)
	{
		delete m_pBotCombo;
		m_pBotCombo = NULL;
	}
}

#endif