//
// HPB bot - botman's High Ping Bastard bot
//
// (http://planethalflife.com/botman/)
//
// dll.cpp
//

#include "general_header.h"
#include <assert.h>
#include "autoclient.h"
#include "studio.h"
#include "usercmd.h"

#ifdef _DEBUG
#define trycatchshit
#endif

#ifdef USEBSPSHIT
#include "bsp_file.h"
#endif

extern GETENTITYAPI other_GetEntityAPI;
extern GETNEWDLLFUNCTIONS other_GetNewDLLFunctions;
extern enginefuncs_t g_engfuncs;

extern int debug_engine;
extern bool DebugNetworkMessages;
bool debug_mode = false;

#ifdef trycatchshit
bool KickCorruptedBots = false;
#endif

extern bool CheckForDBSpot;

extern bool IsPlayingMessage;
extern globalvars_t  *gpGlobals;
extern char *g_argv;
extern bool g_waypoint_on;
bool RealAutoWaypoint = false;
extern bool g_auto_waypoint;
extern bool g_path_waypoint;
extern int num_waypoints;  // number of waypoints currently in use
extern WAYPOINT waypoints[MAX_WAYPOINTS];
extern float wp_display_time[MAX_WAYPOINTS];
extern bot_t bots[32];
extern BotPersonality_t BotPersonalities[9];

extern bool b_observer_mode;
extern bool b_botdontshoot;
extern bool BotDontSearchEnemy;
extern bool BotShouldMove;
extern bool BotDoCombos;
extern bool BotsUseDiscs;
extern bool BotsAreIdle;
extern bool BotsAlwaysTryToAscend;

extern edict_t *pHostViewPlayer;
extern CBaseEntity *pHostCam;
extern edict_t *pBeamViewEnt;
extern CBaseEntity *pBeamCam;

#ifdef _DEBUG
int TraceLineCalls = 0;
int FVisibleCalls = 0;
extern unsigned long MeleeCalls;
extern unsigned long KiAttackCalls;
byte DebugMinHeadPercent = 0;
bool TestFCommand = false;
#endif

bool DrawTraceLines = false;

int bot_melee_percent = 80;
int default_bot_skill = 2;
bool follow_mode = false;
int bot_teleport_percent = 60;

char welcome_msg[] = "ESF Bot - version 4.1\n";
static FILE *fp;

DLL_FUNCTIONS other_gFunctionTable;
DLL_GLOBAL const Vector g_vecZero = Vector(0,0,0);

short lcoutXPos = -200;
short lcoutYPos = -200;

byte NumPlayers = 0;
int m_spriteTexture = 0;
int isFakeClientCommand = 0;
int fake_arg_count;
float bot_check_time = 30.0;
int min_bots = -1;
int max_bots = -1;
int num_bots = 0;
float num_bots_check = 0.0;
int prev_num_bots = 0;
bool g_GameRules = false;
edict_t *listenserver_edict = NULL;
float welcome_time = 0.0;
bool welcome_sent = false;
bool BotCommandWasFound = true;
float previous_time = -1.0;
bool PrintingInGameHelp = false;

bool TeamMenuShowedUp = false;
bool ClassMenuShowedUp = false;

bool should_bot_chat = true;
bool LockedAutoCam = true;
bool BalanceTeams = false;

bool borg_mode = false;

float BotDebugAimXSpeed = 0.0;
float BotDebugAimYSpeed = 0.0;
float BotDebugAimDelay = 0.0;
float BotDebugDelayForAimDelay = 0.0f;
float DebugAimFactor = 0.0;
Vector DebugGoToVec = g_vecZero;

FILE *bot_cfg_fp = NULL;
bool need_to_open_cfg = true;
float bot_cfg_pause_time = 0.0;
float respawn_time = 0.0;
bool spawn_time_reset = false;

int whine_count;

int bot_chat_percent = 10;   // percent of time to chat
int bot_taunt_percent = 20;  // percent of time to taunt after kill
int bot_whine_percent = 10;  // percent of time to whine after death
int bot_chat_tag_percent = 80;   // percent of the time to drop clan tag
int bot_chat_drop_percent = 10;  // percent of the time to drop characters
int bot_chat_swap_percent = 10;  // percent of the time to swap characters
int bot_chat_lower_percent = 50; // percent of the time to lowercase chat

bool fill_server = false;
int fill_count = 0;
int fill_team = 0;
bool fill_half = false;
float fill_bot_check_time = 0.0;

bool hp_cheat = false;

float OldPlCatchupValue = 0.0;

ClientInfo_t ClientInfo[32];

void BotNameInit(void);
void UpdateClientData(const struct edict_s *ent, int sendweapons, struct clientdata_s *cd);
void ProcessBotCfgFile(void);
void ExecuteBotCommands(void);
void DisplayDebugTexts(void);

float check_cvar_delay = 0;

cvar_t sv_num_bots = {"numbots",""};
cvar_t sv_bot_skill = {"bot_skill",""};

#ifdef _DEBUG
bool DisplayBotStuff = true;
#endif

void ChangeMeleePercent(short NewPercent)
{
	int i;
	bot_melee_percent = NewPercent;
	char msg[50] = "";

	sprintf(msg, "Melee percent of EVERY bot is now: %d\n", NewPercent);
	UTIL_Printf(msg);

//	CVAR_SET_FLOAT("botmeleepercent",NewPercent);

	for (i = 0;i<32;i++)
	{
		if (bots[i].pEdict != listenserver_edict) // Skip autopilots(since they can't melee)
			bots[i].MeleePercent = NewPercent;
	}

	for (i = 0;i<9;i++)
		BotPersonalities[i].melee_percent = NewPercent;
}

void ChangeTeleportPercent(short NewPercent)
{
	int i;
	bot_teleport_percent = NewPercent;
	char msg[50] = "";

	sprintf(msg, "Teleport percent of EVERY bot is now: %d\n", NewPercent);
	UTIL_Printf(msg);

	//	CVAR_SET_FLOAT("botteleportpercent",NewPercent);

	for (i = 0;i<32;i++)
		bots[i].TeleportPercent = NewPercent;

	for (i = 0;i<9;i++)
		BotPersonalities[i].teleport_percent = NewPercent;
}

void ChangeSwoopPercent(short NewPercent)
{
	int i;
	char msg[50] = "";

	sprintf(msg, "Swoop percent of EVERY bot is now: %d\n", NewPercent);
	UTIL_Printf(msg);

	for (i = 0;i<32;i++)
		bots[i].SwoopPercent = NewPercent;

	for (i = 0;i<9;i++)
		BotPersonalities[i].swoop_percent = NewPercent;
}

void ChangeFlyPercent(short NewPercent)
{
	int i;
	char msg[50] = "";

	sprintf(msg, "Fly percent of EVERY bot is now: %d\n", NewPercent);
	UTIL_Printf(msg);

	for (i = 0;i<32;i++)
	{
		bots[i].FlyPercent = NewPercent;
		bots[i].CheckFlyDelay = 0.0;
	}
	for (i = 0;i<9;i++)
		BotPersonalities[i].fly_percent = NewPercent;
}

void ChangeChatPercent(short NewPercent)
{
	int i;
	char msg[50] = "";

	sprintf(msg, "Chat percent of EVERY bot is now: %d\n", NewPercent);
	UTIL_Printf(msg);

	for (i = 0;i<32;i++)
		bots[i].chat_percent = NewPercent;

	for (i = 0;i<9;i++)
		BotPersonalities[i].chat_percent = NewPercent;
}

void ChangeTauntPercent(short NewPercent)
{
	int i;
	char msg[50] = "";

	sprintf(msg, "Taunt percent of EVERY bot is now: %d\n", NewPercent);
	UTIL_Printf(msg);

	for (i = 0;i<32;i++)
		bots[i].taunt_percent = NewPercent;

	for (i = 0;i<9;i++)
		BotPersonalities[i].taunt_percent = NewPercent;
}

void ChangeWhinePercent(short NewPercent)
{
	int i;
	char msg[50] = "";

	sprintf(msg, "Whine percent of EVERY bot is now: %d\n", NewPercent);
	UTIL_Printf(msg);

	for (i = 0;i<32;i++)
		bots[i].whine_percent = NewPercent;

	for (i = 0;i<9;i++)
		BotPersonalities[i].whine_percent = NewPercent;
}

void ChangeChatTagPercent(short NewPercent)
{
	int i;
	char msg[50] = "";

	sprintf(msg, "Chat-tag percent of EVERY bot is now: %d\n", NewPercent);
	UTIL_Printf(msg);

	for (i = 0;i<32;i++)
		bots[i].chat_tag_percent = NewPercent;

	for (i = 0;i<9;i++)
		BotPersonalities[i].chat_tag_percent = NewPercent;
}

void ChangeChatDropPercent(short NewPercent)
{
	int i;
	char msg[50] = "";

	sprintf(msg, "Chat-drop percent of EVERY bot is now: %d\n", NewPercent);
	UTIL_Printf(msg);

	for (i = 0;i<32;i++)
		bots[i].chat_drop_percent = NewPercent;

	for (i = 0;i<9;i++)
		BotPersonalities[i].chat_drop_percent = NewPercent;
}

void ChangeChatSwapPercent(short NewPercent)
{
	int i;
	char msg[50] = "";

	sprintf(msg, "Chat-swap percent of EVERY bot is now: %d\n", NewPercent);
	UTIL_Printf(msg);

	for (i = 0;i<32;i++)
		bots[i].chat_swap_percent = NewPercent;

	for (i = 0;i<9;i++)
		BotPersonalities[i].chat_swap_percent = NewPercent;
}

void ChangeChatLowerPercent(short NewPercent)
{
	int i;
	char msg[50] = "";

	sprintf(msg, "Chat-lower percent of EVERY bot is now: %d\n", NewPercent);
	UTIL_Printf(msg);

	for (i = 0;i<32;i++)
		bots[i].chat_lower_percent = NewPercent;

	for (i = 0;i<9;i++)
		BotPersonalities[i].chat_lower_percent = NewPercent;
}

void ChangeSBotLaserPercent(short NewPercent)
{
	int i;
	char msg[50] = "";
	extern SBotSettings_t SBotSettings[3];

	sprintf(msg, "Super bot laser percent of EVERY super bot is now: %d\n", NewPercent);
	UTIL_Printf(msg);

	for (i = 0;i<3;i++)
		SBotSettings[i].laser_percent = NewPercent;
}


void GameDLLInit( void )
{
   CVAR_REGISTER (&sv_num_bots);
   CVAR_REGISTER (&sv_bot_skill);

    // initialize the bots array of structures...
   memset(bots, 0, sizeof(bots));
   memset(ClientInfo, 0, sizeof(ClientInfo));

   BotNameInit(); // load bot names
   pChatClass->ReadChatFile(); // load chat sentences
   MakePersonalities(); // load/create bot personalities
   MakeSBotSettings(); // load/create sbot settings
   LoadSkillData();

   ADD_SERVER_COMMAND("esf_bot4", ExecuteBotCommands);
   ADD_SERVER_COMMAND("bot_help", UTIL_ShowInGameHelpWindow);

   (*other_gFunctionTable.pfnGameInit)();
}

void PrechacePlayerPainSounds()
{
	PRECACHE_SOUND("buu/pain1.wav");
	PRECACHE_SOUND("buu/pain2.wav");
	PRECACHE_SOUND("buu/pain3.wav");
	PRECACHE_SOUND("buu/pain4.wav");

	PRECACHE_SOUND("goku/pain1.wav");
	PRECACHE_SOUND("goku/pain2.wav");
	PRECACHE_SOUND("goku/pain3.wav");
	PRECACHE_SOUND("goku/pain4.wav");

	PRECACHE_SOUND("gohan/pain1.wav");
	PRECACHE_SOUND("gohan/pain2.wav");
	PRECACHE_SOUND("gohan/pain3.wav");
	PRECACHE_SOUND("gohan/pain4.wav");

	PRECACHE_SOUND("krillin/pain1.wav");
	PRECACHE_SOUND("krillin/pain2.wav");
	PRECACHE_SOUND("krillin/pain3.wav");
	PRECACHE_SOUND("krillin/pain4.wav");

	PRECACHE_SOUND("frieza/pain1.wav");
	PRECACHE_SOUND("frieza/pain2.wav");
	PRECACHE_SOUND("frieza/pain3.wav");
	PRECACHE_SOUND("frieza/pain4.wav");

	PRECACHE_SOUND("piccolo/pain1.wav");
	PRECACHE_SOUND("piccolo/pain2.wav");
	PRECACHE_SOUND("piccolo/pain3.wav");
	PRECACHE_SOUND("piccolo/pain4.wav");

	PRECACHE_SOUND("trunks/pain1.wav");
	PRECACHE_SOUND("trunks/pain2.wav");
	PRECACHE_SOUND("trunks/pain3.wav");
	PRECACHE_SOUND("trunks/pain4.wav");

	PRECACHE_SOUND("vegeta/pain1.wav");
	PRECACHE_SOUND("vegeta/pain2.wav");
	PRECACHE_SOUND("vegeta/pain3.wav");
	PRECACHE_SOUND("vegeta/pain4.wav");

	PRECACHE_SOUND("cell/pain1.wav");
	PRECACHE_SOUND("cell/pain2.wav");
	PRECACHE_SOUND("cell/pain3.wav");
	PRECACHE_SOUND("cell/pain4.wav");

	PRECACHE_SOUND("fatbuu/pain1.wav");
	PRECACHE_SOUND("fatbuu/pain2.wav");
	PRECACHE_SOUND("fatbuu/pain3.wav");
	PRECACHE_SOUND("fatbuu/pain4.wav");

	PRECACHE_SOUND("cell2/pain1.wav");
	PRECACHE_SOUND("cell2/pain2.wav");
	PRECACHE_SOUND("cell2/pain3.wav");
	PRECACHE_SOUND("cell2/pain4.wav");
}

int DispatchSpawn( edict_t *pent )
{
   if (gpGlobals->deathmatch)
   {
      char *pClassname = (char *)STRING(pent->v.classname);

      if (debug_engine)
      {
         fp=fopen("bot.txt","a");
         fprintf(fp, "DispatchSpawn: %x %s\n",pent,pClassname);
         if (pent->v.model != 0)
            fprintf(fp, " model=%s\n",STRING(pent->v.model));
         fclose(fp);
      }

      if (strcmp(pClassname, "worldspawn") == 0)
      {
         // do level initialization stuff here...

         WaypointInit();
         WaypointLoad(NULL);
#ifdef usedbcode
		 InitCustomGatherDBSpots();
#endif

         PRECACHE_SOUND("weapons/xbow_hit1.wav");      // waypoint add
         PRECACHE_SOUND("weapons/mine_activate.wav");  // waypoint delete
         PRECACHE_SOUND("common/wpn_hudoff.wav");      // path add/delete start
         PRECACHE_SOUND("common/wpn_hudon.wav");       // path add/delete done
         PRECACHE_SOUND("common/wpn_moveselect.wav");  // path add/delete cancel
         PRECACHE_SOUND("common/wpn_denyselect.wav");  // path add/delete error
		 PRECACHE_SOUND("weapons/basicbeam_chargeoriginal.wav"); // for sbot 'weapon'

		 PRECACHE_MODEL( "models/mechgibs.mdl" );

		 // pain sounds for each class
		 //PrechacePlayerPainSounds();

         m_spriteTexture = PRECACHE_MODEL( "sprites/lgtning.spr");

         g_GameRules = true;

         bot_cfg_pause_time = 0.0;
         respawn_time = 0.0;
         spawn_time_reset = false;

         prev_num_bots = num_bots;
         num_bots = 0;

         bot_check_time = gpGlobals->time + 30.0;
      }
   }

   return (*other_gFunctionTable.pfnSpawn)(pent);
}

void DispatchThink( edict_t *pent )
{
	if (debug_engine)
	{
		char s[25] = "";
		if (pent->v.classname)
			strcpy(s, STRING(pent->v.classname));
		
		clog << "DispatchThink on " << s << "\n";
	}

    if ((IsNull(pent) == false) && (IsAttack(pent)))
		pAttackManager->AddAttack(pent);

   (*other_gFunctionTable.pfnThink)(pent); // 175091948   -   61432504
}

void DispatchUse( edict_t *pentUsed, edict_t *pentOther )
{
	if (debug_engine)
	{
		char s1[25] = "";
		char s2[25] = "";

		if (pentUsed->v.classname)
			strcpy(s1, STRING(pentUsed->v.classname));
		
		if (pentOther->v.classname)
			strcpy(s2, STRING(pentOther->v.classname));

		clog << "DispatchUse, used on " << s1 << "by " << s2 << "\n";
	}

   (*other_gFunctionTable.pfnUse)(pentUsed, pentOther);
}

void DispatchTouch( edict_t *pentTouched, edict_t *pentOther )
{
	if (debug_engine)
	{
		char s1[25] = "";
		char s2[25] = "";

		if (pentTouched->v.classname)
			strcpy(s1, STRING(pentTouched->v.classname));
		
		if (pentOther->v.classname)
			strcpy(s2, STRING(pentOther->v.classname));

		clog << "DispatchTouch, touched " << s1 << "by " << s2 << "\n";
	}

	int BotInd;

	if ((IsNull(pentTouched) == false) && (IsNull(pentOther) == false))
	{
		if (pentTouched->v.flags & FL_FAKECLIENT)
		{
			BotInd = UTIL_GetBotIndex(pentTouched);

			if (BotInd > -1)
			{
				bots[BotInd].pTouchEnt = pentOther;
			}
		}

		if (pentOther->v.flags & FL_FAKECLIENT)
		{
			BotInd = UTIL_GetBotIndex(pentOther);

			if (BotInd > -1)
			{
				bots[BotInd].pTouchEnt = pentTouched;
			}
		}
	}

   (*other_gFunctionTable.pfnTouch)(pentTouched, pentOther);
}

void DispatchBlocked( edict_t *pentBlocked, edict_t *pentOther )
{
	if (debug_engine)
	{
		char s1[25] = "";
		char s2[25] = "";

		if (pentBlocked->v.classname)
			strcpy(s1, STRING(pentBlocked->v.classname));
		
		if (pentOther->v.classname)
			strcpy(s2, STRING(pentOther->v.classname));

		clog << "DispatchBlocked, blocked " << s1 << "by " << s2 << "\n";
	}

   (*other_gFunctionTable.pfnBlocked)(pentBlocked, pentOther);
}

void DispatchKeyValue( edict_t *pentKeyvalue, KeyValueData *pkvd )
{
	if (debug_engine)
	{
		char s1[25] = "";

		if (pentKeyvalue->v.classname)
			strcpy(s1, STRING(pentKeyvalue->v.classname));
		
		clog << "DispatchKeyvalue, for " << s1 << " Str: " << pkvd->szKeyName << " Nr: " << pkvd->szValue << "\n";
	}

   //fp=fopen("bot.txt","a"); fprintf(fp, "DispatchKeyValue: %x %s=%s\n",pentKeyvalue,pkvd->szKeyName,pkvd->szValue); fclose(fp);


   (*other_gFunctionTable.pfnKeyValue)(pentKeyvalue, pkvd);
}

void DispatchSave( edict_t *pent, SAVERESTOREDATA *pSaveData )
{
   (*other_gFunctionTable.pfnSave)(pent, pSaveData);
}

int DispatchRestore( edict_t *pent, SAVERESTOREDATA *pSaveData, int globalEntity )
{
   return (*other_gFunctionTable.pfnRestore)(pent, pSaveData, globalEntity);
}

void DispatchObjectCollsionBox( edict_t *pent )
{/*
	if (debug_engine)
	{
		char s1[25] = "";

		if (pent->v.classname)
			strcpy(s1, STRING(pent->v.classname));
		
		clog << "DispatchObjectCollsionBox on " << s1 << "\n";
	}*/

   (*other_gFunctionTable.pfnSetAbsBox)(pent);
}

void SaveWriteFields( SAVERESTOREDATA *pSaveData, const char *pname, void *pBaseData, TYPEDESCRIPTION *pFields, int fieldCount )
{
   (*other_gFunctionTable.pfnSaveWriteFields)(pSaveData, pname, pBaseData, pFields, fieldCount);
}

void SaveReadFields( SAVERESTOREDATA *pSaveData, const char *pname, void *pBaseData, TYPEDESCRIPTION *pFields, int fieldCount )
{
   (*other_gFunctionTable.pfnSaveReadFields)(pSaveData, pname, pBaseData, pFields, fieldCount);
}

void SaveGlobalState( SAVERESTOREDATA *pSaveData )
{
   (*other_gFunctionTable.pfnSaveGlobalState)(pSaveData);
}

void RestoreGlobalState( SAVERESTOREDATA *pSaveData )
{
   (*other_gFunctionTable.pfnRestoreGlobalState)(pSaveData);
}

void ResetGlobalState( void )
{
   (*other_gFunctionTable.pfnResetGlobalState)();
}


BOOL ClientConnect( edict_t *pEntity, const char *pszName, const char *pszAddress, char szRejectReason[ 128 ]  )
{ 
   if (gpGlobals->deathmatch)
   {
      int i;
      int count = 0;

      if (debug_engine) { fp=fopen("bot.txt","a"); fprintf(fp, "ClientConnect: pent=%x name=%s\n",pEntity,pszName); fclose(fp); }

      // check if this is NOT a bot joining the server...
      if (strcmp(pszAddress, "127.0.0.1") != 0)
      {
#ifdef classstuff
		 pClientManager->ConnectPlayer(pEntity);
#endif
         // don't try to add bots for 60 seconds, give client time to get added
         bot_check_time = gpGlobals->time + 60.0;

         for (i=0; i < 32; i++)
         {
            if (bots[i].is_used)  // count the number of bots in use
               count++;
         }

         // if there are currently more than the minimum number of bots running
         // then kick one of the bots off the server...
         if ((count > min_bots) && (min_bots != -1))
         {
            for (i=0; i < 32; i++)
            {
               if (bots[i].is_used)  // is this slot used?
               {
                  char cmd[80];

                  sprintf(cmd, "kick \"%s\"\n", STRING(bots[i].pEdict->v.netname));

                  SERVER_COMMAND(cmd);  // kick the bot using (kick "name")

				  if (fill_server) // stop filling the server
				  {
					  fill_team = 0;
					  fill_half = fill_server = false;
				  }

                  break;
               }
            }
         }
      }
	  else
	  {
#ifdef classstuff
		  pClientManager->ConnectBot(pEntity);
#endif
	  }

	  // check if this client is the listen server client
	  if (strcmp(pszAddress, "loopback") == 0)
	  {
		  // save the edict of the listen server client...
		  listenserver_edict = pEntity;
#ifdef classstuff
		  CClient *pClient = pClientManager->GetClientFromEdict(pEntity);
		  if (pClient)
			  pClientManager->SetHost(pClient); // Mark this player as a host
#endif
	  }

   }

   return (*other_gFunctionTable.pfnClientConnect)(pEntity, pszName, pszAddress, szRejectReason);
}

void ClientDisconnect( edict_t *pEntity )
{
   if (gpGlobals->deathmatch)
   {
      int i;
      bool AreSBotsInGame = false;
      edict_t *pPlayer = NULL;
	  int BotIndex = 0;

      if (debug_engine)
	  {
		  fp=fopen("bot.txt","a"); fprintf(fp, "ClientDisconnect: %x\n",pEntity); fclose(fp);
	  }

      i = 0;
      while ((i < 32) && (ClientInfo[i].pEdict != pEntity))
         i++;

      if (i < 32)
	  {
		 ClientInfo[i].pEdict = NULL;
		 ClientInfo[i].DefendButtonsList.DeleteAllNodes();
#ifdef usestats
		 ClientInfo[i].WeaponStatistics.ClearAll();
#endif
		 memset(&ClientInfo[i], 0, sizeof(ClientInfo[i]));

		 NumPlayers--;
	  }

      for (i=0; i < 32; i++)
      {
		 if (bots[i].pEdict == pEntity)
         {
              // someone kicked this bot off of the server...

			  // for the esf bug, where the powerup aura of a kicked player would stay...
			  if (UTIL_IsValidPlayer(pEntity))
				  FakeClientCommand(pEntity,"-powerup",NULL,NULL);

      	      bots[i].is_used = false;  // this slot is now free to use

			  // Free dynamically allocated stuff
	          DeleteCombos(&bots[i]);
			  KillCurrentTask(&bots[i]);
			  if (bots[i].pBotWeaponList)
			  {
				  delete bots[i].pBotWeaponList;
				  bots[i].pBotWeaponList = NULL;
			  }

			  bots[i].kick_time = gpGlobals->time;  // save the kicked time

			  if (bots[i].SBotType > 0)
			  {
				bots[i].SBotType = -1;
				sprintf(bots[i].name,"");

				for (int j=1;i<=gpGlobals->maxClients;i++)
				{
					pPlayer = INDEXENT(j);

					if (pPlayer == bots[i].pEdict)
						continue;

					if (IsNull(pPlayer))
						continue;

					BotIndex = UTIL_GetBotIndex(pPlayer);
					if (BotIndex > -1)
					{
						if (bots[BotIndex].SBotType > -1)
						{
							AreSBotsInGame = true;
							break;
						}
					}
				}
				if (!AreSBotsInGame) // restore mp_plcatchup value
				      CVAR_SET_FLOAT("mp_plcatchup",OldPlCatchupValue);
				break;
			}
   		}
	  }
   }

#ifdef classstuff
   if (pClientManager)
	   pClientManager->DisconnectPlayer(pEntity);
#endif

   (*other_gFunctionTable.pfnClientDisconnect)(pEntity);
}

void ClientKill( edict_t *pEntity )
{
   if (debug_engine) { fp=fopen("bot.txt","a"); fprintf(fp, "ClientKill: %x\n",pEntity); fclose(fp); }
   (*other_gFunctionTable.pfnClientKill)(pEntity);
}

void ClientPutInServer( edict_t *pEntity )
{
   if (debug_engine) { fp=fopen("bot.txt","a"); fprintf(fp, "ClientPutInServer: %x\n",pEntity); fclose(fp); }

   int i = 0;

   while ((i < 32) && (ClientInfo[i].pEdict != NULL))
      i++;

   if (i < 32)
   {
      // store this clients edict in the clients array
	  ClientInfo[i].pEdict = pEntity;
	  ClientInfo[i].PSVal = 127;
	  ClientInfo[i].DefendButtonsList.DeleteAllNodes();
	  ClientInfo[i].FrozenTime = 0.0;
	  ClientInfo[i].LastSoundTime = 0.0;
	  memset(ClientInfo[i].OldPositions,0,sizeof(ClientInfo[i].OldPositions));

	  NumPlayers++;
   }
#ifdef classstuff
   CClient *pClient = pClientManager->GetClientFromEdict(pEntity);
   if (pClient)
	   pClient->ActivatePlayer(); // This player is now in game
#endif

   (*other_gFunctionTable.pfnClientPutInServer)(pEntity);
}

void ClientCommand( edict_t *pEntity )
{
#ifdef trycatchshit
	const char *pcmd = CMD_ARGV(0);
	const char *arg1 = CMD_ARGV(1);
    const char *arg2 = CMD_ARGV(2); 
	const char *arg3 = CMD_ARGV(3);
    const char *arg4 = CMD_ARGV(4);
	const char *arg5 = CMD_ARGV(5);
#endif

   if (gpGlobals->deathmatch)
   {
      const char *pcmd = Cmd_Argv(0);
      const char *arg1 = Cmd_Argv(1);

	  if ((!(pEntity->v.flags & FL_FAKECLIENT)) && (IsTeamPlay()))
	  {
		  if (FStrEq(pcmd, "jointeam"))
		  {
			  if ((arg1) && (*arg1))
			  {
				  if (FStrEq(arg1, "2"))
				  {
					  // Player wants to join team evil. Check if there are any sbots and if so
					  // prevent the player from switching team :)

					  edict_t *pPlayer;
					  bot_t *pBot;

					  for (byte b=1;b<=gpGlobals->maxClients;b++)
					  {
						  pPlayer = INDEXENT(b);

						  if (UTIL_IsValidPlayer(pPlayer, false) == false)
							  continue;

						  if (pPlayer->v.flags & FL_FAKECLIENT)
						  {
							  pBot = UTIL_GetBotPointer(pPlayer);
							  if ((pBot) && (pBot->SBotType > 0)) // Player is a superbot?
							  {
								  UTIL_Printf("Cannot join team evil when there are superbots ingame\n",
											  HUD_PRINTTALK, pEntity);
								  return; // Don't execute the command
							  }
						  }
					  }
				  }
			  }
		  }
	  }

#ifdef _DEBUG
	  if (FStrEq(pcmd,"pl"))
	  {
		  if (arg1 != NULL)
		  {
			  UTIL_ChangePl(pEntity, atoi(arg1));
			  UTIL_ChangeRealPl(pEntity, atoi(arg1));
			  return;
		  }
	  }
	
	  if (FStrEq(pcmd,"ki"))
	  {
		  if (arg1 != NULL)
		  {
			  UTIL_ChangeKi(pEntity, atoi(arg1));
			  return;
		  }
	  }

	  if (FStrEq(pcmd,"health"))
	  {
		  if (arg1 != NULL)
		  {
			  pEntity->v.health = atoi(arg1);
			  return;
		  }
	  }

	  if (FStrEq(pcmd,"frags"))
	  {
		  if (arg1 != NULL)
		  {
			  pEntity->v.frags = atoi(arg1);
			  return;
		  }
	  }

	  if (FStrEq(pcmd,"bot_teleport"))
	  {
		  if (arg1 != NULL)
		  {
			  edict_t *pPlayer = NULL;
			  for (int i=0;i<32;i++)
			  {
				  pPlayer = INDEXENT(i);

				  if (!UTIL_IsValidPlayer(pPlayer))
					  continue;

				  if (FStrEq(STRING(pPlayer->v.netname), arg1))
				  {
					  UTIL_MakeVectors(pEntity->v.v_angle);

					  Vector v_src = pEntity->v.origin;
					  Vector v_end = v_src + Vector(0,0,20) + gpGlobals->v_forward * 100;
					  TraceResult tr;

					  UTIL_TraceHull(v_src, v_end, dont_ignore_monsters, 1, pEntity, &tr);

					  if (tr.flFraction >= 1.0)
						  SET_ORIGIN(pPlayer,v_end);

					  return;
				  }
			  }
		  }
	  }
	  else if (FStrEq(pcmd,"bot_speed"))
	  {
		  if (arg1 != NULL)
		  {
			  for (int i=0;i<32;i++)
			  {
				  if ((bots[i].is_used) &&
				     ((FStrEq(STRING(bots[i].pEdict->v.netname), arg1))))
				  {
					  char botspeed[100] = "";
					  sprintf(botspeed,"%s maxspeed = %f\n", arg1, bots[i].f_max_speed);

					  UTIL_Printf(botspeed);
				  }
			  }
		  }
		  return;
	  }
	  else if (FStrEq(pcmd, "debugattacklist"))
	  {
/*		  edict_t *pent = GetNearestHostileAttack(pEntity, 2250.0, true);

		  if (pent)
		  {
			   UTIL_DrawBeam(pEntity, pEntity->v.origin, pent->v.origin, 5, 0, 0, 0, 255, 250, 5);
		  }

		  PrintAttackList();
*/
		  edict_t *pAttack = pAttackManager->GetNearestHostileAttack(pEntity, 2250.0, true);
		  if (pAttack)
			  UTIL_DrawBeam(pEntity, pEntity->v.origin, pAttack->v.origin, 5, 0, 0, 0, 255, 250, 5);

		  pAttackManager->PrintAttackList();
		  return;
	  }
	  else if (FStrEq(pcmd, "selfdestruct"))
	  {
		  ExplodePlayer(pEntity);
		  return;
	  }
#endif
   }

   // only allow custom commands if deathmatch mode and NOT dedicated server and
   // client sending command is the listen server client...
   if ((gpGlobals->deathmatch) && (!IS_DEDICATED_SERVER()) &&
       (pEntity == listenserver_edict))
   {
	   BotCommandWasFound = true;
	   ExecuteBotCommands();

	   // Uggly way to check if there was a valid command...
	   if (BotCommandWasFound)
	   {
		   return;
	   }
   }

#ifdef trycatchshit
	assert(pEntity);

   try{
#endif
   (*other_gFunctionTable.pfnClientCommand)(pEntity);
#ifdef trycatchshit
   }
   catch (...)
   {
		lcout << "Client command command error !!\n";

		if ((!IsNull(pEntity)) && (pEntity->v.netname))
			lcout << "Caused by " << STRING(pEntity->v.netname) << "\n";

		clog << "ClientCommand error, time: " << gpGlobals->time << "\n";

		if ((!IsNull(pEntity)) && (pEntity->v.netname))
			clog << "Caused by " << STRING(pEntity->v.netname) << "\n";

		clog << "Command: " << pcmd << "\n";

        if ((arg1 != NULL) && (*arg1 != 0))
            clog << "Arg1: " << arg1 << "\n";
        if ((arg2 != NULL) && (*arg2 != 0))
            clog << "Arg2: " << arg2 << "\n";
        if ((arg3 != NULL) && (*arg3 != 0))
            clog << "Arg3: " << arg3 << "\n";
        if ((arg4 != NULL) && (*arg4 != 0))
            clog << "Arg4: " << arg4 << "\n";
        if ((arg5 != NULL) && (*arg5 != 0))
            clog << "Arg5: " << arg5 << "\n";

        clog << "\n";

		bot_t *pBot = UTIL_GetBotPointer(pEntity);
		if (pBot)
			LogBotInfo(pBot);

		if ((KickCorruptedBots) && (pEntity->v.flags & FL_FAKECLIENT))
		{
//			ClientKill(pEntity);

			char cmd[40];
			sprintf(cmd, "kick \"%s\"\n", STRING(pEntity->v.netname));

			SERVER_COMMAND(cmd);  // kick the bot using (kick "name")
		}
	}
#endif
   return;
}

void ClientUserInfoChanged( edict_t *pEntity, char *infobuffer )
{
   if (debug_engine) { fp=fopen("bot.txt", "a"); fprintf(fp, "ClientUserInfoChanged: pEntity=%x infobuffer=%s\n", pEntity, infobuffer); fclose(fp); }

   (*other_gFunctionTable.pfnClientUserInfoChanged)(pEntity, infobuffer);
}

void ServerActivate( edict_t *pEdictList, int edictCount, int clientMax )
{
#ifdef USEBSPSHIT
	// get the map name and build the corresponding BSP file name
	char bsp_file_path[256];
    sprintf (bsp_file_path, "maps/%s.bsp", STRING (gpGlobals->mapname));
    LoadBSPFile (bsp_file_path); // load the BSP file
    LookDownOnTheWorld (); // look down on the world and sort the walkable faces
#endif

   (*other_gFunctionTable.pfnServerActivate)(pEdictList, edictCount, clientMax);
}

void ServerDeactivate( void )
{
	if (debug_engine)
		clog << "ServerDeactivate() is called\n";

   // kick any bot off of the server after time/frag limit...
   for (int index = 0; index < 32; index++)
   {
      if (bots[index].is_used) // is this slot used?
      {
		  if (IsNull(bots[index].pEdict) == false)
		  {
			  char cmd[40];
			  sprintf(cmd, "kick \"%s\"\n", STRING(bots[index].pEdict->v.netname));
			  SERVER_COMMAND(cmd);  // kick the bot using (kick "name")
		  }
		  bots[index].respawn_state = RESPAWN_NEED_TO_RESPAWN;
	  }
   }

#ifdef USEBSPSHIT
   
   extern map_t map;

   int i, j, delimiters_count;

   // get a quick access to the world's bounding box
   Vector v_worldmins = map.dmodels[0].mins;
   Vector v_worldmaxs = map.dmodels[0].maxs;

   // now cycle through all the zone delimiters we know
   for (delimiters_count = 0; delimiters_count < map.zone_delimiters_count; delimiters_count++)
   {
      // compute the latitude and longitude in the topologic array
      i = (int) ((map.zone_delimiters[delimiters_count].v_origin.x - v_worldmins.x) / (v_worldmaxs.x - v_worldmins.x) * MAP_TOPOLOGY_GRANULARITY);
      j = (int) ((map.zone_delimiters[delimiters_count].v_origin.y - v_worldmins.y) / (v_worldmaxs.y - v_worldmins.y) * MAP_TOPOLOGY_GRANULARITY);

      // handle the cases where the delimiter is just on the right or upper edge of the array...
      if (i > MAP_TOPOLOGY_GRANULARITY - 1)
         i = MAP_TOPOLOGY_GRANULARITY - 1;
      if (j > MAP_TOPOLOGY_GRANULARITY - 1)
         j = MAP_TOPOLOGY_GRANULARITY - 1;

	  if (map.topology[i][j].delimiters)
	  {
		  free(map.topology[i][j].delimiters);
		  map.topology[i][j].delimiters = NULL;
	  }
   }

   // for each latitude/longitude sector of the map topology array, loop through all the faces...
   for (i = 0; i < MAP_TOPOLOGY_GRANULARITY; i++)
   {
      for (j = 0; j < MAP_TOPOLOGY_GRANULARITY; j++)
      {
	  	  if (map.topology[i][j].faces)
		  {
			  free(map.topology[i][j].faces);
			  map.topology[i][j].faces = NULL;
		  }
	  }
   }

   // do we need to free the texture data memory space ?
   if (map.dtexdata)
   {
	   free (map.dtexdata); // don't forget to free the texture data memory space we malloc'ed earlier
       map.dtexdata = NULL; // I want no one to access this pointer anymore, right ?
   }

   // do we need to free the zone delimiters memory space ?
   if (map.zone_delimiters)
   {
      free (map.zone_delimiters); // don't forget to free the zone delimiters memory space
      map.zone_delimiters = NULL; // I want no one to access this pointer anymore, right ?
   }
#endif

   // free/reset our stuff
//   DeleteAttackList();
   pAttackManager->ClearList();
   WaypointFree();
   pHostViewPlayer = NULL;
   TeamMenuShowedUp = false;
   ClassMenuShowedUp = false;
   CheckForDBSpot = true;
   NumPlayers = 0;

   (*other_gFunctionTable.pfnServerDeactivate)();
}

void PlayerPreThink( edict_t *pEntity )
{
#ifdef _DEBUG
	if ((pHostViewPlayer != NULL) && (pEntity == listenserver_edict))
	{
		int ClInd = UTIL_GetClientIndex(pHostViewPlayer);
		if (ClInd > -1)
		{
			UTIL_ChangePl(pEntity, ClientInfo[ClInd].PL);
			UTIL_ChangeKi(pEntity, pHostViewPlayer->v.fuser4);

			if (pHostViewPlayer->v.health > 0.0)
				pEntity->v.health = pHostViewPlayer->v.health;

			UTIL_MakeVectors(pHostViewPlayer->v.v_angle);

			Vector v_src = pHostViewPlayer->v.origin + pHostViewPlayer->v.view_ofs;
			Vector v_dest = v_src - (gpGlobals->v_forward * 60) + (gpGlobals->v_up * 50);
			TraceResult tr;

			UTIL_TraceHull(v_src, v_dest, dont_ignore_monsters, human_hull, pHostViewPlayer, &tr);

			pHostCam->pev->origin = tr.vecEndPos;
			pHostCam->pev->angles = pHostViewPlayer->v.angles;
			pHostCam->pev->v_angle = pHostViewPlayer->v.v_angle;
			pHostCam->pev->v_angle.x = UTIL_WrapAngle(pHostCam->pev->v_angle.x - 30.0);
			pHostCam->pev->v_angle.x = -pHostCam->pev->v_angle.x;
			pHostCam->pev->angles.x = UTIL_WrapAngle(pHostCam->pev->angles.x - 30.0);
			pHostCam->pev->angles.x = -pHostCam->pev->angles.x;

			pEntity->v.v_angle = pHostViewPlayer->v.v_angle;
			pEntity->v.angles = pHostViewPlayer->v.angles;
		}
	}

	if ((pBeamCam) && (pBeamCam->pev) && (pEntity == listenserver_edict) &&
		(!IsNull(pBeamCam->edict())))
	{
		if (!IsNull(pBeamViewEnt))
		{
			UTIL_MakeVectors(pBeamViewEnt->v.angles);

			Vector v_src = pBeamViewEnt->v.origin + pBeamViewEnt->v.view_ofs;
			Vector v_dest = v_src + (gpGlobals->v_forward * 40);
			TraceResult tr;

			UTIL_TraceHull(v_src, v_dest, dont_ignore_monsters, human_hull, pBeamViewEnt, &tr);

			pBeamCam->pev->origin = tr.vecEndPos;
			pBeamCam->pev->angles = pBeamViewEnt->v.angles;
			pBeamCam->pev->v_angle = pBeamViewEnt->v.v_angle;
			pBeamCam->pev->angles.x = -pBeamCam->pev->angles.x;

			pEntity->v.v_angle = pBeamViewEnt->v.v_angle;
			pEntity->v.angles = pBeamViewEnt->v.angles;
			lcout << "Velocity: " << pBeamViewEnt->v.velocity.Length();
		}
		else
			DeactivateBeamCam(pEntity);
	}


/*
	if (listenserver_edict == pEntity)
	{
		lcout << "Velocity: " << pEntity->v.velocity.Length() << "\n";
		UTIL_MakeVectors(pEntity->v.angles);
		UTIL_DrawBeam(pEntity, pEntity->v.origin, pEntity->v.origin + gpGlobals->v_up * 100, 10, 1, 255, 0, 0, 250, 5);

		UTIL_MakeVectors(pEntity->v.v_angle);
		UTIL_DrawBeam(pEntity, pEntity->v.origin, pEntity->v.origin + gpGlobals->v_up * 100, 10, 1, 0, 0, 255, 250, 5);
	}
*/

    if (hp_cheat) // lets cheat when we are debugging :-)
	{
		pEntity->v.health = 210;
		pEntity->v.fuser4 = 1000.0;
	}

#endif
	if ((g_waypoint_on) || (RealAutoWaypoint))
	{
		if (UTIL_IsValidPlayer(pEntity, true, false))
        {
            if (RealAutoWaypoint)
			{
				  if (pEntity->v.maxspeed > 0)// && (pPlayer->v.maxspeed < min_swoop_speed))
					  WaypointThink(pEntity);
			}
			else 
			{
				  WaypointThink(pEntity);
			}
        }
   }

#ifdef trycatchshit
	assert(pEntity);
	try
	{
#endif

	(*other_gFunctionTable.pfnPlayerPreThink)(pEntity);
#ifdef trycatchshit
	}
	catch(...)
	{
		lcout << "Pre think error!\n";
		clog << "Pre think error, time: " << gpGlobals->time << "\n";

		if ((!IsNull(pEntity)) && (pEntity->v.netname))
		{
			clog << "Caused by " << STRING(pEntity->v.netname) << "\n";
			lcout << "Caused by " << STRING(pEntity->v.netname) << "\n";

			bot_t *pBot = UTIL_GetBotPointer(pEntity);
			if (pBot)
				LogBotInfo(pBot);

			if ((KickCorruptedBots) && (pEntity->v.flags & FL_FAKECLIENT))
			{
//				ClientKill(pEntity);

				char cmd[40];
				sprintf(cmd, "kick \"%s\"\n", STRING(pEntity->v.netname));

				SERVER_COMMAND(cmd);  // kick the bot using (kick "name")

			}
		}
	}
#endif

}

void PlayerPostThink( edict_t *pEntity )
{
#ifdef trycatchshit
	assert(pEntity);
	try
	{
#endif
   (*other_gFunctionTable.pfnPlayerPostThink)(pEntity);
#ifdef trycatchshit
	}
	catch(...)
	{
		lcout << "Post think error!\n";
		clog << "Post think error, time: " << gpGlobals->time << "\n";

		if ((!IsNull(pEntity)) && (pEntity->v.netname))
		{
			clog << "Caused by " << STRING(pEntity->v.netname) << "\n";
			lcout << "Caused by " << STRING(pEntity->v.netname) << "\n";
		
			bot_t *pBot = UTIL_GetBotPointer(pEntity);
			if (pBot)
				LogBotInfo(pBot);

			if ((KickCorruptedBots) && (pEntity->v.flags & FL_FAKECLIENT))
			{
//				ClientKill(pEntity);

				char cmd[40];
				sprintf(cmd, "kick \"%s\"\n", STRING(pEntity->v.netname));

				SERVER_COMMAND(cmd);  // kick the bot using (kick "name")
			}
		}
	}
#endif
}

/*
int NewHandler(size_t size)
{
	char s[50] = "";
	sprintf(s, "Ran out of memory!\nSize: %d\n", size);
	clog << s;
	MessageBox(0, s, "Error\n", 0);
	return 0;
}
*/

void StartFrame( void )
{
	//_CrtSetBreakAlloc(1293);
   static float ResetTraceLineTime = 0.0;

   if (gpGlobals->deathmatch)
   {
#ifdef LOGBOTINFO
		clog << "Begin Start frame()\n";
#endif

      static int i, index, bot_index;
	  static float LastTeamBalanceCheck = 0.0;
	  static byte TeamGoodCount = 0;
	  static byte TeamEvilCount = 0;

      char msg[256];
      static int count;

      // if a new map has started then (MUST BE FIRST IN StartFrame)...
      if ((gpGlobals->time + 0.1) < previous_time)
      {
         char filename[256];
         char mapname[64];

		 // reset at start of map
		 ResetTraceLineTime = 0.0;
		 LastTeamBalanceCheck = 0.0;
		 fill_team = 0;
		 fill_half = fill_server = false;

		 memset(ClientInfo, 0, sizeof(ClientInfo));
            
         // check if mapname_bot.cfg file exists...

         strcpy(mapname, STRING(gpGlobals->mapname));
         strcat(mapname, "_bot.cfg");

		 sprintf(filename, "esf\\maps\\%s\\", mapname);

         if ((bot_cfg_fp = fopen(filename, "r")) != NULL)
         {
            sprintf(msg, "Executing %s\n", filename);
            ALERT( at_console, msg );

            for (index = 0; index < 32; index++)
            {
               bots[index].is_used = false;
               bots[index].respawn_state = 0;
               bots[index].kick_time = 0.0;
            }

            if (IS_DEDICATED_SERVER())
               bot_cfg_pause_time = gpGlobals->time + 5.0;
            else
               bot_cfg_pause_time = gpGlobals->time + 20.0;
         }
         else
         {
            count = 0;

            // mark the bots as needing to be respawned...
            for (index = 0; index < 32; index++)
            {
               if (count >= prev_num_bots)
               {
                  bots[index].is_used = false;
                  bots[index].respawn_state = 0;
                  bots[index].kick_time = 0.0;
               }

               if (bots[index].is_used)  // is this slot used?
               {
                  bots[index].respawn_state = RESPAWN_NEED_TO_RESPAWN;
                  count++;
               }

               // check for any bots that were very recently kicked...
               if ((bots[index].kick_time + 5.0) > previous_time)
               {
                  bots[index].respawn_state = RESPAWN_NEED_TO_RESPAWN;
                  count++;
               }
               else
                  bots[index].kick_time = 0.0;  // reset to prevent false spawns later
            }

            // set the respawn time
            if (IS_DEDICATED_SERVER())
               respawn_time = gpGlobals->time + 5.0;
            else
               respawn_time = gpGlobals->time + 30.0;
         }

         bot_check_time = gpGlobals->time + 30.0;
      }

	  if ((welcome_sent == false) && (welcome_time < 1.0))
	  {
		  if (!IS_DEDICATED_SERVER())
		  {
			  if (listenserver_edict != NULL)
			  {
				  // is the host out of observer mode yet?
				  if ((UTIL_IsValidPlayer(listenserver_edict)) && 
					  (listenserver_edict->v.playerclass >= 1) && 
					  (listenserver_edict->v.playerclass <= 9))
					  welcome_time = gpGlobals->time + 7.0;  // welcome in 7 seconds
			  }
		  }
		  else
		  {
			  welcome_time = gpGlobals->time + 3.0;
		  }
	  }

      if ((welcome_time > 0.0) && (welcome_time < gpGlobals->time) &&
          (welcome_sent == false))
	  {
		  if (!IS_DEDICATED_SERVER())
		  {
			if (IsPlayingMessage)
			{
				clog << "Tried to display text when there is already a message active\n";
				return;
			}

			  pfnMessageBegin (MSG_ONE, 23, NULL, listenserver_edict);
				pfnWriteByte (TE_TEXTMESSAGE);
				pfnWriteByte (1); // channel
				pfnWriteShort (-8192); // x coordinates * 8192
				pfnWriteShort (-8192); // y coordinates * 8192
				pfnWriteByte (0); // effect (fade in/out)
				pfnWriteByte (0); // initial RED
				pfnWriteByte (0); // initial GREEN
				pfnWriteByte (255); // initial BLUE
				pfnWriteByte (1); // initial ALPHA
				pfnWriteByte (0); // effect RED
				pfnWriteByte (0); // effect GREEN
				pfnWriteByte (255); // effect BLUE
				pfnWriteByte (1); // effect ALPHA
				pfnWriteShort (256); // fade-in time in seconds * 256
				pfnWriteShort (512); // fade-out time in seconds * 256
				pfnWriteShort (1024); // hold time in seconds * 256
				pfnWriteString (welcome_msg); // send welcome message
			  pfnMessageEnd (); // end

		      UTIL_Printf("Press - or type bot_help in the console for help\n", HUD_PRINTTALK);
		  }
		  else
		  {
			  UTIL_Printf("\n");
			  UTIL_Printf(welcome_msg);
			  UTIL_Printf("\n");

			  UTIL_Printf("Type bot_help in the console for help\n");

		  }

		  UTIL_Printf("Visit www.esforces.com/bot\n\n", HUD_PRINTTALK);
		  welcome_sent = true;  // clear this so we only do it once
	  }


#ifdef USEBSPSHIT
	  
      if ((UTIL_IsValidPlayer(listenserver_edict)) && (g_waypoint_on == false))
	  {
		  static zone_delimiter_t delimiter;
		  static float f_update_time = 0.0;
		  // if time to update the player's position
		  if (f_update_time < gpGlobals->time)
		  {
			  delimiter = GetNearestDelimiter (listenserver_edict); // get this player's nearest delimiter
			  if (delimiter.v_origin != g_vecZero)
			  {
				  UTIL_DrawBeam (listenserver_edict, delimiter.v_origin, 
					  delimiter.v_origin + Vector (0, 0, 64), 10, 5, 0, 0, 255, 255, 5);
				  UTIL_DrawBeam(listenserver_edict, listenserver_edict->v.origin, delimiter.v_origin, 
					  5, 10, 255, 255, 0, 250, 5);
			  
				  UTIL_DrawFace (delimiter.face, 2, 10, 0, 0, 0, 255, 255, 0);
				  f_update_time = gpGlobals->time + 0.2; // next update in half a second
			  }
		  }
	  }
#endif

	  count = 0;
  
	  if (fill_team != 0)
	  {
		  if (((fill_count >= (gpGlobals->maxClients/2)) && (fill_half)) ||
              ((fill_count >= gpGlobals->maxClients) && (!fill_half)))
		  {
              fill_server = false;
              fill_half = false;
		      fill_team = 0;
		      fill_count = 0;
          }
	  }
	  if (fill_count >= (gpGlobals->maxClients-1))
	  {
		  fill_server = false;
		  fill_team = 0;
		  fill_count = 0;
	  }

	  if ((fill_server) && (fill_count < gpGlobals->maxClients) && 
		  (fill_bot_check_time < gpGlobals->time))
	  {
		  fill_bot_check_time = gpGlobals->time + 1.0;
		  if (fill_team != 0)
		  {
       		  if (fill_team == 1)
       			  BotCreate(NULL, "1", NULL, NULL, NULL, NULL);
			  else
       			  BotCreate(NULL, "2", NULL, NULL, NULL, NULL);

              bot_check_time = gpGlobals->time + 5.0;
              fill_count++;
		  }
		  else
		  {
              BotCreate(NULL, NULL, NULL, NULL, NULL, NULL);
              bot_check_time = gpGlobals->time + 5.0;
              fill_count++;
		  }
	  }

	  if (PrintingInGameHelp)
		  UTIL_ShowInGameHelpWindow();

	  if (DrawDBSpots)
		  DrawDBGatherSpots();

//	  AttackListThink();
	  pAttackManager->Think();

	  bool CheckBalanceTeams = ((BalanceTeams) && (IsTeamPlay()) &&
								(LastTeamBalanceCheck < gpGlobals->time));

	  if (CheckBalanceTeams)
		  TeamGoodCount = TeamEvilCount = 0;

#ifdef classstuff
	  //pClientManager->pClientList->UnTill2<CClientManager>(pClientManager, CClientManager::FilterBadClients);
	  pClientManager->pClientList->ForEach(pClientManager, &CClientManager::LetClientsThink);
#endif

	  for(i=0;i<gpGlobals->maxClients;i++)
	  {
		  if (UTIL_IsValidPlayer(ClientInfo[i].pEdict, false, false) == false)
			  continue;

#ifdef LOGBOTINFO
		clog << "Begin client think\n";
#endif
		  
		  ClientThink(&ClientInfo[i]);
		  
#ifdef LOGBOTINFO
		clog << "End client think\n";
#endif

		  if (CheckBalanceTeams)
		  {
			  int Team = UTIL_GetTeam(ClientInfo[i].pEdict);

			  if (Team == 0)
				  TeamGoodCount++;
			  else if (Team == 1)
				  TeamEvilCount++;
		  }
	  }

	  if (CheckBalanceTeams)
	  {
		  if ((TeamGoodCount - 1) > TeamEvilCount)
		  {
			  for (i=0;i<gpGlobals->maxClients;i++)
			  {
				  if (UTIL_IsValidPlayer(bots[i].pEdict, false))
				  {
					  int Team = UTIL_GetTeam(bots[i].pEdict);

					  if (Team == 0) // is this bot in team good?
					  {
						  // let the bot join team evil
						  TeamGoodCount--; 
						  FakeClientCommand(bots[i].pEdict, "jointeam", "2", NULL);

						  if (TeamGoodCount <= TeamEvilCount)
							  break;
					  }
				  }
			  }
		  }
		  else if ((TeamEvilCount - 1) > TeamGoodCount)
		  {
			  for (i=0;i<gpGlobals->maxClients;i++)
			  {
				  if (UTIL_IsValidPlayer(bots[i].pEdict, false))
				  {
					  // Is this bot a superbot?
					  if (bots[i].SBotType > 0)
						  continue; // superbots stay at team evil

					  int Team = UTIL_GetTeam(bots[i].pEdict);

					  if (Team == 1) // is this bot in team evil?
					  {
						  // let the bot join team good
						  TeamEvilCount--;
						  FakeClientCommand(bots[i].pEdict, "jointeam", "1", NULL);

						  if (TeamEvilCount <= TeamGoodCount)
							  break;
					  }
				  }
			  }
		  }
	  }
	  
	  for (bot_index = 0; bot_index < gpGlobals->maxClients; bot_index++)
      {
         if ((bots[bot_index].is_used) &&  // is this slot used AND
             (bots[bot_index].respawn_state == RESPAWN_IDLE))  // not respawning
         {
			 if ((borg_mode) && (bots[bot_index].pEdict == listenserver_edict))
                bots[bot_index].pEdict->v.flags &= ~FL_FROZEN;

			 BotPreThink(&bots[bot_index]);

			 BotThink(&bots[bot_index]);

			 if ((borg_mode) && (bots[bot_index].pEdict == listenserver_edict))
                bots[bot_index].pEdict->v.flags |= FL_FROZEN;

			 count++;
         }
      }

      if (count > num_bots)
         num_bots = count;

      // are we currently respawning bots and is it time to spawn one yet?
      if ((respawn_time > 1.0) && (respawn_time <= gpGlobals->time))
      {
         int index = 0;

         // find bot needing to be respawned...
         while ((index < 32) &&
                (bots[index].respawn_state != RESPAWN_NEED_TO_RESPAWN))
            index++;

         if (index < 32)
         {
            int chat = bot_chat_percent;    // save global chat percent
            int taunt = bot_taunt_percent;  // save global taunt percent
            int whine = bot_whine_percent;  // save global whine percent
            int tag = bot_chat_tag_percent;    // save global clan tag percent
            int drop = bot_chat_drop_percent;  // save global chat drop percent
            int swap = bot_chat_swap_percent;  // save global chat swap percent
            int lower = bot_chat_lower_percent; // save global chat lower percent
            
			bots[index].respawn_state = RESPAWN_IS_RESPAWNING;
            bots[index].is_used = false;      // free up this slot

            bot_chat_percent = bots[index].chat_percent;
            bot_taunt_percent = bots[index].taunt_percent;
            bot_whine_percent = bots[index].whine_percent;
            bot_chat_tag_percent = bots[index].chat_tag_percent;
            bot_chat_drop_percent = bots[index].chat_drop_percent;
            bot_chat_swap_percent = bots[index].chat_swap_percent;
            bot_chat_lower_percent = bots[index].chat_lower_percent;

            // respawn 1 bot then wait a while (otherwise engine crashes)
            char c_skill[2];
            char c_team[2];
            char c_class[3];
		    char c_personality[2];

            sprintf(c_skill, "%d", bots[index].bot_skill);
            sprintf(c_team, "%d", bots[index].bot_team);
            sprintf(c_class, "%d", bots[index].bot_class);
			// Personalities are array based(so personr - 1)
            sprintf(c_personality, "%d", bots[index].Personality + 1);

			if (bots[index].SBotType > 0)
				SBotCreate(NULL, c_class, bots[index].SBotType, c_personality);
			else
				BotCreate(NULL, c_team, c_class, bots[index].name, c_skill, c_personality);
            
            bot_chat_percent = chat;    // restore global chat percent
            bot_taunt_percent = taunt;  // restore global taunt percent
            bot_whine_percent = whine;  // restore global whine percent
            bot_chat_tag_percent = tag;    // restore global chat percent
            bot_chat_drop_percent = drop;    // restore global chat percent
            bot_chat_swap_percent = swap;    // restore global chat percent
            bot_chat_lower_percent = lower;    // restore global chat percent

            respawn_time = gpGlobals->time + 2.0;  // set next respawn time

            bot_check_time = gpGlobals->time + 5.0;
         }
         else
         {
            respawn_time = 0.0;
         }
      }

      if (g_GameRules)
      {
         if (check_cvar_delay == 0)
			 check_cvar_delay = gpGlobals->time + 5.0;

		 if ((check_cvar_delay < gpGlobals->time) && (check_cvar_delay != -2))
		 {
			check_cvar_delay = gpGlobals->time + 3.0;

			int nb = CVAR_GET_FLOAT("numbots");
			int bs = CVAR_GET_FLOAT("bot_skill");
			//int mp = CVAR_GET_FLOAT("botmeleepercent");
			//int tp = CVAR_GET_FLOAT("botteleportpercent");

 			if ((count < nb) && (count < (gpGlobals->maxClients - 1)) && 
				(CVAR_GET_STRING("numbots")))
			{
				if  ((num_bots_check < gpGlobals->time) && (num_bots_check != -2))
				{
					BotCreate(NULL,NULL,NULL,NULL,NULL,NULL);
					bot_check_time = gpGlobals->time + 5.0;
					num_bots_check = gpGlobals->time + 8.0;
				}
			}
			else
				num_bots_check = -2;

			if ((default_bot_skill != (bs+1)) && (CVAR_GET_STRING("bot_skill")))
			{
			    int bot_nr;
				for (bot_nr=0;bot_nr<32;bot_nr++)
				{
					if (bots[i].SBotType < 1)
				 	    bots[bot_nr].bot_skill = bs;
				}
				default_bot_skill = bs+1;
			}

			// DISBALED because i don't see much use of it and it was giving some probs
/*
			if ((bot_melee_percent != mp) && (CVAR_GET_STRING("botmeleepercent")))
			{
				ChangeMeleePercent(mp);
			}

			if ((bot_teleport_percent != tp) && (CVAR_GET_STRING("botteleportpercent")))
			{
				ChangeTeleportPercent(tp);
			}
*/
		 }
#ifdef usedbcode
		 if (CheckForDBSpot)
			 DecideNextDBSpots();
#endif
         if (need_to_open_cfg)  // have we open bot.cfg file yet?
         {
            char filename[256];
            char mapname[64];

            need_to_open_cfg = false;  // only do this once!!!

            // check if mapname_bot.cfg file exists...

            strcpy(mapname, STRING(gpGlobals->mapname));
            strcat(mapname, "_bot.cfg");

            UTIL_BuildFileName(filename, "maps", mapname);

            if ((bot_cfg_fp = fopen(filename, "r")) != NULL)
            {
               sprintf(msg, "Executing %s\n", filename);
               ALERT( at_console, msg );
            }
            else
            {
               UTIL_BuildFileName(filename, "bot.cfg", NULL);

               sprintf(msg, "Executing %s\n", filename);
               ALERT( at_console, msg );

               bot_cfg_fp = fopen(filename, "r");

               if (bot_cfg_fp == NULL)
                  ALERT( at_console, "bot.cfg file not found\n" );
            }

            if (IS_DEDICATED_SERVER())
               bot_cfg_pause_time = gpGlobals->time + 5.0;
            else
               bot_cfg_pause_time = gpGlobals->time + 20.0;
         }

         if (!IS_DEDICATED_SERVER() && !spawn_time_reset)
         {
            if (listenserver_edict != NULL)
            {
               if (IsAlive(listenserver_edict))
               {
                  spawn_time_reset = true;

                  if (respawn_time >= 1.0)
                     respawn_time = min(respawn_time, gpGlobals->time + (float)1.0);

                  if (bot_cfg_pause_time >= 1.0)
                     bot_cfg_pause_time = min(bot_cfg_pause_time, gpGlobals->time + (float)1.0);
               }
            }
         }

         if ((bot_cfg_fp) &&
             (bot_cfg_pause_time >= 1.0) && (bot_cfg_pause_time <= gpGlobals->time))
         {
            // process bot.cfg file options... 
            ProcessBotCfgFile();
         }

      }      

      // check if time to see if a bot needs to be created...
      if ((bot_check_time < gpGlobals->time) && (max_bots != -1))
      {
         int count = 0;

         bot_check_time = gpGlobals->time + 5.0;

         for (i = 0; i < 32; i++)
         {
            if (IsNull(ClientInfo[i].pEdict) == false)
               count++;
         }

         // if there are currently less than the maximum number of "players"
         // then add another bot using the default skill level...
         if (count < max_bots)
         {
            BotCreate( NULL, NULL, NULL, NULL, NULL, NULL );
         }
      }

      previous_time = gpGlobals->time;
   }

#ifdef _DEBUG
   if (listenserver_edict)
   {
	   if (DisplayBotStuff)
		   DisplayDebugTexts();

	   for(short i=0;i<gpGlobals->maxClients;i++)
		   bots[i].VisiblePlayers = bots[i].PlayersChecked = 0;

	   if (ResetTraceLineTime < gpGlobals->time)
	   {
		   ResetTraceLineTime = gpGlobals->time + 1.0;

		   mcout << "Trace lines called last second: " << TraceLineCalls << "\n";
		   mcout << "FVisible called last second: " << FVisibleCalls << "\n";

		   float MeleePercent = 0.0;
		   
		   if (MeleeCalls)
			   MeleePercent = float(MeleeCalls) / (float(MeleeCalls) + float(KiAttackCalls)) * 100.0;
		   mcout << "Melee percent: " << MeleePercent << "\n";

		   TraceLineCalls = 0;
		   FVisibleCalls = 0;
	   }
   }
#endif

//   _set_new_handler( old_handler );
   (*other_gFunctionTable.pfnStartFrame)();

   cout.Display();

#ifdef _DEBUG
   // Variabeles to prevent overflows....
   bool DisplayNextOne = true;
   short lcoutLength = strlen(lcout.TextToDisplay);
   short rcoutLength = strlen(rcout.TextToDisplay);

   if (strlen(lcout.TextToDisplay) > 500)
	   DisplayNextOne = false;

   lcout.Display();

   if (DisplayNextOne)
   {
	   if ((lcoutLength + rcoutLength) > 500)
		   DisplayNextOne = false;

	   rcout.Display();
   }

   if (DisplayNextOne)
	   mcout.Display();
#endif

   //clog.EndFrame();
}

void ParmsNewLevel( void )
{
   (*other_gFunctionTable.pfnParmsNewLevel)();
}

void ParmsChangeLevel( void )
{
   (*other_gFunctionTable.pfnParmsChangeLevel)();
}

const char *GetGameDescription( void )
{
   return (*other_gFunctionTable.pfnGetGameDescription)();
}

void PlayerCustomization( edict_t *pEntity, customization_t *pCust )
{
   if (debug_engine) { fp=fopen("bot.txt", "a"); fprintf(fp, "PlayerCustomization: %x\n",pEntity); fclose(fp); }

   (*other_gFunctionTable.pfnPlayerCustomization)(pEntity, pCust);
}

void SpectatorConnect( edict_t *pEntity )
{
   (*other_gFunctionTable.pfnSpectatorConnect)(pEntity);
}

void SpectatorDisconnect( edict_t *pEntity )
{
   (*other_gFunctionTable.pfnSpectatorDisconnect)(pEntity);
}

void SpectatorThink( edict_t *pEntity )
{
   (*other_gFunctionTable.pfnSpectatorThink)(pEntity);
}

void Sys_Error( const char *error_string )
{
#ifdef _DEBUG
	_asm int 3;
#endif
    //fp=fopen("bot.txt","a"); fprintf(fp,"sys_error: %s\n",error_string); fclose(fp); 
	(*other_gFunctionTable.pfnSys_Error)(error_string);
}

void PM_Move ( struct playermove_s *ppmove, int server )
{
   (*other_gFunctionTable.pfnPM_Move)(ppmove, server);
}

void PM_Init ( struct playermove_s *ppmove )
{
   (*other_gFunctionTable.pfnPM_Init)(ppmove);
}

char PM_FindTextureType( char *name )
{
   return (*other_gFunctionTable.pfnPM_FindTextureType)(name);
}

void SetupVisibility( edict_t *pViewEntity, edict_t *pClient, unsigned char **pvs, unsigned char **pas )
{
   (*other_gFunctionTable.pfnSetupVisibility)(pViewEntity, pClient, pvs, pas);
}

void UpdateClientData ( const struct edict_s *ent, int sendweapons, struct clientdata_s *cd )
{
   (*other_gFunctionTable.pfnUpdateClientData)(ent, sendweapons, cd);
}

int AddToFullPack( struct entity_state_s *state, int e, edict_t *ent, edict_t *host, int hostflags, int player, unsigned char *pSet )
{
   return (*other_gFunctionTable.pfnAddToFullPack)(state, e, ent, host, hostflags, player, pSet);
}

void CreateBaseline( int player, int eindex, struct entity_state_s *baseline, struct edict_s *entity, int playermodelindex, vec3_t player_mins, vec3_t player_maxs )
{
   (*other_gFunctionTable.pfnCreateBaseline)(player, eindex, baseline, entity, playermodelindex, player_mins, player_maxs);
}

void RegisterEncoders( void )
{
   (*other_gFunctionTable.pfnRegisterEncoders)();
}

int GetWeaponData( struct edict_s *player, struct weapon_data_s *info )
{
   return (*other_gFunctionTable.pfnGetWeaponData)(player, info);
}

void CmdStart( const edict_t *player, const struct usercmd_s *cmd, unsigned int random_seed )
{/*
	if ((player == listenserver_edict) && (player))
	{
		cout << "you're move speed = " << cmd->forwardmove << "\n";
		cout << "you're side speed = " << cmd->sidemove << "\n";
		cout << "you're up speed = " << cmd->upmove << "\n";

		bot_t *pBot = UTIL_GetBotPointer(const_cast<edict_t*>(player));
		if (pBot)
		{
			usercmd_t *uc = const_cast<usercmd_t*>(cmd);
			uc->forwardmove = pBot->f_move_speed;
			uc->sidemove = pBot->f_strafe_speed;
			uc->upmove = pBot->f_updown_speed;
			uc->msec = pBot->msecval;
			uc->buttons = pBot->pEdict->v.button;
		}
	}*/
   (*other_gFunctionTable.pfnCmdStart)(player, cmd, random_seed);
}

void CmdEnd ( const edict_t *player )
{
   (*other_gFunctionTable.pfnCmdEnd)(player);
}

int ConnectionlessPacket( const struct netadr_s *net_from, const char *args, char *response_buffer, int *response_buffer_size )
{
   return (*other_gFunctionTable.pfnConnectionlessPacket)(net_from, args, response_buffer, response_buffer_size);
}

int GetHullBounds( int hullnumber, float *mins, float *maxs )
{
   return (*other_gFunctionTable.pfnGetHullBounds)(hullnumber, mins, maxs);
}

void CreateInstancedBaselines( void )
{
   (*other_gFunctionTable.pfnCreateInstancedBaselines)();
}

int InconsistentFile( const edict_t *player, const char *filename, char *disconnect_message )
{
   if (debug_engine) { fp=fopen("bot.txt", "a"); fprintf(fp, "InconsistentFile: %x filename=%s\n",player,filename); fclose(fp); }

   return (*other_gFunctionTable.pfnInconsistentFile)(player, filename, disconnect_message);
}

int AllowLagCompensation( void )
{
   return (*other_gFunctionTable.pfnAllowLagCompensation)();
}


DLL_FUNCTIONS gFunctionTable =
{
   GameDLLInit,               //pfnGameInit
   DispatchSpawn,             //pfnSpawn
   DispatchThink,             //pfnThink
   DispatchUse,               //pfnUse
   DispatchTouch,             //pfnTouch
   DispatchBlocked,           //pfnBlocked
   DispatchKeyValue,          //pfnKeyValue
   DispatchSave,              //pfnSave
   DispatchRestore,           //pfnRestore
   DispatchObjectCollsionBox, //pfnAbsBox

   SaveWriteFields,           //pfnSaveWriteFields
   SaveReadFields,            //pfnSaveReadFields

   SaveGlobalState,           //pfnSaveGlobalState
   RestoreGlobalState,        //pfnRestoreGlobalState
   ResetGlobalState,          //pfnResetGlobalState

   ClientConnect,             //pfnClientConnect
   ClientDisconnect,          //pfnClientDisconnect
   ClientKill,                //pfnClientKill
   ClientPutInServer,         //pfnClientPutInServer
   ClientCommand,             //pfnClientCommand
   ClientUserInfoChanged,     //pfnClientUserInfoChanged
   ServerActivate,            //pfnServerActivate
   ServerDeactivate,          //pfnServerDeactivate

   PlayerPreThink,            //pfnPlayerPreThink
   PlayerPostThink,           //pfnPlayerPostThink

   StartFrame,                //pfnStartFrame
   ParmsNewLevel,             //pfnParmsNewLevel
   ParmsChangeLevel,          //pfnParmsChangeLevel

   GetGameDescription,        //pfnGetGameDescription    Returns string describing current .dll game.
   PlayerCustomization,       //pfnPlayerCustomization   Notifies .dll of new customization for player.

   SpectatorConnect,          //pfnSpectatorConnect      Called when spectator joins server
   SpectatorDisconnect,       //pfnSpectatorDisconnect   Called when spectator leaves the server
   SpectatorThink,            //pfnSpectatorThink        Called when spectator sends a command packet (usercmd_t)

   Sys_Error,                 //pfnSys_Error          Called when engine has encountered an error

   PM_Move,                   //pfnPM_Move
   PM_Init,                   //pfnPM_Init            Server version of player movement initialization
   PM_FindTextureType,        //pfnPM_FindTextureType

   SetupVisibility,           //pfnSetupVisibility        Set up PVS and PAS for networking for this client
   UpdateClientData,          //pfnUpdateClientData       Set up data sent only to specific client
   AddToFullPack,             //pfnAddToFullPack
   CreateBaseline,            //pfnCreateBaseline        Tweak entity baseline for network encoding, allows setup of player baselines, too.
   RegisterEncoders,          //pfnRegisterEncoders      Callbacks for network encoding
   GetWeaponData,             //pfnGetWeaponData
   CmdStart,                  //pfnCmdStart
   CmdEnd,                    //pfnCmdEnd
   ConnectionlessPacket,      //pfnConnectionlessPacket
   GetHullBounds,             //pfnGetHullBounds
   CreateInstancedBaselines,  //pfnCreateInstancedBaselines
   InconsistentFile,          //pfnInconsistentFile
   AllowLagCompensation,      //pfnAllowLagCompensation
};

#ifdef __BORLANDC__
int EXPORT GetEntityAPI( DLL_FUNCTIONS *pFunctionTable, int interfaceVersion )
#else
extern "C" EXPORT int GetEntityAPI( DLL_FUNCTIONS *pFunctionTable, int interfaceVersion )
#endif
{
   // check if engine's pointer is valid and version is correct...

   if ( !pFunctionTable || interfaceVersion != INTERFACE_VERSION )
      return false;

   // pass engine callback function table to engine...
   memcpy( pFunctionTable, &gFunctionTable, sizeof( DLL_FUNCTIONS ) );

   // pass other DLLs engine callbacks to function table...
   if (!(*other_GetEntityAPI)(&other_gFunctionTable, INTERFACE_VERSION))
   {
      return false;  // error initializing function table!!!
   }

   return true;
}


#ifdef __BORLANDC__
int EXPORT GetNewDLLFunctions( NEW_DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion )
#else
extern "C" EXPORT int GetNewDLLFunctions( NEW_DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion )
#endif
{
   if (other_GetNewDLLFunctions == NULL)
      return false;

   // pass other DLLs engine callbacks to function table...
   if (!(*other_GetNewDLLFunctions)(pFunctionTable, interfaceVersion))
   {
      return false;  // error initializing function table!!!
   }

   return true;
}


void FakeClientCommand(edict_t *pBot, char *arg1, char *arg2, char *arg3)
{
   int length;

   memset(g_argv, 0, sizeof(g_argv));

   if ((arg1 == NULL) || (*arg1 == 0))
      return;

   isFakeClientCommand = 1;

   if ((arg2 == NULL) || (*arg2 == 0))
   {
      length = sprintf(&g_argv[0], "%s", arg1);
      fake_arg_count = 1;
   }
   else if ((arg3 == NULL) || (*arg3 == 0))
   {
      length = sprintf(&g_argv[0], "%s %s", arg1, arg2);
      fake_arg_count = 2;
   }
   else
   {
      length = sprintf(&g_argv[0], "%s %s %s", arg1, arg2, arg3);
      fake_arg_count = 3;
   }

   g_argv[length] = 0;  // null terminate just in case

   strcpy(&g_argv[64], arg1);

   if (arg2)
      strcpy(&g_argv[128], arg2);

   if (arg3)
      strcpy(&g_argv[192], arg3);

   // allow the MOD DLL to execute the ClientCommand...
   ClientCommand(pBot);

   isFakeClientCommand = 0;
}



const char *Cmd_Args( void )
{
   if (isFakeClientCommand)
   {
      return &g_argv[0];
   }
   else
   {
      return (*g_engfuncs.pfnCmd_Args)();
   }
}


const char *Cmd_Argv( int argc )
{
   if (isFakeClientCommand)
   {
      if (argc == 0)
      {
         return &g_argv[64];
      }
      else if (argc == 1)
      {
         return &g_argv[128];
      }
      else if (argc == 2)
      {
         return &g_argv[192];
      }
      else
      {
         return NULL;
      }
   }
   else
   {
      return (*g_engfuncs.pfnCmd_Argv)(argc);
   }
}


int Cmd_Argc( void )
{
   if (isFakeClientCommand)
   {
      return fake_arg_count;
   }
   else
   {
      return (*g_engfuncs.pfnCmd_Argc)();
   }
}


void ProcessBotCfgFile(void)
{
   int ch;
   char cmd_line[256];
   int cmd_index;
   static char server_cmd[80];
   char *cmd, *arg1, *arg2, *arg3, *arg4, *arg5;
   char msg[80];

   if (bot_cfg_pause_time > gpGlobals->time)
      return;

   if (bot_cfg_fp == NULL)
      return;
     
   cmd_index = 0;
   cmd_line[cmd_index] = 0;

   ch = fgetc(bot_cfg_fp);

   // skip any leading blanks
   while (ch == ' ')
      ch = fgetc(bot_cfg_fp);

   while ((ch != EOF) && (ch != '\r') && (ch != '\n'))
   {
      if (ch == '\t')  // convert tabs to spaces
         ch = ' ';

      cmd_line[cmd_index] = ch;

      ch = fgetc(bot_cfg_fp);

      // skip multiple spaces in input file
      while ((cmd_line[cmd_index] == ' ') &&
             (ch == ' '))      
         ch = fgetc(bot_cfg_fp);

      cmd_index++;
   }

   if (ch == '\r')  // is it a carriage return?
   {
      ch = fgetc(bot_cfg_fp);  // skip the linefeed
   }

   // if reached end of file, then close it
   if (ch == EOF)
   {
      fclose(bot_cfg_fp);

      bot_cfg_fp = NULL;

      bot_cfg_pause_time = 0.0;
   }

   cmd_line[cmd_index] = 0;  // terminate the command line

   // copy the command line to a server command buffer...
   strcpy(server_cmd, cmd_line);
   strcat(server_cmd, "\n");

   cmd_index = 0;
   cmd = cmd_line;
   arg1 = arg2 = arg3 = arg4 = arg5 = NULL;

   // skip to blank or end of string...
   while ((cmd_line[cmd_index] != ' ') && (cmd_line[cmd_index] != 0))
      cmd_index++;

   if (cmd_line[cmd_index] == ' ')
   {
      cmd_line[cmd_index++] = 0;
      arg1 = &cmd_line[cmd_index];

      // skip to blank or end of string...
      while ((cmd_line[cmd_index] != ' ') && (cmd_line[cmd_index] != 0))
         cmd_index++;

      if (cmd_line[cmd_index] == ' ')
      {
         cmd_line[cmd_index++] = 0;
         arg2 = &cmd_line[cmd_index];

         // skip to blank or end of string...
         while ((cmd_line[cmd_index] != ' ') && (cmd_line[cmd_index] != 0))
            cmd_index++;

         if (cmd_line[cmd_index] == ' ')
         {
            cmd_line[cmd_index++] = 0;
            arg3 = &cmd_line[cmd_index];

            // skip to blank or end of string...
            while ((cmd_line[cmd_index] != ' ') && (cmd_line[cmd_index] != 0))
               cmd_index++;

            if (cmd_line[cmd_index] == ' ')
            {
               cmd_line[cmd_index++] = 0;
               arg4 = &cmd_line[cmd_index];

               // skip to blank or end of string...
               while ((cmd_line[cmd_index] != ' ') && (cmd_line[cmd_index] != 0))
                  cmd_index++;

               if (cmd_line[cmd_index] == ' ')
		   {
                   cmd_line[cmd_index++] = 0;
                   arg5 = &cmd_line[cmd_index];
		   }
            }
         }
      }
   }

   if ((cmd_line[0] == '#') || (cmd_line[0] == 0))
      return;  // return if comment or blank line

   if (strcmp(cmd, "addbot") == 0)
   {
      BotCreate( NULL, arg1, arg2, arg3, arg4, arg5 );

      // have to delay here or engine gives "Tried to write to
      // uninitialized sizebuf_t" error and crashes...

      bot_cfg_pause_time = gpGlobals->time + 2.0;
      bot_check_time = gpGlobals->time + 5.0;

      return;
   }

   if (strcmp(cmd, "addsbot") == 0)
   {
      SBotCreate( NULL, arg2, atoi(arg1), arg3);

      // have to delay here or engine gives "Tried to write to
      // uninitialized sizebuf_t" error and crashes...

      bot_cfg_pause_time = gpGlobals->time + 2.0;
      bot_check_time = gpGlobals->time + 5.0;

      return;
   }

   if (strcmp(cmd, "botskill") == 0)
   {
      int temp = atoi(arg1);

      if ((temp >= 1) && (temp <= 5))
	  {
		  default_bot_skill = atoi( arg1 );  // set default bot skill level
		  CVAR_SET_FLOAT("bot_skill",default_bot_skill-1);
		  for (int i=0;i<32;i++)
		  {
			  if (bots[i].SBotType < 1)
				bots[i].bot_skill = default_bot_skill-1;
		  }
	  }

      return;
   }

/*
   if (strcmp(cmd, "bot_melee_percent") == 0)
   {
      int temp = atoi(arg1);

      if ((temp >= 0) && (temp <= 100))
      {
		  bot_melee_percent = atoi( arg1 );  // set bot melee percent
		  CVAR_SET_FLOAT("botmeleepercent",bot_melee_percent);
	  }
      else if (temp == -1)
	  {
		  bot_melee_percent = RANDOM_LONG(1, 100);
		  CVAR_SET_FLOAT("botmeleepercent",bot_melee_percent);
	  }
      return;
   }

   if (strcmp(cmd, "bot_teleport_percent") == 0)
   {
      int temp = atoi(arg1);

      if ((temp >= 0) && (temp <= 100))
      {
		  bot_teleport_percent = atoi( arg1 );  // set bot teleport percent
		  CVAR_SET_FLOAT("botteleportpercent",bot_teleport_percent);
	  }
      else if (temp == -1)
	  {
		  bot_teleport_percent = RANDOM_LONG(1, 100);
		  CVAR_SET_FLOAT("botteleportpercent",bot_teleport_percent);
	  }
      return;
   }


   if (strcmp(cmd, "bot_chat_percent") == 0)
   {
      int temp = atoi(arg1);

      if ((temp >= 0) && (temp <= 100))
         ChangeChatPercent(atoi( arg1 ));  // set bot chat percent

      return;
   }

   if (strcmp(cmd, "bot_taunt_percent") == 0)
   {
      int temp = atoi(arg1);

      if ((temp >= 0) && (temp <= 100))
         ChangeTauntPercent(atoi( arg1 ));  // set bot taunt percent

      return;
   }

   if (strcmp(cmd, "bot_whine_percent") == 0)
   {
      int temp = atoi(arg1);

      if ((temp >= 0) && (temp <= 100))
         ChangeWhinePercent(atoi( arg1 ));  // set bot whine percent

      return;
   }

   if (strcmp(cmd, "bot_chat_tag_percent") == 0)
   {
      int temp = atoi(arg1);

      if ((temp >= 0) && (temp <= 100))
         ChangeChatTagPercent(atoi( arg1 ));  // set bot chat percent

      return;
   }

   if (strcmp(cmd, "bot_chat_drop_percent") == 0)
   {
      int temp = atoi(arg1);

      if ((temp >= 0) && (temp <= 100))
         ChangeChatDropPercent(atoi( arg1 ));  // set bot chat percent


      return;
   }

   if (strcmp(cmd, "bot_chat_swap_percent") == 0)
   {
      int temp = atoi(arg1);

      if ((temp >= 0) && (temp <= 100))
         ChangeChatSwapPercent(atoi( arg1 ));  // set bot chat percent

      return;
   }

   if (strcmp(cmd, "bot_chat_lower_percent") == 0)
   {
      int temp = atoi(arg1);

      if ((temp >= 0) && (temp <= 100))
         ChangeChatLowerPercent(atoi( arg1 ));  // set bot chat percent

      return;
   }

   if (strcmp(cmd, "observer") == 0)
   {
      int temp = atoi(arg1);

      if (temp)
         b_observer_mode = true;
      else
         b_observer_mode = false;

      return;
   }*/

   if (strcmp(cmd, "should_bot_chat") == 0)
   {
      int temp = atoi(arg1);

      if (temp)
         should_bot_chat = true;
      else
         should_bot_chat = false;

      return;
   }

   if (strcmp(cmd, "follow_mode") == 0)
   {
      int temp = atoi(arg1);

      if (temp)
         follow_mode = true;
      else
         follow_mode = false;

      return;
   }

   if (FStrEq(cmd, "botsusediscs"))
   {
		 if ((arg1 != NULL) && (*arg1 != 0))
		 {
			int temp = atoi(arg1);

			if (temp)
				BotsUseDiscs = true;
			else
				BotsUseDiscs = false;
		 }
         return;
   } 

   if (strcmp(cmd, "botdontshoot") == 0)
   {
      int temp = atoi(arg1);

      if (temp)
         b_botdontshoot = true;
      else
         b_botdontshoot = false;

      return;
   }

   if (strcmp(cmd, "min_bots") == 0)
   {
      min_bots = atoi( arg1 );

      if ((min_bots < 0) || (min_bots > 31))
         min_bots = 1;

      if (IS_DEDICATED_SERVER())
      {
         sprintf(msg, "min_bots set to %d\n", min_bots);
         UTIL_Printf(msg);
      }

      return;
   }

   if (strcmp(cmd, "max_bots") == 0)
   {
      max_bots = atoi( arg1 );

      if ((max_bots < 0) || (max_bots > 31)) 
         max_bots = 1;

      if (IS_DEDICATED_SERVER())
      {
         sprintf(msg, "max_bots set to %d\n", max_bots);
         UTIL_Printf(msg);
      }

      return;
   }

   if (strcmp(cmd, "pause") == 0)
   {
      bot_cfg_pause_time = gpGlobals->time + atoi( arg1 );

      return;
   }

   if (strcmp(cmd, "bot_fill") == 0)
   {
      if (strcmp(arg1, "full") == 0)
      {
         fill_server = true;
         fill_half = false;
         fill_team = 0;
         fill_count = 0;
         return;
      }
      if (strcmp(arg1, "half_good") == 0)
      {
         fill_server = true;
         fill_half = true;
         fill_team = 1;
         fill_count = 0;
         return;
      }
      if (strcmp(arg1, "half_evil") == 0)
      {
         fill_server = true;
         fill_half = true;
         fill_team = 2;
         fill_count = 0;
         return;
      }
      if (strcmp(arg1, "full_good") == 0)
      {
         fill_server = true;
         fill_half = false;
         fill_team = 1;
         fill_count = 0;
         return;
      }
      if (strcmp(arg1, "full_evil") == 0)
      {
         fill_server = true;
         fill_half = false;
         fill_team = 2;
         fill_count = 0;
         return;
      }
      return;
   } 
   if (FStrEq(cmd, "bot_balanceteams"))
   {
	   if ((arg1 != NULL) && (*arg1 != 0))
	   {
		   int temp = atoi(arg1);

		   if (temp)
			   BalanceTeams = true;
		   else
			   BalanceTeams = false;
	   }
	   return;
   }
   
   if (FStrEq(cmd, "botsalwaystrytoascend"))
   {
	   if ((arg1 != NULL) && (*arg1 != NULL))
	   {
		   short Temp = atoi(arg1);
		   
		   if (Temp == -1)
			   BotsAlwaysTryToAscend ^= 1; // Toggle it
		   else if (Temp == 1)
			   BotsAlwaysTryToAscend = true;
		   else
			   BotsAlwaysTryToAscend = false;
	   }
	   return;
   }

   sprintf(msg, "executing server command: %s\n", server_cmd);
   UTIL_Printf(msg);

   SERVER_COMMAND(server_cmd);
}

// TODO: This function REALLY need a clean up...
void ExecuteBotCommands()
{
	int AddValue = (IS_DEDICATED_SERVER()) ? 1 : 0;

	const char *pcmd = CMD_ARGV(0 + AddValue);
    const char *arg1 = CMD_ARGV(1 + AddValue);
    const char *arg2 = CMD_ARGV(2 + AddValue); 
    const char *arg3 = CMD_ARGV(3 + AddValue);
    const char *arg4 = CMD_ARGV(4 + AddValue);
    const char *arg5 = CMD_ARGV(5 + AddValue);

    char msg[80];

    if (debug_engine)
	{
		fp=fopen("bot.txt","a"); fprintf(fp,"ClientCommand: %s",pcmd);
        if ((arg1 != NULL) && (*arg1 != 0))
            fprintf(fp," %s", arg1);
        if ((arg2 != NULL) && (*arg2 != 0))
            fprintf(fp," %s", arg2);
        if ((arg3 != NULL) && (*arg3 != 0))
            fprintf(fp," %s", arg3);
        if ((arg4 != NULL) && (*arg4 != 0))
            fprintf(fp," %s", arg4);
        fprintf(fp, "\n");
        fclose(fp);
	}

    if (strcmp(pcmd, "bot_fill") == 0)
	{
		if (strcmp(arg1, "full") == 0)
		{
            fill_server = true;
            fill_half = false;
            fill_team = 0;
            fill_count = 0;
            return;
		 }
         if (strcmp(arg1, "half_good") == 0)
		 {
            fill_server = true;
            fill_half = true;
            fill_team = 1;
            fill_count = 0;
            return;
		 }
         if (strcmp(arg1, "half_evil") == 0)
		 {
            fill_server = true;
            fill_half = true;
            fill_team = 2;
            fill_count = 0;
            return;
		 }
         if (strcmp(arg1, "full_good") == 0)
		 {
            fill_server = true;
            fill_half = false;
            fill_team = 1;
            fill_count = 0;
            return;
		 }
         if (strcmp(arg1, "full_evil") == 0)
		 {
            fill_server = true;
            fill_half = false;
            fill_team = 2;
            fill_count = 0;
            return;
		 }
         return;
	  }
	  else if (FStrEq(pcmd,"bot_command"))
	  {
		  if ((arg1 != NULL) && (arg2 != NULL))
		  {
			  edict_t *pPlayer = NULL;
			  for (int i=0;i<32;i++)
			  {
				  if (bots[i].is_used == false)
					  continue;

				  pPlayer = bots[i].pEdict;

				  if (IsNull(pPlayer))
					  continue;

				  if (FStrEq(STRING(pPlayer->v.netname), arg1))
				  {
					  char ar1[100], ar2[100], ar3[100], s[100];
					  strcpy(ar1, arg2);
					  strcpy(ar2, arg3);
					  strcpy(ar3, arg4);

					  if (FStrEq(ar1,"kill"))
						ClientKill(pPlayer);
					  else
					  	FakeClientCommand(pPlayer, ar1, ar2, ar3);

					  sprintf(s, "bot %s excutes command: %s %s %s", STRING(pPlayer->v.netname), 
						      ar1, ar2, ar3);
					  UTIL_Printf(s);
					  return;
				  }
			  }
		  }
	  }
      else if (FStrEq(pcmd, "addbot"))
      {
         BotCreate( listenserver_edict, arg1, arg2, arg3, arg4, arg5 );

         bot_check_time = gpGlobals->time + 5.0;

         return;
      }
      else if (FStrEq(pcmd, "addsbot"))
      {
		 if (IsTeamPlay() == false)
		 {
			 UTIL_Printf("Can't create Super bots with free fight !");
			 return;
		 }

		 SBotCreate( listenserver_edict, arg2, atoi(arg1), arg3);
		 
         bot_check_time = gpGlobals->time + 5.0;

         return;
      }
	  //EEKHOORN : OUR NEW FRESH 'N STEAMY KICK BOT CMDS
      else if (FStrEq(pcmd, "botkicklast"))
      {
		  int index;
         
		  for (index = 32; index >= 0; index--)
		  {
			  // is this slot used?
			  if ((bots[index].is_used) && (bots[index].pEdict != listenserver_edict) &&
				  (!IsNull(bots[index].pEdict)))
			  {
				  char cmd[40];
				  sprintf(cmd, "kick \"%s\"\n", STRING(bots[index].pEdict->v.netname));
				  
				  SERVER_COMMAND(cmd);  // kick the bot using (kick "name")
				  num_bots_check = -2;
				  bots[index].is_used = false;

				  if (fill_server) // stop filling the server(guess the user want to abort it)
				  {
					  fill_team = 0;
					  fill_half = fill_server = false;
				  }

				  break;
			  }
		  }
		  return;
      } 
      else if (FStrEq(pcmd, "botkickall"))
      {
		  for (int index = 0; index < 32; index++)
		  {
			  // is this slot used?
			  if ((bots[index].is_used) && (bots[index].pEdict != listenserver_edict) &&
				  (IsNull(bots[index].pEdict) == false))
			  {
				  char cmd[40];
				  
				  sprintf(cmd, "kick \"%s\"\n", STRING(bots[index].pEdict->v.netname));
						  
				  SERVER_COMMAND(cmd);  // kick the bot using (kick "name")
				  num_bots_check = -2;
			  }
		  }
		  UTIL_Printf("All Bots removed !\n");
		  if (fill_server) // stop filling the server(guess the user want to abort it)
		  {
			  fill_team = 0;
			  fill_half = fill_server = false;
		  }

		  return;
	  }
	  else if (FStrEq(pcmd, "botkickallgood"))
      {
		  for (int index = 0; index < 32; index++)
		  {
			  // is this slot used?
			  if ((bots[index].is_used) && (IsNull(bots[index].pEdict) == false) &&
				  (UTIL_GetTeam(bots[index].pEdict) == 0) && 
				  (bots[index].pEdict != listenserver_edict)) 
				  {
				      char cmd[40];
				 		  
				      sprintf(cmd, "kick \"%s\"\n", STRING(bots[index].pEdict->v.netname));
						  
				      SERVER_COMMAND(cmd);  // kick the bot using (kick "name")
					  num_bots_check = -2;
				  }
		  }
		  UTIL_Printf("All Bots removed in team good!\n");

		  if (fill_server) // stop filling the server(guess the user want to abort it)
		  {
			  fill_team = 0;
			  fill_half = fill_server = false;
		  }

		  return;
	  }
	  else if (FStrEq(pcmd, "botkickallevil"))
      {
		  for (int index = 0; index < 32; index++)
		  {
			  // is this slot used?
			  if ((bots[index].is_used) && (IsNull(bots[index].pEdict) == false) &&
				  (UTIL_GetTeam(bots[index].pEdict) == 1) && 
				  (bots[index].pEdict != listenserver_edict)) 
				  {
				      char cmd[40];
				 		  
				      sprintf(cmd, "kick \"%s\"\n", STRING(bots[index].pEdict->v.netname));
						  
				      SERVER_COMMAND(cmd);  // kick the bot using (kick "name")
					  num_bots_check = -2;
				  }
		  }
		  UTIL_Printf("All Bots removed in team evil!\n");

		  if (fill_server) // stop filling the server(guess the user want to abort it)
		  {
			  fill_team = 0;
			  fill_half = fill_server = false;
		  }

		  return;
	  }
      else if (FStrEq(pcmd, "botsusediscs"))
      {
		  if ((arg1 != NULL) && (*arg1 != 0))
          {
            int temp = atoi(arg1);

            if (temp == 1)
               BotsUseDiscs = true;
            else if (temp != -1)
               BotsUseDiscs = false;

			if (temp == -1)
			{
               if (BotsUseDiscs)
				   BotsUseDiscs = false;
               else
				   BotsUseDiscs = true;
			}
          }
          if (BotsUseDiscs)
             UTIL_Printf( "Bots ARE using discs\n");
          else
             UTIL_Printf( "Bots ARENT'T using discs\n");

          return;
      } 
      else if (FStrEq(pcmd, "idlebots"))
      {
		  if ((arg1 != NULL) && (*arg1 != 0))
          {
            int temp = atoi(arg1);

            if (temp == 1)
               BotsAreIdle = true;
            else if (temp != -1)
               BotsAreIdle = false;

			if (temp == -1)
			{
               if (BotsAreIdle)
				   BotsAreIdle = false;
               else
				   BotsAreIdle = true;
			}
          }
          if (BotsAreIdle)
             UTIL_Printf( "Bots ARE idle");
          else
             UTIL_Printf( "Bots ARENT'T idles\n");

          return;
      } 
      else if (FStrEq(pcmd, "should_bot_chat"))
      {
		  if ((arg1 != NULL) && (*arg1 != 0))
          {
            int temp = atoi(arg1);

            if (temp)
               should_bot_chat = true; 
            else
               should_bot_chat = false;
          }
          if (should_bot_chat)
             UTIL_Printf( "bots ARE chatting\n");
          else
             UTIL_Printf( "bots AREN'T chatting\n");

          return;
      } 
      else if (FStrEq(pcmd, "debug_mode"))
      {
		  if ((arg1 != NULL) && (*arg1 != 0))
          {
              int temp = atoi(arg1);

              if (temp)
                 debug_mode = true; 
              else
			  	 debug_mode = false;
          }
          if (debug_mode)
             UTIL_Printf( "debug mode is on\n");
          else
             UTIL_Printf( "debug mode is off\n");

          return;
      }
	  else if (FStrEq(pcmd, "bot_balanceteams"))
	  {
		  if ((arg1 != NULL) && (*arg1 != 0))
          {
              int temp = atoi(arg1);

			  if (temp)
				  BalanceTeams = true;
			  else
				  BalanceTeams = false;
		  }

		  if (BalanceTeams)
			  UTIL_Printf( "Bots will balance teams\n");
		  else
			  UTIL_Printf( "Bots won't balance teams\n");

		  return;
	  }
      else if (FStrEq(pcmd, "follow_mode"))
      {
		  if ((arg1 != NULL) && (*arg1 != 0))
          {
              int temp = atoi(arg1);

              if (temp == 1)
                 follow_mode = true; 
              else if (temp != -1)
			  	 follow_mode = false;

			  if (temp == -1)
			  {
		         if (follow_mode)
                 follow_mode = false; 
                 else
			  	 follow_mode = true;
			  }
		  }
          if (follow_mode)
             UTIL_Printf( "bots ARE following\n");
          else
             UTIL_Printf( "bots AREN'T following\n");

          return;
      }
	  else if (FStrEq(pcmd, "bot_aggression_level"))
	  {
		  if ((arg1 != NULL) && (*arg1 != 0))
          {
			  int i;
			  AggressionLevel_e ALevel = Normal;

			  if (FStrEq(arg1,"defensive"))
				  ALevel = Defensive;
			  else if (FStrEq(arg1,"normal"))
				  ALevel = Normal;
			  else if (FStrEq(arg1,"aggressive"))
				  ALevel = Aggressive;
			  else
			  {
				  UTIL_Printf("Invalid aggression level\n");
				  return;				  
			  }

			  for (i=0;i<32;i++)
			  {
				  bots[i].AggressionLevel = ALevel;
			  }
			  
			  for (i = 0;i<9;i++)
				  BotPersonalities[i].aggression_level = ALevel;

			  sprintf(msg,"Aggression level of every bot is now %s\n", arg1);
			  UTIL_Printf(msg);
		  }
		  return;
	  }
	  else if (FStrEq(pcmd, "bot_chat_percent"))
      {
         if ((arg1 != NULL) && (*arg1 != 0))
         {
            int temp = atoi(arg1);

            if ((temp < -1) || (temp > 100))
               UTIL_Printf( "invalid bot_chat_percent value!\n");
			else if (temp == -1)
			{
				ChangeChatPercent(RANDOM_LONG(0,100));
			}
            else
               ChangeChatPercent(temp);
         }
         return;
      }
      else if (FStrEq(pcmd, "bot_taunt_percent"))
      {
         if ((arg1 != NULL) && (*arg1 != 0))
         {
            int temp = atoi(arg1);

            if ((temp < -1) || (temp > 100))
               UTIL_Printf( "invalid bot_taunt_percent value!\n");
			else if (temp == -1)
			{
				ChangeTauntPercent(RANDOM_LONG(0,100));
			}
            else
               ChangeTauntPercent(temp);
         }
         return;
      }
      else if (FStrEq(pcmd, "bot_whine_percent"))
      {
         if ((arg1 != NULL) && (*arg1 != 0))
         {
            int temp = atoi(arg1);

            if ((temp < -1) || (temp > 100))
               UTIL_Printf( "invalid bot_whine_percent value!\n");
			else if (temp == -1)
			{
				ChangeWhinePercent(RANDOM_LONG(0,100));
			}
            else
			{
               ChangeWhinePercent(temp);
			}
         }
         return;
      }
      else if (FStrEq(pcmd, "bot_chat_tag_percent"))
      {
         if ((arg1 != NULL) && (*arg1 != 0))
         {
            int temp = atoi(arg1);

            if ((temp < -1) || (temp > 100))
               UTIL_Printf( "invalid bot_chat_tag_percent value!\n");
			else if (temp == -1)
			{
				ChangeChatTagPercent(RANDOM_LONG(0,100));
			}
            else
			{
               ChangeChatTagPercent(temp);
			}
         }
         return;
      }
      else if (FStrEq(pcmd, "bot_chat_drop_percent"))
      {
         if ((arg1 != NULL) && (*arg1 != 0))
         {
            int temp = atoi(arg1);

            if ((temp < -1) || (temp > 100))
               UTIL_Printf( "invalid bot_chat_drop_percent value!\n");
			else if (temp == -1)
			{
				ChangeChatDropPercent(RANDOM_LONG(0,100));
			}
            else
			{
				ChangeChatDropPercent(temp);
			}
         }
         return;
      }
      else if (FStrEq(pcmd, "bot_chat_swap_percent"))
      {
         if ((arg1 != NULL) && (*arg1 != 0))
         {
            int temp = atoi(arg1);

            if ((temp < -1) || (temp > 100))
               UTIL_Printf( "invalid bot_chat_swap_percent value!\n");
			else if (temp == -1)
			{
				ChangeChatSwapPercent(RANDOM_LONG(0,100));
			}
            else
			{
				ChangeChatSwapPercent(temp);
			}
         }
         return;
      }
      else if (FStrEq(pcmd, "bot_chat_lower_percent"))
      {
         if ((arg1 != NULL) && (*arg1 != 0))
         {
            int temp = atoi(arg1);

            if ((temp < 0) || (temp > 100))
               UTIL_Printf( "invalid bot_chat_lower_percent value!\n");
			else if (temp == -1)
			{
				ChangeChatLowerPercent(RANDOM_LONG(0,100));
			}
            else
			{
				ChangeChatLowerPercent(temp);
			}
         }
         return;
      }
      
	  else if (FStrEq(pcmd, "bot_melee_percent"))
      {
         if ((arg1 != NULL) && (*arg1 != 0))
         {
            int temp = atoi(arg1);

            if ((temp < -1) || (temp > 100))
               UTIL_Printf( "invalid bot_melee_percent value!\n");
			else if (temp == -1)
			{
				ChangeMeleePercent(RANDOM_LONG(0,100));
			}
			else
			{
				ChangeMeleePercent(temp);
			}
         }

         return;
      }
	  else if (FStrEq(pcmd, "bot_teleport_percent"))
      {
         if ((arg1 != NULL) && (*arg1 != 0))
         {
            int temp = atoi(arg1);

            if ((temp < -1) || (temp > 100))
               UTIL_Printf( "invalid bot_teleport_percent value!\n");
            else if (temp == -1)
			{
				ChangeTeleportPercent(RANDOM_LONG(0, 100));
			}
            else
			{
				ChangeTeleportPercent(temp);		
			}
         }
         return;
      }
	  else if (FStrEq(pcmd, "bot_swoop_percent"))
      {
         if ((arg1 != NULL) && (*arg1 != 0))
         {
            int temp = atoi(arg1), NewPercent;

            if ((temp < -1) || (temp > 100))
			{
				UTIL_Printf( "invalid bot_swoop_percent value!\n");
				return;
			}

			if (temp == -1)
				NewPercent = RANDOM_LONG(0, 100);
			else
				NewPercent = temp;

			ChangeSwoopPercent(NewPercent);
        }
         return;
      }
	  else if (FStrEq(pcmd, "bot_fly_percent"))
      {
         if ((arg1 != NULL) && (*arg1 != 0))
         {
            int temp = atoi(arg1), NewPercent;

            if ((temp < -1) || (temp > 100))
            {
				UTIL_Printf( "invalid bot_fly_percent value!\n");
				return;
			}

			if (temp == -1)
				NewPercent = RANDOM_LONG(0, 100);
			else
				NewPercent = temp;

			ChangeFlyPercent(NewPercent);
         }
         return;
      }
      else if (FStrEq(pcmd, "observer"))
      {
         if ((arg1 != NULL) && (*arg1 != 0))
         {
            int temp = atoi(arg1);
            if (temp)
               b_observer_mode = true;
            else
               b_observer_mode = false;
         }

         if (b_observer_mode)
            UTIL_Printf( "observer mode ENABLED\n");
         else
            UTIL_Printf( "observer mode DISABLED\n");

         return;
      }
      else if (FStrEq(pcmd, "botskill"))
      {
         if ((arg1 != NULL) && (*arg1 != 0))
         {
            int temp = atoi(arg1);
            int i;

            if ((temp < 1) || (temp > 5))
               UTIL_Printf( "invalid botskill value!\n");
            else
            {
				default_bot_skill = temp;
			    CVAR_SET_FLOAT("bot_skill",default_bot_skill-1);
				for (i = 0;i<=31;i++)  
				{
					if (bots[i].SBotType < 1)
						bots[i].bot_skill = default_bot_skill-1;
				}
			}
         }

         sprintf(msg, "botskill is %d\n", default_bot_skill);
         UTIL_Printf( msg);

         return;
      }
      else if (FStrEq(pcmd, "botdontshoot"))
      {
         if ((arg1 != NULL) && (*arg1 != 0))
         {
            int temp = atoi(arg1);
            if (temp)
               b_botdontshoot = true;
            else
               b_botdontshoot = false;
         }

         if (b_botdontshoot)
            UTIL_Printf( "botdontshoot ENABLED\n");
         else
            UTIL_Printf( "botdontshoot DISABLED\n");

         return;
      }
	  else if(FStrEq(pcmd,"botsdontsearchenemys"))
	  {
         if ((arg1 != NULL) && (*arg1 != 0))
         {
            int temp = atoi(arg1);
			if (temp == -1)
			{
				if (BotDontSearchEnemy)
					BotDontSearchEnemy = false;
				else
					BotDontSearchEnemy = true;
			}
			else if (temp == 1)
				BotDontSearchEnemy = true;
			else
				BotDontSearchEnemy = false;
         }

         if (BotDontSearchEnemy)
            UTIL_Printf( "bots won't search for enemies\n");
         else
            UTIL_Printf( "bots search for enemies\n");

         return;
	  }
      else if (FStrEq(pcmd, "debug_engine"))
      {
         debug_engine = 1;

         UTIL_Printf( "debug_engine enabled!\n");

         return;
      }
      else if (FStrEq(pcmd, "bot_menu"))
      {
		 NMenu::ExecuteMenuCommand(-1);
         return;
      }
      else if (FStrEq(pcmd, "menuselect"))
      {
		  if ((arg1 != NULL) && (*arg1 != 0))
			NMenu::ExecuteMenuCommand(atoi(arg1));

		  return;
      }
	  else if (FStrEq(pcmd, "restorebotpersonalities"))
	  {
		  MakePersonalities();

		  int i;
		  for(i=0;i<32;i++)
		  {
			  if (bots[i].is_used == false)
				  continue;

			  if (bots[i].pEdict != listenserver_edict) // Skip autopilots(since they can't melee)
				  bots[i].MeleePercent = BotPersonalities[bots[i].Personality].melee_percent;

			  bots[i].TeleportPercent = BotPersonalities[bots[i].Personality].teleport_percent;
			  bots[i].SwoopPercent = BotPersonalities[bots[i].Personality].swoop_percent;
			  bots[i].FlyPercent = BotPersonalities[bots[i].Personality].fly_percent;
			  bots[i].AggressionLevel = BotPersonalities[bots[i].Personality].aggression_level;
			  bots[i].chat_percent = BotPersonalities[bots[i].Personality].chat_percent;
			  bots[i].taunt_percent = BotPersonalities[bots[i].Personality].taunt_percent;
			  bots[i].whine_percent = BotPersonalities[bots[i].Personality].whine_percent;
			  bots[i].chat_tag_percent = BotPersonalities[bots[i].Personality].chat_tag_percent;
			  bots[i].chat_drop_percent = BotPersonalities[bots[i].Personality].chat_drop_percent;
			  bots[i].chat_swap_percent = BotPersonalities[bots[i].Personality].chat_swap_percent;
			  bots[i].chat_lower_percent = BotPersonalities[bots[i].Personality].chat_lower_percent;
		  }
		  return;
	  }
	  else if (FStrEq(pcmd, "sbot_laser_percent"))
	  {
         if ((arg1 != NULL) && (*arg1 != 0))
         {
            int temp = atoi(arg1), NewPercent;

            if ((temp < -1) || (temp > 100))
			{
				UTIL_Printf( "invalid sbot_laser_percent value!\n");
				return;
			}

			if (temp == -1)
				NewPercent = RANDOM_LONG(0, 100);
			else
				NewPercent = temp;

			ChangeSBotLaserPercent(NewPercent);
        }
         return;
      }

              else if (strcmp(pcmd, "min_bots") == 0)
			  {
				  if (arg1 != NULL)
				  {
					  min_bots = atoi( arg1 );

					  if ((min_bots < 0) || (min_bots > 31))
						  min_bots = 1;
				  }
				  sprintf(msg, "min_bots is now %d\n", min_bots);
				  UTIL_Printf(msg);
				  return;
			  }
			  else if (strcmp(pcmd, "max_bots") == 0)
			  {
				  if (arg1 != NULL)
				  {
					  max_bots = atoi( arg1 );
     
					  if ((max_bots < 0) || (max_bots > 31)) 
						  max_bots = 1;
				  }
				  sprintf(msg, "max_bots set to %d\n", max_bots);
				  UTIL_Printf(msg);
				  return;
			  }
			  else if (FStrEq(pcmd, "debugnetwork"))
			  {
				  if ((arg1 != NULL) && (*arg1 != NULL))
				  {
					  int temp = atoi(arg1);
					  if (temp)
						  DebugNetworkMessages = true;
					  else
						  DebugNetworkMessages = false;
				  }
				  return;
			  }
			  else if (FStrEq(pcmd, "bot_version"))
			  {
				  cout << "ESF_Bot 4.0\n";
				  return;
			  }
			  else if (FStrEq(pcmd, "botsalwaystrytoascend"))
			  {
				  if ((arg1 != NULL) && (*arg1 != NULL))
				  {
					  short Temp = atoi(arg1);

					  if (Temp == -1)
						  BotsAlwaysTryToAscend ^= 1; // Toggle it
					  else if (Temp == 1)
						  BotsAlwaysTryToAscend = true;
					  else
						  BotsAlwaysTryToAscend = false;
				  }
				  
				  if (BotsAlwaysTryToAscend)
					  cout << "Bots allways try to ascend\n";
				  else
					  cout << "Bots check before they try to ascend\n";

				  return;
			  }
	  else if (FStrEq(pcmd, "logchatlists"))
	  {
		  pChatClass->LogChatLists();
		  return;
	  }
	  else if (FStrEq(pcmd, "logoldchats"))
	  {
		  pChatClass->LogPrevMessages();
		  return;
	  }

	if (!IS_DEDICATED_SERVER())
	{
		// Non DED server commands

	if (FStrEq(pcmd, "killbotinfront"))
	{
		UTIL_MakeVectors(listenserver_edict->v.v_angle);
		Vector v_src = listenserver_edict->v.origin;
		Vector v_end = v_src + gpGlobals->v_forward * 10000;
		TraceResult tr;

		UTIL_TraceHull(v_src, v_end, dont_ignore_monsters, human_hull,
					   listenserver_edict->v.pContainingEntity, &tr);

		// Did the traceline hit something ?
		if (IsNull(tr.pHit) == false)
		{
			// Is it a bot ?
			if ((tr.pHit->v.flags & FL_CLIENT) && (tr.pHit->v.flags & FL_FAKECLIENT))
			{
				ClientKill(tr.pHit); // kill the bot
			}
		}
		return;
	}

	else if (FStrEq(pcmd,"autopilot"))
	  {
	  	  if(arg1 != NULL)
		  {
		 	 if ((FStrEq(arg1, "1") || FStrEq(arg1, "-1")) && (!borg_mode))
			 {
				// Turn off client prediction
				CVAR_SET_FLOAT("cl_lw",0);
				UTIL_Printf("Auto Pilot on\n");
				AutoclCreate(listenserver_edict);
			    return;
			 }
			 else if ((FStrEq(arg1, "0") || FStrEq(arg1, "-1")) && (borg_mode))
			 {
				CVAR_SET_FLOAT("cl_lw",1);
				int index=UTIL_GetBotIndex(listenserver_edict);
				if (index != -1)
				{
                    char *infobuffer;
	                int clientIndex;
					
	                infobuffer = g_engfuncs.pfnGetInfoKeyBuffer( listenserver_edict );
	                clientIndex = ENTINDEX( listenserver_edict );	  

					g_engfuncs.pfnSetClientKeyValue( clientIndex, infobuffer, "name", bots[index].old_name );

					bots[index].is_used = false;  // this slot is now free to use
					bots[index].pEdict = NULL;
					sprintf(bots[index].name, "");

					listenserver_edict->v.flags &= ~FL_FROZEN;
					listenserver_edict->v.fixangle = 0;

					UTIL_Printf("Auto Pilot off\n");

					borg_mode = false;
				}
			 }
		  }
		  return;
	  }
		else if (FStrEq(pcmd, "waypoint"))
      {
         if (FStrEq(arg1, "on"))
         {
            g_waypoint_on = true;

            UTIL_Printf( "waypoints are ON\n");
         }
         else if (FStrEq(arg1, "off"))
         {
            g_waypoint_on = false;

            UTIL_Printf( "waypoints are OFF\n");
         }
         else if (FStrEq(arg1, "add"))
         {
            if (!g_waypoint_on)
               g_waypoint_on = true;  // turn waypoints on if off

            WaypointAdd(listenserver_edict);
         }
         else if (FStrEq(arg1, "delete"))
         {
            if (!g_waypoint_on)
               g_waypoint_on = true;  // turn waypoints on if off

            WaypointDelete(listenserver_edict);
         }
         else if (FStrEq(arg1, "save"))
         {
            WaypointSave();

            UTIL_Printf( "waypoints saved\n");
         }
         else if (FStrEq(arg1, "load"))
         {
            if (WaypointLoad(listenserver_edict))
               UTIL_Printf( "waypoints loaded\n");
         }
/*         else if (FStrEq(arg1, "menu"))
         {
            int index;

            if (num_waypoints < 1)
               return;

            index = WaypointFindNearest(pEntity, 50.0, -1);

            if (index == -1)
               return;

            g_menu_waypoint = index;
            g_menu_state = MENU_1;

            UTIL_ShowMenu(pEntity, 0x1F, -1, false, show_menu_1);
         }*/
         else if (FStrEq(arg1, "info"))
         {
            WaypointPrintInfo(listenserver_edict);
         }
         else
         {
            if (g_waypoint_on)
               UTIL_Printf( "waypoints are ON\n");
            else
               UTIL_Printf( "waypoints are OFF\n");
         }

         return;
      }
      else if (FStrEq(pcmd, "autowaypoint"))
      {
         if (FStrEq(arg1, "on"))
         {
            g_auto_waypoint = true;
            g_waypoint_on = true;  // turn this on just in case
         }
         else if (FStrEq(arg1, "off"))
         {
            g_auto_waypoint = false;
         }

         if (g_auto_waypoint)
            sprintf(msg, "autowaypoint is ON\n");
         else
            sprintf(msg, "autowaypoint is OFF\n");

         UTIL_Printf( msg);

         return;
      }
      else if (FStrEq(pcmd, "pathwaypoint"))
      { 
         if (FStrEq(arg1, "on"))
         {
            g_path_waypoint = true;
            g_waypoint_on = true;  // turn this on just in case

            UTIL_Printf( "pathwaypoint is ON\n");
         }
         else if (FStrEq(arg1, "off"))
         {
            g_path_waypoint = false;

            UTIL_Printf( "pathwaypoint is OFF\n");
         }
         else if (FStrEq(arg1, "create1"))
         {
            WaypointCreatePath(listenserver_edict, 1);
         }
         else if (FStrEq(arg1, "create2"))
         {
            WaypointCreatePath(listenserver_edict, 2);
         }
         else if (FStrEq(arg1, "remove1"))
         {
            WaypointRemovePath(listenserver_edict, 1);
         }
         else if (FStrEq(arg1, "remove2"))
         {
            WaypointRemovePath(listenserver_edict, 2);
         }

         return;
      }
#ifdef usedbcode
	else if (FStrEq(pcmd, "dbgatherspot"))
	{
		if ((IsTeamPlay() == false) || (CVAR_GET_FLOAT("mp_gamemode") != 2.0f))
		{
			cout << "Error: Cannot use dragonball commands when CPDB mode is off!\n";
			return;
		}

		if (FStrEq(arg1, "on"))
		{
			cout << "DB gather spots are being drawed\n";
			DrawDBSpots = true;
			return;
		}
		else if (FStrEq(arg1, "off"))
		{
			cout << "DB gather spots are not being drawed\n";
			DrawDBSpots = false;
			return;
		}
		else if (FStrEq(arg1, "add"))
		{
			cout << "Adding dragonball gather spot...\n";
			PlaceNewDBGatherSpot(listenserver_edict);
			return;
		}
		else if (FStrEq(arg1, "delete"))
		{
			cout << "Deleting dragonball gather spot...\n";
			DeleteDBGatherSpot(listenserver_edict);
			return;
		}
		else if (FStrEq(arg1, "save"))
		{
			SaveCustomGatherDBSpots();
			return;
		}
		else if (FStrEq(arg1, "load"))
		{
			InitCustomGatherDBSpots();
			return;
		}
		else
		{
			// ...
		}
		return;
	}
#endif

#ifdef _DEBUG
//EEKHOORN : OFFSET SEARCH
	    if (FStrEq(pcmd, "offsetsearch"))
		{
		 int searchoffset_value = atoi(arg1);
		 int searchoffset_begin = atoi(arg2);
		 int searchoffset_end = atoi(arg3);
		 int searchoffset_no = atoi(arg2);
		 int searchoffset_currentvalue = -1;
         int searchoffset_results = 0;

		 fp = fopen("bot.txt","a");
		 fprintf(fp,"\n");
		 if ((searchoffset_begin < 0) || (searchoffset_end < 1))
		 {
			UTIL_Printf( "offsetsearch <value> <lowest offset> <highestoffset>\n");
			return;
		 }

		 UTIL_Printf( "searching offsets...\n");

		 while (searchoffset_no < searchoffset_end)
		 {
			searchoffset_currentvalue = (*((int *)listenserver_edict->pvPrivateData + searchoffset_no));
            if (searchoffset_value == searchoffset_currentvalue)
            {
				sprintf(msg, "  offset no %d\n", searchoffset_no);
				ClientPrint(listenserver_edict, HUD_PRINTCONSOLE, msg);
				fprintf(fp,msg);
				searchoffset_results += 1;
            }
			searchoffset_no += 1;
		 }

		 sprintf(msg, "Search done... %d results.\n", searchoffset_results);
         ClientPrint(listenserver_edict, HUD_PRINTCONSOLE, msg);

		 fprintf(fp,msg);
		 fclose(fp);

    	 return;
	  }
//END OFFSET SEARCH

		else if (FStrEq(pcmd, "change_offset"))
		{
		  if ((arg1 != NULL) && (*arg1 != 0) &&
			  (arg2 != NULL) && (*arg2 != 0))
          {
              int temp1 = atoi(arg1);
			  int temp2 = atoi(arg2);

			  (*((int *)listenserver_edict->pvPrivateData + temp1)) = temp2;
			  
			  return;
		  }
		}

      else if (FStrEq(pcmd, "hp_cheat"))
      {
		  if ((arg1 != NULL) && (*arg1 != 0))
          {
              int temp = atoi(arg1);

              if (temp)
                 hp_cheat = true;
              else
			  	 hp_cheat = false;
          }
          if (hp_cheat)
             UTIL_Printf( "hp-cheat mode is on\n");
          else
             UTIL_Printf( "hp-cheat mode is off\n");

          return;
      }
      else if (FStrEq(pcmd, "search"))
      {
         edict_t *pent = NULL;
         float radius = 500;
         char str[80];

         ClientPrint(listenserver_edict, HUD_PRINTCONSOLE, "searching...\n");

         FILE *fp=fopen("bot.txt", "a");
		 fprintf(fp,"\n");

         while ((pent = UTIL_FindEntityInSphere( pent, listenserver_edict->v.origin, radius )) != NULL)
         {
			if (IsNull(pent))
				continue;
            sprintf(str, "Found %s at %5.2f %5.2f %5.2f\n",
                       STRING(pent->v.classname), pent->v.origin.x, pent->v.origin.y,
                       pent->v.origin.z);
            ClientPrint(listenserver_edict, HUD_PRINTCONSOLE, str);

			UTIL_PrintEntity(pent);
            fprintf(fp, "ClientCommmand: search %s", str);
         }

		 fprintf(fp,"\n");
         fclose(fp);
         return;
      }
	  else if (FStrEq(pcmd, "teststudio"))
	  {
		  if ((arg1) && (*arg1))
		  {
			  edict_t *pPlayer = INDEXENT(atoi(arg1));
			  void *pModel = GET_MODEL_PTR(pPlayer);
			  mstudioseqdesc_t *pseqdesc;
			  studiohdr_t *pstudiohdr;
			  pstudiohdr = (studiohdr_t *)pModel;
			  
			  if (!pstudiohdr)
				  return;

			  pseqdesc = (mstudioseqdesc_t *)((byte *)pstudiohdr + pstudiohdr->seqindex);

		      lcout << "Numseq: " << pstudiohdr->numseq << "\n";
			  clog << "sequence info for " << STRING(pPlayer->v.netname) << "\n";
			  clog << "Numseq: " << pstudiohdr->numseq << "\n";
			  clog << "Gaitseq is " << pPlayer->v.gaitsequence << " norm seq is " << pPlayer->v.sequence << "\n";

			  for (int i=0;i<pstudiohdr->numseq; i++)
			  {
				  if (pPlayer->v.sequence == i)
				  {
					  clog << "Current label for norm seq is: " << pseqdesc[i].label << "\n";
				  }
				  else if (pPlayer->v.gaitsequence == i)
				  {
					  clog << "Current label for gait seq is: " << pseqdesc[i].label << "\n";
				  }
				  else
				  {
					  clog << "label of " << i << " is " << pseqdesc[i].label << "\n";
				  }
			  }
		  }
		  return;
	  }
      else if (FStrEq(pcmd, "searchcandy"))
      {
         edict_t *pent = NULL;

         ClientPrint(listenserver_edict, HUD_PRINTCONSOLE, "searching...\n");

         while ((pent = UTIL_FindEntityByClassname( pent, "candy" )) != NULL)
         {
			if (IsNull(pent))
				continue;

			UTIL_PrintEntity(pent);
         }
         return;
      }
	  else if (FStrEq(pcmd, "explosion"))
	  {
		  static int gmsgExplosion = 0;

		  if (gmsgExplosion == 0)
			  gmsgExplosion = REG_USER_MSG( "Explosion", -1 );
		  //explosion sphere
		  MESSAGE_BEGIN( MSG_ALL, gmsgExplosion, NULL );
			WRITE_COORD( listenserver_edict->v.origin.x );	
			WRITE_COORD( listenserver_edict->v.origin.y );
			WRITE_COORD( listenserver_edict->v.origin.z );
			WRITE_LONG (700);		//radius
			WRITE_BYTE (4);
		  MESSAGE_END();

		  UTIL_DamagePlayer(listenserver_edict,listenserver_edict,"weapon_test",50);
		  return;
	  }
	  else if (FStrEq(pcmd, "selfdestruct"))
	  {
		  ExplodePlayer(listenserver_edict);
		  return;
	  }
	  else if (FStrEq(pcmd, "debugsbotlaser"))
	  {
		  for (int i=0;i<gpGlobals->maxClients;i++)
		  {
			  if ((bots[i].is_used) && (UTIL_IsValidPlayer(bots[i].pEdict)))
			  {
				  if (!bots[i].pBotEnemy)
					  bots[i].pBotEnemy = listenserver_edict;
				  MakeTask(&bots[i], TaskKeepDangerAway);
			  }
		  }
		  return;
	  }
	  else if (FStrEq(pcmd, "minheadpercent"))
	  {
		  if ((arg1) && (*arg1))
		  {
			  DebugMinHeadPercent = atoi(arg1);
			  cout << "Min head percent: " << DebugMinHeadPercent << "\n";
		  }
		  return;
	  }
	  else if (FStrEq(pcmd, "debugcomboteledirs"))
	  {
		  if ((arg1 != NULL) && (*arg1 != 0) && (arg2 != NULL) && (*arg2 != 0) &&
			  (arg3 != NULL) && (*arg3 != 0))
          {
			  int IdealDir = 0;

			  if (FStrEq(arg1, "left"))
				  IdealDir = dir_left;
			  else
				  IdealDir = dir_right;

			  if (FStrEq(arg2, "forward"))
				  IdealDir |= dir_forward;
			  else
				  IdealDir |= dir_back;

			  if (FStrEq(arg3, "up"))
				  IdealDir |= dir_up;
			  else
				  IdealDir |= dir_down;

			  DebugComboTeleDirs(IdealDir);
		  }
		  return;
	  }
	  else if (FStrEq(pcmd, "debugtelemeleecombo"))
	  {
		  for (int i=0;i<gpGlobals->maxClients;i++)
		  {
			  if ((bots[i].is_used) && (UTIL_IsValidPlayer(bots[i].pEdict)))
			  {
				  if (!bots[i].pBotEnemy)
					  bots[i].pBotEnemy = listenserver_edict;
				  if (MakeTeleMelee(&bots[i], 500.0f))
					  lcout << "Combo succesfull made\n";
			  }
		  }
		  return;
	  }
	  else if (FStrEq(pcmd, "debugcombo"))
	  {
		  for (int i=0;i<gpGlobals->maxClients;i++)
		  {
			  if ((bots[i].is_used) && (UTIL_IsValidPlayer(bots[i].pEdict)))
			  {
				  if (!bots[i].pBotEnemy)
					  bots[i].pBotEnemy = listenserver_edict;
				  MakeCombo(&bots[i],telemelee1);
			  }
		  }
		  return;
	  }
	  else if (FStrEq(pcmd, "debugcandy"))
	  {
		  for (int i=0;i<gpGlobals->maxClients;i++)
		  {
			  if ((bots[i].is_used) && (UTIL_IsValidPlayer(bots[i].pEdict)))
			  {
				  if (!bots[i].pBotEnemy)
					  bots[i].pBotEnemy = listenserver_edict;
				  MakeTask(&bots[i], TaskShootCandy);
			  }
		  }
		  return;
	  }
	  else if (FStrEq(pcmd, "debugkametorp"))
	  {
		  for (int i=0;i<gpGlobals->maxClients;i++)
		  {
			  if ((bots[i].is_used) && (UTIL_IsValidPlayer(bots[i].pEdict)))
			  {
				  if (!bots[i].pBotEnemy)
					  bots[i].pBotEnemy = listenserver_edict;
				  MakeTask(&bots[i], TaskKameTorp);
			  }
		  }
		  return;
	  }
	  else if (FStrEq(pcmd, "traceline"))
	  {
         if ((arg1 != NULL) && (*arg1 != 0))
         {
            int temp = atoi(arg1);
			Vector v_temp = listenserver_edict->v.v_angle;
			v_temp.x = -45;
			//v_temp.y = UTIL_WrapAngle(v_temp.y + 180.0);

			UTIL_MakeVectors(v_temp);

			Vector v_src = listenserver_edict->v.origin;
			Vector v_end = v_src + gpGlobals->v_forward * 1000;
			TraceResult tr;

			if (temp == 1) 
				UTIL_TraceLine(v_src,v_end,dont_ignore_monsters,dont_ignore_glass,listenserver_edict->v.pContainingEntity,&tr);
			else
				UTIL_TraceHull(v_src,v_end,dont_ignore_monsters,human_hull,listenserver_edict->v.pContainingEntity,&tr);

			sprintf(msg,"Fraction: %f\n",tr.flFraction);
			ClientPrint(listenserver_edict,HUD_PRINTCENTER,msg);
			return;
		 }
	  }
	  else if (FStrEq(pcmd, "debugdist"))
	  {
		 static Vector DistPoint1 = Vector(0,0,0);
		 static Vector DistPoint2 = Vector(0,0,0);

         if ((arg1 != NULL) && (*arg1 != 0))
         {
            int temp = atoi(arg1);

			if (temp == 1)
				DistPoint1 = listenserver_edict->v.origin;
			else if (temp == 2)
				DistPoint2 = listenserver_edict->v.origin;
		 }
		 else
		 {
			 float dist = UTIL_Distance(DistPoint1,DistPoint2);
			 sprintf(msg,"Distance between the 2 points: %f\n",dist);
			 ClientPrint(listenserver_edict,HUD_PRINTCENTER,msg);
		 }
		 return;
	  }
	  else if (FStrEq(pcmd, "currentani"))
	  {
		char s[300] = "";
		sprintf(s,"gaitsequence: %i\nsequence: %i\nframe: %f\n", listenserver_edict->v.gaitsequence,
				listenserver_edict->v.sequence, listenserver_edict->v.frame);

		ClientPrint(listenserver_edict,HUD_PRINTNOTIFY,s);

		FILE *fp = fopen("bot.txt","a");
		fprintf(fp,"\n");
		fprintf(fp,s);
		fprintf(fp,"\n");
		fclose (fp);
		return;
	  }
	  else if (FStrEq(pcmd,"printent"))
	  {
		  if (arg1 != NULL)
		  {
			  edict_t *pEnt = NULL;
			  pEnt = INDEXENT(atoi(arg1));

			  if (pEnt)
				  UTIL_PrintEntity(pEnt);
			  return;
		  }
	  }
	  else if (FStrEq(pcmd, "aimxspeed"))
	  {
		  if ((arg1 != NULL) && (*arg1 != 0))
		  {
			  BotDebugAimXSpeed = atof(arg1);
		  }
		  return;
	  }
	  else if (FStrEq(pcmd, "aimyspeed"))
	  {
		  if ((arg1 != NULL) && (*arg1 != 0))
		  {
			  BotDebugAimYSpeed = atof(arg1);
		  }
		  return;
	  }
	  else if (FStrEq(pcmd, "aimdelay"))
	  {
		  if ((arg1 != NULL) && (*arg1 != 0))
		  {
			  BotDebugAimDelay = atof(arg1);
		  }
		  return;
	  }
	  else if (FStrEq(pcmd, "delayforaimdelay"))
	  {
		  if ((arg1 != NULL) && (*arg1 != 0))
		  {
			  BotDebugDelayForAimDelay = atof(arg1);
		  }
		  return;
	  }
	  else if (FStrEq(pcmd, "aimfactor"))
	  {
		  if ((arg1 != NULL) && (*arg1 != 0))
		  {
			  DebugAimFactor = atof(arg1);
		  }
		  return;
	  }
	  else if (FStrEq(pcmd, "turnxangle"))
	  {
		  if ((arg1 != NULL) && (*arg1 != 0) && (arg2 != NULL) && (*arg2 != 0))
		  {
			  short BotInd = UTIL_GetBotIndex(INDEXENT(atoi(arg1)));
			  bots[BotInd].AimVec.x = UTIL_WrapAngle(atof(arg2));
		  }
		  return;
	  }
	  else if (FStrEq(pcmd, "turnyangle"))
	  {
		  if ((arg1 != NULL) && (*arg1 != 0) && (arg2 != NULL) && (*arg2 != 0))
		  {
			  short BotInd = UTIL_GetBotIndex(INDEXENT(atoi(arg1)));
			  bots[BotInd].AimVec.y = UTIL_WrapAngle(bots[BotInd].AimVec.y + atof(arg2));
		  }
		  return;
	  }
	  else if (FStrEq(pcmd, "aggressionlevel"))
	  {
		  if ((arg1 != NULL) && (*arg1 != 0))
		  {
			  int temp = atoi(arg1);
			  int BotInd = UTIL_GetBotIndex(INDEXENT(temp));
			  sprintf(msg, "AggressionLevel of Bot: %s is :%d\n",
				      STRING(bots[BotInd].pEdict->v.netname), int(bots[BotInd].AggressionLevel));
			  UTIL_Printf( msg);
		  }
		  return;
	  }
	  else if (FStrEq(pcmd, "playercam"))
	  {
		  if ((arg1 != NULL) && (*arg1 != 0))
		  {
			  SetCameraToPlayer(listenserver_edict, INDEXENT(atoi(arg1)));
		  }
		  return;
	  }
	  else if (FStrEq(pcmd, "turnplayercamoff"))
	  {
		  DestroyPlayerCamera(listenserver_edict);
		  return;
	  }
	  else if (FStrEq(pcmd, "beamcam"))
	  {
		  if (pBeamViewEnt)
			  DeactivateBeamCam(listenserver_edict);
		  else
			  ActivateBeamCam(listenserver_edict);

		  return;
	  }
	  else if (FStrEq(pcmd, "botbeamjump"))
	  {
		  for (int i=0;i<32;i++)
		  {
			  if (UTIL_IsValidPlayer(bots[i].pEdict))
			  {
				  if (BotCanBeamJump(&bots[i], false))
					  MakeTask(&bots[i], TaskBeamJump);
			  }
		  }
		  return;
	  }
	  else if (FStrEq(pcmd, "lcoutxpos"))
	  {
		  if ((arg1 != NULL) && (*arg1 != 0))
		  {
			  lcoutXPos = atoi(arg1);
		  }
		  return;
	  }
	  else if (FStrEq(pcmd, "lcoutypos"))
	  {
		  if ((arg1 != NULL) && (*arg1 != 0))
		  {
			  lcoutYPos = atoi(arg1);
		  }
		  return;
	  }
	  else if (FStrEq(pcmd, "displaybotstuff"))
	  {
		  DisplayBotStuff ^= 1;			  
		  cout << "DisplayBotStuff is now: " << DisplayBotStuff << "\n";
		  return;
	  }
	  else if (FStrEq(pcmd, "break"))
	  {
		  _asm int 3;
		  return;
	  }
	  else if (FStrEq(pcmd, "testoverflow"))
	  {
		  char s[512] = "";
		  int i;
		  for (i=0;i<(512);i++)
			  s[i] = 'h';
		  s[i+1] = 0;
		  lcout << s;
		  lcout.Display();
		  rcout << s;
		  rcout.Display();
		  mcout << s;
		  mcout.Display();
		  return;
	  }
	  else if (FStrEq(pcmd, "saveedict"))
	  {
		  FILE *mfp = fopen("esfsavetest.txt", "wb");
		  fwrite(listenserver_edict, sizeof(*listenserver_edict), 1, mfp);
		  fclose(mfp);
		  return;
	  }
	  else if (FStrEq(pcmd, "loadedict"))
	  {
		  FILE *mfp = fopen("esfsavetest.txt", "rb");
		  if (mfp)
		  {
			  fread(listenserver_edict, sizeof(*listenserver_edict), 1, mfp);
			  fclose(mfp);
		  }
		  return;
	  }
	  else if (FStrEq(pcmd, "testmsgbox"))
	  {
		  MessageBox(0, "Test1", "Test2", NULL);
		  return;
	  }
	  else if (FStrEq(pcmd, "grow"))
	  {
		  listenserver_edict->v.scale += 1.5;
//		  Vector mins = Vector(listenserver_edict->v.mins.x * -1.5, listenserver_edict->v.mins.y * -1.5, listenserver_edict->v.mins.z * -1.5);
//		  Vector maxs = Vector(listenserver_edict->v.maxs.x * 1.5, listenserver_edict->v.maxs.y * 1.5, listenserver_edict->v.maxs.z * 1.5);
		  UTIL_SetSize(&listenserver_edict->v, Vector(-50, -50, 0), Vector(150, 150, 150));/*
		  listenserver_edict->v.mins.x *= 1.5;
		  listenserver_edict->v.mins.y *= 1.5;
		  listenserver_edict->v.mins.z *= 1.5;
		  listenserver_edict->v.maxs.x *= 1.5;
		  listenserver_edict->v.maxs.y *= 1.5;
		  listenserver_edict->v.maxs.z *= 1.5;
		  listenserver_edict->v.size.x *= 1.5;
		  listenserver_edict->v.size.y *= 1.5;
		  listenserver_edict->v.size.z *= 1.5;*/
		  return;
	  }
	  else if (FStrEq(pcmd, "smaller"))
	  {
		  listenserver_edict->v.scale -= 1.5;
		  return;
	  }
	  else if (FStrEq(pcmd, "teststring"))
	  {
		  lcout << STRING(65937496) << "\n";
		  return;
	  }
	  else if (FStrEq(pcmd, "fakecommand"))
	  {
		  if ((arg1) && (*arg1) && (arg2) && (*arg2))
		  {
			  TestFCommand = true;
		  }
		  return;
	  }
	  else if (FStrEq(pcmd, "validclasses"))
	  {
		  edict_t *pPlayer = NULL;
		  int index;
		 short CharLimit = static_cast<short>(CVAR_GET_FLOAT("mp_characterlimit"));
		 int ValidClasses = ((1<<1) | (1<<2) | (1<<3) | (1<<4) | (1<<5) | (1<<6) | (1<<7) |
							 (1<<8) | (1<<9));
		 byte BuuCount = 0;
		 byte GokuCount = 0;
		 byte GohanCount = 0;
		 byte KrillinCount = 0;
		 byte FriezaCount = 0;
		 byte PiccoloCount = 0;
		 byte TrunksCount = 0;
		 byte VegetaCount = 0;
		 byte CellCount = 0;
		 byte PlayerClass = 0;

		 // Count all the classes
		 for (index=1;index<=gpGlobals->maxClients;index++)
		 {
			 pPlayer = INDEXENT(index);
			 if (UTIL_IsValidPlayer(pPlayer, false, false))
			 {
				 PlayerClass = UTIL_GetClass(pPlayer);
				 if (PlayerClass == 1)
				 {
					 BuuCount++;
					 if (BuuCount >= CharLimit)
						 ValidClasses &= ~(1<<1);
				 }
				 else if (PlayerClass == 2)
				 {
					 GokuCount++;
					 if (GokuCount >= CharLimit)
						 ValidClasses &= ~(1<<2);
				 }
				 else if (PlayerClass == 3)
				 {
					 GohanCount++;
					 if (GohanCount >= CharLimit)
						 ValidClasses &= ~(1<<3);
				 }
				 else if (PlayerClass == 4)
				 {
					 KrillinCount++;
					 if (KrillinCount >= CharLimit)
						 ValidClasses &= ~(1<<4);
				 }
				 else if (PlayerClass == 5)
				 {
					 FriezaCount++;
					 if (FriezaCount >= CharLimit)
						 ValidClasses &= ~(1<<5);
				 }
				 else if (PlayerClass == 6)
				 {
					 PiccoloCount++;
					 if (PiccoloCount >= CharLimit)
						 ValidClasses &= ~(1<<6);
				 }
				 else if (PlayerClass == 7)
				 {
					 TrunksCount++;
					 if (TrunksCount >= CharLimit)
						 ValidClasses &= ~(1<<7);
				 }
				 else if (PlayerClass == 8)
				 {
					 VegetaCount++;
					 if (VegetaCount >= CharLimit)
						 ValidClasses &= ~(1<<8);
				 }
				 else if (PlayerClass == 9)
				 {
					 CellCount++;
					 if (CellCount >= CharLimit)
						 ValidClasses &= ~(1<<9);
				 }
			 }
		 }
		 for(index=1;index<=9;index++)
		 {
			 if (ValidClasses & (1<<index))
				 cout << index << " Is a valid class\n";
		 }
		 return;
	  }
	  else if (FStrEq(pcmd, "getbotdll"))
	  {
		  char* buf = (*g_engfuncs.pfnGetInfoKeyBuffer)(NULL);
		  char* bots_gamedll = (*g_engfuncs.pfnInfoKeyValue)(buf,"esf_bot_dll");
		  if ((bots_gamedll) && (*bots_gamedll != '\0'))
			  lcout << bots_gamedll << "\n";
		  return;
	  }
	  else if (FStrEq(pcmd, "meleekickpercent"))
	  {
		  if ((arg1) && (*arg1))
		  {
			  int NewPercent = atoi(arg1);
			  cout << "kick percent = " << NewPercent << "\n";
			  int i;

			  for (i = 0;i<9;i++)
				  BotPersonalities[i].meleekick_percent = NewPercent;
		  }
		  return;
	  }
	  else if (FStrEq(pcmd, "meleecombopercent"))
	  {
		  if ((arg1) && (*arg1))
		  {
			  int NewPercent = atoi(arg1);
			  cout << "combo percent = " << NewPercent << "\n";
			  int i;

			  for (i = 0;i<9;i++)
				  BotPersonalities[i].meleecombo_percent = NewPercent;
		  }
		  return;
	  }
	  else if (FStrEq(pcmd, "blockpercent"))
	  {
		  if ((arg1) && (*arg1))
		  {
			  int NewPercent = atoi(arg1);
			  cout << "block percent = " << NewPercent << "\n";
			  int i;

			  for (i = 0;i<9;i++)
				  BotPersonalities[i].block_percent = NewPercent;
		  }
		  return;
	  }
	  else if (FStrEq(pcmd, "dbspot"))
	  {
		  extern Vector GatherDBPosForTeamGood;
		  extern Vector GatherDBPosForTeamEvil;

		  UTIL_DrawBeam(listenserver_edict, listenserver_edict->v.origin, GatherDBPosForTeamGood,
		                10, 10, 0, 0, 255, 250, 5);

		  UTIL_DrawBeam(listenserver_edict, listenserver_edict->v.origin, GatherDBPosForTeamEvil,
		                10, 10, 255, 0, 0, 250, 5);

		  return;
	  }
	  else if (FStrEq(pcmd, "makenewdbspots"))
	  {
		  DecideNextDBSpots();
		  return;
	  }
	  else if (FStrEq(pcmd, "dbsaregathered"))
	  {
		  if (DBSAreGathered())
			  cout << "DB's are gathered\n";
		  else
			  cout << "DB's are not gathered\n";

		  return;
	  }
	  else if (FStrEq(pcmd, "dbsareactive"))
	  {
		  if (DBSAreActive())
			  cout << "DB's are active\n";
		  else
			  cout << "DB's are not active\n";

		  return;
	  }
	  else if (FStrEq(pcmd, "setgotovec"))
	  {
		  DebugGoToVec = listenserver_edict->v.origin;
		  return;
	  }
	  else if (FStrEq(pcmd, "botgotovec"))
	  {
		  if ((arg1) && (*arg1))
		  {
			  bot_t *pBot = UTIL_GetBotPointer(INDEXENT(atoi(arg1)));
			  if (pBot)
			  {
			 	  pBot->v_GoToVector = DebugGoToVec;
				  MakeTask(pBot, TaskGoToVec);
			  }
		  }			  
		  return;
	  }
	  else if (FStrEq(pcmd, "findattack"))
	  {
		  if ((arg1) && (*arg1))
		  {
			  if (pAttackManager->SearchAttackByName(listenserver_edict, arg1))
				  cout << "Founded Attack " << arg1 << "\n";
			  else
				  cout << "Couldn't find Attack " << arg1 << "\n";
		  }
		  return;
	  }
#ifdef usestats
	  else if (FStrEq(pcmd, "logweaponstats"))
	  {
		  LogAllWeaponStatistics();
		  return;
	  }
#endif
#ifdef classstuff
	  else if (FStrEq(pcmd, "logcllist"))
	  {
		  pClientManager->LogClientList();
		  return;
	  }
	  else if (FStrEq(pcmd, "createbot"))
	  {
		  pBotManager->CreateBot(1, 3, "", 1, -1);
		  return;
	  }
	  else if (FStrEq(pcmd, "setskill"))
	  {
		  if ((arg1) && (*arg1))
			  pBotManager->ChangeBotSkill(atoi(arg1));
		  return;
	  }
#endif

#ifdef USEBSPSHIT
	  else if (FStrEq(pcmd, "floodwps"))
	  {
		  AddWaypointsOnDelimiters();
		  return;
	  }
#endif
#endif
	  }

	  BotCommandWasFound = false; // No valid command found
}

// debug shit -----------------------------------------------------------

#ifdef classstuff
class CGetNearestBotFuncClass
{
	float NearestDist;
	CBot *pNearestBot;

public:
	CGetNearestBotFuncClass(void) : NearestDist(9999.9), pNearestBot(NULL) {};

	CBot *GetNearestBot(void)	{ return pNearestBot; }
	operator ()(CClient *pClient)
	{
		CBot *pBot = pBotManager->GetBotFromClient(pClient);
		if (pBot)
		{
			float dist = UTIL_Distance(pClientManager->GetHost()->GetOrigin(), pBot->GetOrigin());
			if (dist < NearestDist)
			{
				NearestDist = dist;
				pNearestBot = pBot;
			}
		}
	}
};
#endif

#ifdef _DEBUG
void DisplayDebugTexts()
{
	short i;
	float NearestBotDist = 9999.9, dist;
	short NearestBotInd = -1;

	i = UTIL_GetClientIndex(listenserver_edict);
	if (i > -1)
	{
		/*if (ClientInfo[i].IsAutoPunching)
			lcout << "You're auto punching\n";
		if (ClientInfo[i].GetAutoPunched)
			lcout << "You get auto punched\n";
		if (ClientInfo[i].IsInMeleeMode)
			lcout << "You're in melee mode\n";
		if (ClientInfo[i].Ascends)
			lcout << "You ascend\n";
		if (ClientInfo[i].Powerstruggles)
			lcout << "You're PS'ing\n";
		if (ClientInfo[i].ChargesAttack)
			lcout << "You charge an attack\n";
		if (ClientInfo[i].FlysAfterHit)
			lcout << "You fly after hit\n";
		if (ClientInfo[i].ChargesWallJump)
			lcout << "You charge a wjump\n";
		if (ClientInfo[i].WallJumps)
			lcout << "You wjumps\n";
		if (ClientInfo[i].Swoops)
			lcout << "You swoop\n";
		if (ClientInfo[i].MeleeStruggles)
			lcout << "You melee struggling\n";
		if (ClientInfo[i].IsStuckAgainstWall)
			lcout << "You're sticked at a wall\n";
		if (ClientInfo[i].LaysOnGround)
			lcout << "You lay on the ground\n";
		if (ClientInfo[i].ControlsAttack)
			lcout << "You control an attack\n";
		if (ClientInfo[i].BeamJumps)
			lcout << "You BJump\n";
		if (ClientInfo[i].IsBlinded)
			lcout << "You're blinded\n";
		if (ClientInfo[i].Blocks)
			lcout << "You're blocking\n";
		if (ClientInfo[i].BlockStruggles)
			lcout << "You're BS'ing\n";*/
	}


#ifdef classstuff
	CGetNearestBotFuncClass NearestBotFuncClass;
	pClientManager->pClientList->ForEach(NearestBotFuncClass);

	CBot *pNearestBot = NearestBotFuncClass.GetNearestBot();
	if (pNearestBot)
	{
		rcout << "Bot info for " << STRING(pNearestBot->pEdict->v.netname) << "\n\n";
		rcout << "Pl " << pNearestBot->GetPl() << "\n";
		rcout << "Ki " << pNearestBot->GetKi() << "\n";
		rcout << "Skill " << pNearestBot->GetSkill() << "\n";
		if (pNearestBot->pEdict->v.button & IN_ATTACK)
			rcout << "Bot is pressing attack\n";
	}

	return;
#endif

	if (pHostViewPlayer)
	{
		i = UTIL_GetBotIndex(pHostViewPlayer);
		if (i > -1)
			NearestBotInd = i;
	}

	if (NearestBotInd == -1)
	{
		for (i=0;i<32;i++)
		{
			if (UTIL_IsValidPlayer(bots[i].pEdict, false))
			{
				dist = UTIL_Distance(listenserver_edict->v.origin, bots[i].pEdict->v.origin);

				if (NearestBotDist > dist)
				{
					NearestBotDist = dist;
					NearestBotInd = i;
				}
			}
		}
	}

	if (NearestBotInd > -1)
	{
		edict_t *pEdict = bots[NearestBotInd].pEdict;
		rcout << "Displaying info for bot: " << STRING(pEdict->v.netname) << "\n";

		if (bots[NearestBotInd].CurrentBotTask)
			rcout << "CurrentTask: " << int(bots[NearestBotInd].CurrentBotTask->TaskIdentify()) << "\n";

		rcout << "Previous task: " << int(bots[NearestBotInd].PrevTask) << "\n";

		if ((bots[NearestBotInd].pBotCombo) && (bots[NearestBotInd].pBotCombo->CurrentCombo))
			rcout << "Current combo nr: " << bots[NearestBotInd].pBotCombo->CurrentCombo->ComboAction << "\n";

		rcout << "\nBot status: \n\n";
		rcout << "Health: " << pEdict->v.health << "\nKi: " << bots[NearestBotInd].bot_ki << "\n";
		rcout << "Max speed: " << bots[NearestBotInd].f_max_speed << "\n";
		rcout << "Power Level: " << bots[NearestBotInd].PL << "\n";
		rcout << "Power struggle value: " << bots[NearestBotInd].bot_powerstrug << "\n";
		rcout << "Charge beam value: " << bots[NearestBotInd].ChargeBeamVal << "\n";
		rcout << "DangerLevel: " << bots[NearestBotInd].DangerLevel << "\n";
		rcout << "DangerType: " << bots[NearestBotInd].DangerType << "\n";

		rcout << "\nEnemies: \n\n";
		for (i=0;i<4;i++)
		{
			if (bots[NearestBotInd].EnemyList[i].pEnemy)
				rcout << "Enemy nr " << i + 1 << ": " << STRING(bots[NearestBotInd].EnemyList[i].pEnemy->v.netname) << "\n";
		}

		if (bots[NearestBotInd].pHuntingEdict)
			rcout << "Hunting player: " << STRING(bots[NearestBotInd].pHuntingEdict->v.netname) << "\n";

		rcout << "\nBot settings: \n\n";
		rcout << "Melee percent: " << bots[NearestBotInd].MeleePercent << "\n";
		rcout << "Teleport percent: " << bots[NearestBotInd].TeleportPercent << "\n";
		rcout << "Swoop percent: " << bots[NearestBotInd].SwoopPercent << "\n";
		rcout << "AggrLevel: " << bots[NearestBotInd].AggressionLevel << "\n";
		//rcout << "Skill: " << bots[NearestBotInd].bot_skill << "\n";

//		rcout << "\nDelays: \n\n";
//		rcout << "Teleport delay: " << (bots[NearestBotInd].teleport_delay - gpGlobals->time) << "\n";

//		if (bots[NearestBotInd].CurrentBotTask)
//			rcout << "General Delay: " << (bots[NearestBotInd].CurrentBotTask->Delay - gpGlobals->time) << "\n";

/*		rcout << "\nVisPlayers:\n";
		for (i=0;i<32;i++)
		{
			if (bots[NearestBotInd].VisiblePlayers & (1<<i))
				rcout << "1";
			else
				rcout << "0";
		}
		rcout << "\nPlayersChecked:\n";
		for (i=0;i<32;i++)
		{
			if (bots[NearestBotInd].PlayersChecked & (1<<i))
				rcout << "1";
			else
				rcout << "0";
		}*/

		i = UTIL_GetClientIndex(bots[NearestBotInd].pEdict);
		if (i > -1)
		{
			if (ClientInfo[i].IsAutoPunching)
				rcout << "Bot is auto punching\n";
			if (ClientInfo[i].GetAutoPunched)
				rcout << "Bot get auto punched\n";
			if (ClientInfo[i].IsInMeleeMode)
				rcout << "Bot is in melee mode\n";
			if (ClientInfo[i].Ascends)
				rcout << "Bot ascend\n";
			if (ClientInfo[i].Powerstruggles)
				rcout << "Bot is PS'ing\n";
			if (ClientInfo[i].ChargesAttack)
				rcout << "Bot charges an attack\n";
			if (ClientInfo[i].FlysAfterHit)
				rcout << "Bot flys after hit\n";
			if (ClientInfo[i].ChargesWallJump)
				rcout << "Bot charge a wjump\n";
			if (ClientInfo[i].WallJumps)
				rcout << "Bot wjumps\n";
			if (ClientInfo[i].Swoops)
				rcout << "Bot swoops\n";
			if (ClientInfo[i].MeleeStruggles)
				rcout << "Bot is melee struggling\n";
			if (ClientInfo[i].IsStuckAgainstWall)
				rcout << "Bot is sticked at a wall\n";
			if (ClientInfo[i].LaysOnGround)
				rcout << "Bot lays on the ground\n";
			if (ClientInfo[i].ControlsAttack)
				rcout << "Bot control an attack\n";
			if (ClientInfo[i].BeamJumps)
				rcout << "Bot BJumps\n";
			if (ClientInfo[i].IsBlinded)
				rcout << "Bot is blinded\n";
			if (ClientInfo[i].Blocks)
				rcout << "Bot is blocking\n";
			if (ClientInfo[i].BlockStruggles)
				rcout << "Bot is BS'ing\n";
		}
	}
}

void LogBotInfo(bot_t *pBot)
{
	edict_t *pEdict = pBot->pEdict;
	clog << "\nDisplaying info for bot: " << STRING(pEdict->v.netname) << "\n\n";

	if (pBot->CurrentBotTask)
		clog << "CurrentTask: " << int(pBot->CurrentBotTask->TaskIdentify()) << "\n";

	clog << "Previous task: " << int(pBot->PrevTask) << "\n";

	if ((pBot->pBotCombo) && (pBot->pBotCombo->CurrentCombo))
		clog << "Current combo nr: " << pBot->pBotCombo->CurrentCombo->ComboAction << "\n";

	clog << "\nBot status: \n\n";
	clog << "Health: " << pEdict->v.health << "\nKi: " << pBot->bot_ki << "\n";
	clog << "Max speed: " << pBot->f_max_speed << "\n";
	clog << "Power Level: " << pBot->PL << "\n";
	clog << "Power struggle value: " << pBot->bot_powerstrug << "\n";
	clog << "Charge beam value: " << pBot->ChargeBeamVal << "\n";

	clog << "\nEnemies: \n\n";
	for (int i=0;i<4;i++)
	{
		if (pBot->EnemyList[i].pEnemy)
			clog << "Enemy nr " << i + 1 << ": " << STRING(pBot->EnemyList[i].pEnemy->v.netname) << "\n";
	}

	if (pBot->pHuntingEdict)
		clog << "Hunting player: " << STRING(pBot->pHuntingEdict->v.netname) << "\n";

	clog << "\nBot settings: \n\n";
	clog << "Melee percent: " << pBot->MeleePercent << "\n";
	clog << "Teleport percent: " << pBot->TeleportPercent << "\n";
	clog << "Swoop percent: " << pBot->SwoopPercent << "\n";
	clog << "Skill: " << pBot->bot_skill << "\n";

	clog << "\nDelays: \n\n";
	clog << "Teleport delay: " << (pBot->teleport_delay - gpGlobals->time) << "\n";

	if (pBot->CurrentBotTask)
		clog << "General Delay: " << (pBot->CurrentBotTask->Delay - gpGlobals->time) << "\n";

	clog << "\nVisPlayers:\n";
	for (i=0;i<32;i++)
	{
		if (pBot->VisiblePlayers & (1<<i))
			clog << "1";
		else
			clog << "0";
	}
	clog << "\nPlayersChecked:\n";
	for (i=0;i<32;i++)
	{
		if (pBot->PlayersChecked & (1<<i))
			clog << "1";
		else
			clog << "0";
	}

	clog << "\n";
	i = UTIL_GetClientIndex(pBot->pEdict);
	if (i > -1)
	{
		if (ClientInfo[i].IsAutoPunching)
			clog << "Bot is auto punching\n";
		if (ClientInfo[i].GetAutoPunched)
			clog << "Bot get auto punched\n";
		if (ClientInfo[i].IsInMeleeMode)
			clog << "Bot is in melee mode\n";
		if (ClientInfo[i].Ascends)
			clog << "Bot ascend\n";
		if (ClientInfo[i].Powerstruggles)
			clog << "Bot is PS'ing\n";
		if (ClientInfo[i].ChargesAttack)
			clog << "Bot charges an attack\n";
		if (ClientInfo[i].FlysAfterHit)
			clog << "Bot flys after hit\n";
		if (ClientInfo[i].ChargesWallJump)
			clog << "Bot charge a wjump\n";
		if (ClientInfo[i].WallJumps)
			clog << "Bot wjumps\n";
		if (ClientInfo[i].Swoops)
			clog << "Bot swoops\n";
		if (ClientInfo[i].MeleeStruggles)
			clog << "Bot is melee struggling\n";
		if (ClientInfo[i].IsStuckAgainstWall)
			clog << "Bot is sticked at a wall\n";
		if (ClientInfo[i].LaysOnGround)
			clog << "Bot lays on the ground\n";
		if (ClientInfo[i].ControlsAttack)
			clog << "Bot control an attack\n";
		if (ClientInfo[i].BeamJumps)
			clog << "Bot BJumps\n";
		if (ClientInfo[i].IsBlinded)
			clog << "Bot is blinded\n";
		if (ClientInfo[i].Blocks)
			clog << "Bot is blocking\n";
		if (ClientInfo[i].BlockStruggles)
			clog << "Bot is BS'ing\n";
	}

	clog << "\n";
}
#endif