#ifndef GENERAL_HEADER_H
#define GENERAL_HEADER_H

#pragma warning(disable:4786) // Long template name for debugging warning
#pragma warning(disable:4710) // Inlining warning

#include "extdll.h"
#include "sdk_util.h"
#include "misc.h"
#include "studio.h"
#include "engine.h"
#include "enginecallback.h"
#include "bot_io.h"
#include "client.h"
#include "bot.h"
#include "bot_func.h"
#include "bot_chat.h"
#include "dragonball.h"
#include "bot_sense.h"
#include "tasks.h"
#include "combo.h"
#include "bot_weapons.h"
#include "bot_client.h"
#include "bot_menu.h"
#include "waypoint.h"
#include "bot_personality.h"
#include "cbase.h"

// Globals
extern bool TeamMenuShowedUp;
extern bool ClassMenuShowedUp;

#ifdef classstuff
extern CClientManager *pClientManager;
extern CBotManager *pBotManager;
#endif

extern CBaseOutput cout;

#ifdef _DEBUG
extern CLeftOutput lcout;
extern CRightOutput rcout;
extern CMiddleOutput mcout;
#endif

extern CLog clog;
extern CAttackManager *pAttackManager;
extern CChatClass *pChatClass;
extern BotPersonality_t BotPersonalities[9];
extern byte NumPlayers;

#endif // GENERAL_HEADER_H