#include "general_header.h"

extern bool borg_mode;
extern bot_t bots[32];   // max of 32 bots in a game
extern BotPersonality_t BotPersonalities[9];
extern short DefaultPersonality;

void AutoclCreate( edict_t *pPlayer) //HEAP[hl.exe]: Invalid heap signature for heap at c770000, passed to RtlFreeHeap
{
   edict_t *BotEnt;
   bot_t *pBot;
   
   BotEnt = pPlayer;

   if (FNullEnt( BotEnt )) 
   {
   }
   else
   {
      int index;

      index = 0;
      while ((bots[index].is_used) && (index < 32))
         index++;

      if (index == 32)
      {
         ClientPrint( pPlayer, HUD_PRINTNOTIFY, "Can't create bot!\n");
         return;
      }

      pBot = &bots[index];

      pBot->is_used = TRUE;
      pBot->respawn_state = RESPAWN_IDLE;
      pBot->create_time = gpGlobals->time;

      pBot->pEdict = BotEnt;
	  pBot->pBotClient = UTIL_GetClientPointer(BotEnt);
#ifdef _DEBUG
	  assert(pBot->pBotClient);
#endif

      BotSpawnInit( pBot );

      pBot->not_started = 0;  // hasn't joined game yet

      pBot->start_action = MSG_IDLE;

      pBot->need_to_initialize = FALSE;  // don't need to initialize yet

 	  if(BotEnt->v.ideal_yaw > 180.0)
		 BotEnt->v.ideal_yaw -= 360.0;
	  if(BotEnt->v.ideal_yaw < -180.0)
	     BotEnt->v.ideal_yaw += 360.0;

 	  if(BotEnt->v.idealpitch > 180.0)
		 BotEnt->v.idealpitch -= 360.0;
	  if(BotEnt->v.idealpitch < -180.0)
	     BotEnt->v.idealpitch += 360.0;
	
      pBot->idle_angle = 0.0;

      pBot->bot_skill = 0;  // 0 based for array indexes

      pBot->bot_team = pPlayer->v.team;

      pBot->bot_class = pPlayer->v.playerclass;
	  strcpy(pBot->old_name, STRING(pPlayer->v.netname));

      sprintf(pBot->name, "[AUTO]%s", STRING(pPlayer->v.netname));

      char *infobuffer;
	  int clientIndex;
	  infobuffer = g_engfuncs.pfnGetInfoKeyBuffer( pPlayer );
	  clientIndex = ENTINDEX( pPlayer );
	  
	  g_engfuncs.pfnSetClientKeyValue( clientIndex, infobuffer, "name", pBot->name );

      pBot->f_max_speed = pPlayer->v.maxspeed;

      char model_name[64];
	
	  UTIL_GetModel(pBot->pEdict,model_name);

	  if (pBot->pBotWeaponList)
		  delete pBot->pBotWeaponList;

	  pBot->pBotWeaponList = new TLinkedList<short>;
	  pBot->pBotWeaponList->AddNode(ESF_WEAPON_KIBLAST); // 'give' the bot a kiblast

	  pBot->bot_health = pPlayer->v.health;
      pBot->bot_ki = int(pPlayer->v.fuser4);
	  pBot->PL = GetPlayerPl(pPlayer);
	  borg_mode = true;

      pBot->pLastEnemy = NULL;
      pBot->SBotType = -1;

 	  if (DefaultPersonality > 0)
		  pBot->Personality = DefaultPersonality - 1;
	  else
		  pBot->Personality = RANDOM_LONG(0, 8);
	
	  pBot->MeleePercent = 0;
	  pBot->TeleportPercent = BotPersonalities[pBot->Personality].teleport_percent;
	  pBot->FlyPercent = BotPersonalities[pBot->Personality].fly_percent;
	  pBot->AggressionLevel = BotPersonalities[pBot->Personality].aggression_level;

	  pBot->VisiblePlayers = 0;

	  pBot->CurrentBotTask = NULL;
	  pBot->CurrentBotSubTask = NULL;
   }   
}
