//
// HPB_bot - botman's High Ping Bastard bot
//
// (http://planethalflife.com/botman/)
//
// bot_weapons.h
//

#ifndef BOT_WEAPONS_H
#define BOT_WEAPONS_H

#define ESF_WEAPON_MELEE               1
#define ESF_WEAPON_SWORD               2
#define ESF_WEAPON_KIBLAST             3
#define ESF_WEAPON_GENERIC_BEAM        4
#define ESF_WEAPON_GALLIT_GUN          5
#define ESF_WEAPON_KAMEHAMEHA          6
#define ESF_WEAPON_DESTRUCTO_DISC      7
#define ESF_WEAPON_SOLARFLARE          8
#define ESF_WEAPON_EYELASER            9
#define ESF_WEAPON_FRIEZADISC         10
#define ESF_WEAPON_SPECIALBEAM_CANNON 11
#define ESF_WEAPON_SPIRIT_BOMB        12
#define ESF_WEAPON_BIGBANG            13
#define ESF_WEAPON_FINGERLASER        14
#define ESF_WEAPON_FINAL_FLASH        15
#define ESF_WEAPON_MASENKO            16
#define ESF_WEAPON_DEATHBALL          17
#define ESF_WEAPON_BURNINGATTACK      18
#define ESF_WEAPON_SCATTERBEAM        19
#define ESF_WEAPON_CANDY              20
#define ESF_WEAPON_SCATTERSHOT        21
#define ESF_WEAPON_POWERBEAM          22
#define ESF_WEAPON_MOUTHBLAST         23
#define ESF_WEAPON_FINISHING_BUSTER   24
#define ESF_WEAPON_SENSU              25
#define ESF_WEAPON_DRAGONBALL         26
#define ESF_WEAPON_UNKNOWN1           27
#define ESF_WEAPON_SHIELD_ATTACK      28
#define ESF_WEAPON_REGENERATION       29
#define ESF_WEAPON_RENZOKU            30
#define ESF_WEAPON_UNKNOWN2           31
#define ESF_WEAPON_KAMETORPEDO        32
#define ESF_WEAPON_TELEKINESIS		  33

// sbot weapons
#define SBOT_WEAPON_LASER1			  64

#define LASER1_KICOST				  110 // for each 0.1 sec
#define HEALTH_BEAM_SPEED_DECREASE	  2 // for each million pl difference
#define ABSORB_DAMAGE_VALUE			  0.25f // damage drain for each million pl
#define ABSORB_PL_GAIN				  950 // pl gain * (BotPl / 1000000)

typedef struct
{
   char szClassname[64];
   int  iAmmo1;     // ammo index for primary ammo
   int  iAmmo1Max;  // max primary ammo
   int  iAmmo2;     // ammo index for secondary ammo
   int  iAmmo2Max;  // max secondary ammo
   int  iSlot;      // HUD slot (0 based)
   int  iPosition;  // slot position
   int  iId;        // weapon ID
   int  iFlags;     // flags???
} bot_weapon_t;


#endif // BOT_WEAPONS_H

