#ifndef DRAGONBALL_H
#define DRAGONBALL_H

//#define usedbcode
int SearchNextWPForDBSpot(bot_t *pBot);
bool SearchDB(bot_t *pBot);
void DecideNextDBSpots(void);
bool DBSAreGathered(void);
bool DBSAreActive(void);
bool CheckDBS(bot_t *pBot);
void InitCustomGatherDBSpots(void);
void SaveCustomGatherDBSpots(void);
void PlaceNewDBGatherSpot(edict_t *pEdict);
void DeleteDBGatherSpot(edict_t *pEdict);
short GetNearestDBSpotIndex(edict_t *pEdict, float flRadius);
short GetRandomDBSpotIndex(short Team);
void DrawDBGatherSpots(void);

#define DB_SPOT_VERSION 1.0f
#define MAX_CUSTOM_DB_GATHER_SPOTS 10

struct SDBFileHeader
{
	float flVersion;
	char szMapName[32];
};

struct SDBSpot
{
	Vector origin;
	bool Deleted;

	SDBSpot(void) : origin(g_vecZero), Deleted(true) {};
};

extern bool DrawDBSpots;

#endif // DRAGONBALL_H